// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(h) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e) {
        return e.split("");
    }
    function Ee(e, n) {
        return n.indexOf(e) >= 0;
    }
    function Se(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function K(e, n) {
        if (n <= 0) return "";
        if (n == 1) return e;
        var t = K(e, n >> 1);
        t += t;
        return n & 1 ? t + e : t;
    }
    function n(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function r(e, n) {
        this.message = e;
        this.defs = n;
    }
    r.prototype = Object.create(Error.prototype);
    r.prototype.constructor = r;
    r.prototype.name = "DefaultsError";
    n(r);
    function ue(e, n, t) {
        if (t) for (var i in e) {
            if (Pe(e, i) && !Pe(n, i)) throw new r("`" + i + "` is not a supported option", n);
        }
        for (var i in e) {
            if (Pe(e, i)) n[i] = e[i];
        }
        return n;
    }
    function t(e, n) {
        var t = 0;
        for (var i in n) if (Pe(n, i)) {
            e[i] = n[i];
            t++;
        }
        return t;
    }
    function Te() {}
    function De() {
        return false;
    }
    function Oe() {
        return true;
    }
    function Ae() {
        return this;
    }
    function ze() {
        return null;
    }
    var $e = function() {
        function e(e, n) {
            var t = [];
            for (var i = 0; i < e.length; i++) {
                var r = n(e[i], i);
                if (r === a) continue;
                if (r instanceof o) {
                    t.push.apply(t, r.v);
                } else {
                    t.push(r);
                }
            }
            return t;
        }
        e.is_op = function(e) {
            return e === a || e instanceof o;
        };
        e.splice = function(e) {
            return new o(e);
        };
        var a = e.skip = {};
        function o(e) {
            this.v = e;
        }
        return e;
    }();
    function Me(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function je(e, i) {
        return e.replace(/\{([^}]+)\}/g, function(e, n) {
            var t = i[n];
            return t instanceof Ie ? t.print_to_string() : t;
        });
    }
    function Fe(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function qe(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function Ce(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function Ne() {
        this._values = Object.create(null);
        this._size = 0;
    }
    Ne.prototype = {
        set: function(e, n) {
            if (!this.has(e)) ++this._size;
            this._values["$" + e] = n;
            return this;
        },
        add: function(e, n) {
            if (this.has(e)) {
                this.get(e).push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return this._values["$" + e];
        },
        del: function(e) {
            if (this.has(e)) {
                --this._size;
                delete this._values["$" + e];
            }
            return this;
        },
        has: function(e) {
            return "$" + e in this._values;
        },
        all: function(e) {
            for (var n in this._values) if (!e(this._values[n], n.substr(1))) return false;
            return true;
        },
        each: function(e) {
            for (var n in this._values) e(this._values[n], n.substr(1));
        },
        size: function() {
            return this._size;
        },
        map: function(e) {
            var n = [];
            for (var t in this._values) n.push(e(this._values[t], t.substr(1)));
            return n;
        },
        clone: function() {
            var e = new Ne();
            for (var n in this._values) e._values[n] = this._values[n];
            e._size = this._size;
            return e;
        },
        toObject: function() {
            return this._values;
        }
    };
    Ne.fromObject = function(e) {
        var n = new Ne();
        n._size = t(n._values, e);
        return n;
    };
    function Pe(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function He(e, n) {
        var t = e.parent(-1);
        for (var i = 0, r; r = e.parent(i++); t = r) {
            if (r instanceof cn) {
                return n && r.value === t;
            } else if (r instanceof Wn) {
                if (r.left === t) continue;
            } else if (r.TYPE == "Call") {
                if (r.expression === t) continue;
            } else if (r instanceof Jn) {
                if (r.condition === t) continue;
            } else if (r instanceof In) {
                if (r.expression === t) continue;
            } else if (r instanceof Hn) {
                if (r.expressions[0] === t) continue;
            } else if (r instanceof Re) {
                return r.body === t;
            } else if (r instanceof Vn) {
                if (r.expression === t) continue;
            }
            return false;
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function i(e, n, t, i) {
        if (typeof i === "undefined") i = Ie;
        n = n ? n.split(/\s+/) : [];
        var r = n;
        if (i && i.PROPS) n = n.concat(i.PROPS);
        var a = [ "return function AST_", e, "(props){", "if(props){" ];
        n.forEach(function(e) {
            a.push("this.", e, "=props.", e, ";");
        });
        var o = i && new i();
        if (o && o.initialize || t && t.initialize) a.push("this.initialize();");
        a.push("}}");
        var s = new Function(a.join(""))();
        if (o) {
            s.prototype = o;
            s.BASE = i;
        }
        if (i) i.SUBCLASSES.push(s);
        s.prototype.CTOR = s;
        s.PROPS = n || null;
        s.SELF_PROPS = r;
        s.SUBCLASSES = [];
        if (e) {
            s.prototype.TYPE = s.TYPE = e;
        }
        if (t) for (var f in t) if (Pe(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.prototype[f] = t[f];
            }
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        if (typeof h !== "undefined") {
            h["AST_" + e] = s;
        }
        return s;
    }
    var Q = i("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var Ie = i("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new Ct(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: Te,
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        },
        validate_ast: function() {
            var n = {};
            this.walk(new zt(function(e) {
                if (e.validate_visited === n) {
                    throw new Error(je("cannot reuse {type} from [{file}:{line},{col}]", {
                        type: "AST_" + e.TYPE,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    }));
                }
                e.validate_visited = n;
            }));
        }
    }, null);
    (Ie.log_function = function(n, e) {
        if (!n) {
            Ie.info = Ie.warn = Te;
            return;
        }
        var t = Object.create(null);
        Ie.info = e ? function(e, n) {
            i("INFO: " + je(e, n));
        } : Te;
        Ie.warn = function(e, n) {
            i("WARN: " + je(e, n));
        };
        function i(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var a = [];
    Ie.enable_validation = function() {
        Ie.disable_validation();
        (function e(n) {
            var i = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = i.call(this, e, n);
                if (t instanceof Ie) {
                    t.validate();
                } else if (!(t === null || n && $e.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            a.push(function() {
                n.prototype.transform = i;
            });
            n.SUBCLASSES.forEach(e);
        })(this);
    };
    Ie.disable_validation = function() {
        var e;
        while (e = a.pop()) e();
    };
    var Re = i("Statement", null, {
        $documentation: "Base class of all statements"
    });
    var Ue = i("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, Re);
    var Be = i("Directive", "value quote", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)",
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Re);
    var Ye = i("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, Re);
    function o(e, n) {
        if (!(e[n] instanceof Ie)) throw new Error(n + " must be AST_Node");
        if (e[n] instanceof St) throw new Error(n + " cannot be AST_Hole");
        if (e[n] instanceof Bn) throw new Error(n + " cannot be AST_Spread");
        if (e[n] instanceof Re && !un(e[n])) {
            throw new Error(n + " cannot be AST_Statement");
        }
    }
    var Le = i("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            o(this, "body");
        }
    }, Re);
    var Ve = i("BlockScope", "enclosed functions make_def parent_scope variables", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            functions: "[Object/S] like `variables`, but only lists function declarations",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            variables: "[Object/S] a map of name -> SymbolDef for all variables/functions defined in this scope"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            if (this.functions) n.functions = this.functions.clone();
            if (this.variables) n.variables = this.variables.clone();
            return n;
        },
        pinned: function() {
            return this.resolve().pinned();
        },
        resolve: function() {
            return this.parent_scope.resolve();
        },
        _validate: function() {
            if (this.parent_scope == null) return;
            if (!(this.parent_scope instanceof Ve)) throw new Error("parent_scope must be AST_BlockScope");
            if (!(this.resolve() instanceof an)) throw new Error("must be contained within AST_Scope");
        }
    }, Re);
    function We(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var Je = i("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                We(n, e);
            });
        },
        _validate: function() {
            this.body.forEach(function(e) {
                if (!(e instanceof Re)) throw new Error("body must be AST_Statement[]");
                if (un(e)) throw new Error("body cannot contain AST_Function");
            });
        }
    }, Ve);
    var Ge = i("BlockStatement", null, {
        $documentation: "A block statement"
    }, Je);
    var T = i("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (!(this.body instanceof Re)) throw new Error("body must be AST_Statement");
            if (un(this.body)) throw new Error("body cannot be AST_Function");
        }
    }, Ve);
    var Xe = i("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var i = this.label;
                n.walk(new zt(function(e) {
                    if (e instanceof wn) {
                        if (!e.label || e.label.thedef !== i) return;
                        e.label.thedef = t;
                        t.references.push(e);
                        return true;
                    }
                    if (e instanceof an) return true;
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof ce)) throw new Error("label must be AST_Label");
        }
    }, T);
    var Ke = i("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it."
    }, T);
    var Qe = i("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _validate: function() {
            o(this, "condition");
        }
    }, Ke);
    var Ze = i("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, Qe);
    var en = i("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, Qe);
    var nn = i("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof Ie)) throw new Error("init must be AST_Node");
                if (this.init instanceof Re && !(this.init instanceof Mn || un(this.init))) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) o(this, "condition");
            if (this.step != null) o(this, "step");
        }
    }, Ke);
    var tn = i("ForIn", "init object", {
        $documentation: "A `for ... in` statement",
        $propdoc: {
            init: "[AST_Node] the `for/in` initialization code",
            object: "[AST_Node] the object that we're looping through"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init instanceof Mn) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else {
                f(this.init, function(e) {
                    if (!(e instanceof In || e instanceof _t)) {
                        throw new Error("init must be assignable: " + e.TYPE);
                    }
                });
            }
            o(this, "object");
        }
    }, Ke);
    var rn = i("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            o(this, "expression");
        }
    }, T);
    var an = i("Scope", "uses_eval uses_with", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement"
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        resolve: Ae
    }, Je);
    var on = i("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Object/S] a map of name -> SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return qt([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new Ct(function(e) {
                if (e instanceof Be && e.value == "$ORIG") {
                    return $e.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return qt([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new Ct(function(e) {
                if (e instanceof Be && e.value == "$ORIG") {
                    return $e.splice(t);
                }
            }));
        }
    }, an);
    var sn = i("Lambda", "argnames length_read uses_arguments", {
        $documentation: "Base class for functions",
        $propdoc: {
            argnames: "[(AST_Destructured|AST_SymbolFunarg)*] array of function arguments and/or destructured literals",
            uses_arguments: "[boolean/S] tells whether this function accesses the arguments array"
        },
        each_argname: function(n) {
            var t = new zt(function(e) {
                if (e instanceof et) {
                    e.value.walk(t);
                    return true;
                }
                if (e instanceof pt) n(e);
            });
            this.argnames.forEach(function(e) {
                e.walk(t);
            });
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                We(e, n);
            });
        },
        _validate: function() {
            this.argnames.forEach(function(e) {
                f(e, function(e) {
                    if (!(e instanceof pt)) throw new Error("argnames must be AST_SymbolFunarg[]");
                });
            });
        }
    }, an);
    var fn = i("Accessor", null, {
        $documentation: "A getter/setter function",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, sn);
    function un(e) {
        return e instanceof cn || e instanceof pn || e instanceof dn;
    }
    var cn = i("Arrow", "inlined value", {
        $documentation: "An arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.value) {
                    e.value.walk(n);
                } else {
                    We(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                o(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, sn);
    function ln(e) {
        return e instanceof vn || e instanceof pn;
    }
    var pn = i("AsyncFunction", "inlined name", {
        $documentation: "An asynchronous function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof ht)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, sn);
    var dn = i("Function", "inlined name", {
        $documentation: "A function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof ht)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, sn);
    function hn(e) {
        return e instanceof vn || e instanceof _n;
    }
    var vn = i("AsyncDefun", "inlined name", {
        $documentation: "An asynchronous function definition",
        $propdoc: {
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (!(this.name instanceof dt)) throw new Error("name must be AST_SymbolDefun");
        }
    }, sn);
    var _n = i("Defun", "inlined name", {
        $documentation: "A function definition",
        $propdoc: {
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (!(this.name instanceof dt)) throw new Error("name must be AST_SymbolDefun");
        }
    }, sn);
    var mn = i("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)"
    }, Re);
    var gn = i("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        }
    }, mn);
    var bn = i("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) o(this, "value");
        }
    }, gn);
    var yn = i("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            o(this, "value");
        }
    }, gn);
    var wn = i("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.label != null) {
                if (!(this.label instanceof le)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, mn);
    var xn = i("Break", null, {
        $documentation: "A `break` statement"
    }, wn);
    var kn = i("Continue", null, {
        $documentation: "A `continue` statement"
    }, wn);
    var En = i("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            o(this, "condition");
            if (this.alternative != null) {
                if (!(this.alternative instanceof Re)) throw new Error("alternative must be AST_Statement");
                if (un(this.alternative)) throw new error("alternative cannot be AST_Function");
            }
        }
    }, T);
    var Sn = i("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                We(n, e);
            });
        },
        _validate: function() {
            o(this, "expression");
            this.body.forEach(function(e) {
                if (!(e instanceof Tn)) throw new Error("body must be AST_SwitchBranch[]");
            });
        }
    }, Je);
    var Tn = i("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches"
    }, Je);
    var Dn = i("Default", null, {
        $documentation: "A `default` switch branch"
    }, Tn);
    var On = i("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                We(n, e);
            });
        },
        _validate: function() {
            o(this, "expression");
        }
    }, Tn);
    var An = i("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                We(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof zn)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof $n)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, Je);
    var zn = i("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[(AST_Destructured|AST_SymbolCatch)?] symbol for the exception, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.argname) n.argname.walk(e);
                We(n, e);
            });
        },
        _validate: function() {
            if (this.argname != null) f(this.argname, function(e) {
                if (!(e instanceof vt)) throw new Error("argname must be AST_SymbolCatch");
            });
        }
    }, Je);
    var $n = i("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, Je);
    var Mn = i("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.definitions.length < 1) throw new Error("must have at least one definition");
        }
    }, Re);
    var jn = i("Const", null, {
        $documentation: "A `const` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Cn)) throw new Error("definitions must be AST_VarDef[]");
                f(e.name, function(e) {
                    if (!(e instanceof ut)) throw new Error("name must be AST_SymbolConst");
                });
                if (e.value != null) o(e, "value");
            });
        }
    }, Mn);
    var Fn = i("Let", null, {
        $documentation: "A `let` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Cn)) throw new Error("definitions must be AST_VarDef[]");
                f(e.name, function(e) {
                    if (!(e instanceof ct)) throw new Error("name must be AST_SymbolLet");
                });
                if (e.value != null) o(e, "value");
            });
        }
    }, Mn);
    var qn = i("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Cn)) throw new Error("definitions must be AST_VarDef[]");
                f(e.name, function(e) {
                    if (!(e instanceof lt)) throw new Error("name must be AST_SymbolVar");
                });
                if (e.value != null) o(e, "value");
            });
        }
    }, Mn);
    var Cn = i("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        }
    });
    function s(e, n, t, i) {
        e[n].forEach(function(e) {
            if (!(e instanceof Ie)) throw new Error(n + " must be AST_Node[]");
            if (!i && e instanceof St) throw new Error(n + " cannot be AST_Hole");
            if (!t && e instanceof Bn) throw new Error(n + " cannot be AST_Spread");
            if (e instanceof Re && !un(e)) {
                throw new Error(n + " cannot contain AST_Statement");
            }
        });
    }
    var Nn = i("Call", "expression args pure", {
        $documentation: "A function call expression",
        $propdoc: {
            expression: "[AST_Node] expression to invoke as function",
            args: "[AST_Node*] array of arguments"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            o(this, "expression");
            s(this, "args", true);
        }
    });
    var Pn = i("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties"
    }, Nn);
    var Hn = i("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            s(this, "expressions");
        }
    });
    var In = i("PropAccess", "expression property", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node"
        },
        getProperty: function() {
            var e = this.property;
            if (e instanceof gt) {
                return e.value;
            }
            if (e instanceof Ln && e.operator == "void" && e.expression instanceof gt) {
                return;
            }
            return e;
        },
        _validate: function() {
            o(this, "expression");
        }
    });
    var Rn = i("Dot", null, {
        $documentation: "A dotted property access expression",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, In);
    var Un = i("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            o(this, "property");
        }
    }, In);
    var Bn = i("Spread", "expression", {
        $documentation: "Spread expression in array/object literals or function calls",
        $propdoc: {
            expression: "[AST_Node] expression to be expanded"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            o(this, "expression");
        }
    });
    var Yn = i("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.operator != "string") throw new Error("operator must be string");
            o(this, "expression");
        }
    });
    var Ln = i("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, Yn);
    var Vn = i("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, Yn);
    var Wn = i("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            o(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            o(this, "right");
        }
    });
    var Jn = i("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            o(this, "condition");
            o(this, "consequent");
            o(this, "alternative");
        }
    });
    var Gn = i("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
            if (this.left instanceof Qn) {
                if (this.operator != "=") throw new Error("invalid destructuring operator: " + this.operator);
                f(this.left, function(e) {
                    if (!(e instanceof In || e instanceof _t)) {
                        throw new Error("left must be assignable: " + e.TYPE);
                    }
                });
            }
        }
    }, Wn);
    var Xn = i("Await", "expression", {
        $documentation: "An await expression",
        $propdoc: {
            expression: "[AST_Node] expression with Promise to resolve on"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            o(this, "expression");
        }
    });
    var Kn = i("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            s(this, "elements", true, true);
        }
    });
    var Qn = i("Destructured", null, {
        $documentation: "Base class for destructured literal"
    });
    function f(e, n) {
        if (e instanceof Zn) return e.elements.forEach(function(e) {
            if (!(e instanceof St)) f(e, n);
        });
        if (e instanceof nt) return e.properties.forEach(function(e) {
            f(e.value, n);
        });
        n(e);
    }
    var Zn = i("DestructuredArray", "elements", {
        $documentation: "A destructured array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        }
    }, Qn);
    var et = i("DestructuredKeyVal", "key value", {
        $documentation: "A key: value destructured property",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof Ie) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof Ie)) throw new Error("key must be string or AST_Node");
                o(this, "key");
            }
            o(this, "value");
        }
    });
    var nt = i("DestructuredObject", "properties", {
        $documentation: "A destructured object literal",
        $propdoc: {
            properties: "[AST_DestructuredKeyVal*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof et)) throw new Error("properties must be AST_DestructuredKeyVal[]");
            });
        }
    }, Qn);
    var tt = i("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[(AST_ObjectProperty|AST_Spread)*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof it || e instanceof Bn)) {
                    throw new Error("properties must contain AST_ObjectProperty and/or AST_Spread only");
                }
            });
        }
    });
    var it = i("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof Ie) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof Ie)) throw new Error("key must be string or AST_Node");
                o(this, "key");
            }
            if (!(this.value instanceof Ie)) throw new Error("value must be AST_Node");
        }
    });
    var rt = i("ObjectKeyVal", null, {
        $documentation: "A key: value object property",
        _validate: function() {
            o(this, "value");
        }
    }, it);
    var at = i("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.value instanceof fn)) throw new Error("value must be AST_Accessor");
        }
    }, it);
    var ot = i("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.value instanceof fn)) throw new Error("value must be AST_Accessor");
        }
    }, it);
    var st = i("Symbol", "scope name thedef", {
        $documentation: "Base class for all symbols",
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        _validate: function() {
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var ft = i("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, st);
    var ut = i("SymbolConst", null, {
        $documentation: "Symbol defining a constant"
    }, ft);
    var ct = i("SymbolLet", null, {
        $documentation: "Symbol defining a lexical-scoped variable"
    }, ft);
    var lt = i("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, ft);
    var pt = i("SymbolFunarg", null, {
        $documentation: "Symbol naming a function argument"
    }, lt);
    var dt = i("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, ft);
    var ht = i("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, ft);
    var vt = i("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, ft);
    var ce = i("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, st);
    var _t = i("SymbolRef", "fixed in_arg", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, st);
    var le = i("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, st);
    var mt = i("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.name !== "this") throw new Error('name must be "this"');
        }
    }, st);
    var gt = i("Constant", null, {
        $documentation: "Base class for all constants"
    });
    var bt = i("String", "value quote", {
        $documentation: "A string literal",
        $propdoc: {
            value: "[string] the contents of this string",
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, gt);
    var yt = i("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
        }
    }, gt);
    var wt = i("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, gt);
    var v = i("Atom", null, {
        $documentation: "Base class for atoms"
    }, gt);
    var xt = i("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, v);
    var kt = i("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, v);
    var Et = i("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, v);
    var St = i("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, v);
    var Tt = i("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, v);
    var Dt = i("Boolean", null, {
        $documentation: "Base class for booleans"
    }, v);
    var Ot = i("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, Dt);
    var At = i("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, Dt);
    function zt(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    zt.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || Te);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof sn) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof Be && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            if (this.stack.pop() instanceof sn) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof e) return i;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof an) {
                for (var i = 0; i < t.body.length; ++i) {
                    var r = t.body[i];
                    if (!(r instanceof Be)) break;
                    if (r.value == e) return r;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof Xe && i.label.name == e.label.name) return i.body;
            } else for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof Ke || e instanceof xn && i instanceof Sn) return i;
            }
        },
        in_boolean_context: function() {
            var e = this.self();
            for (var n = 0, t; t = this.parent(n); n++) {
                if (t instanceof Jn && t.condition === e || t instanceof Qe && t.condition === e || t instanceof nn && t.condition === e || t instanceof En && t.condition === e || t instanceof bn && t.in_bool || t instanceof Hn && t.tail_node() !== e || t instanceof Le || t instanceof Ln && t.operator == "!" && t.expression === e) {
                    return true;
                }
                if (t instanceof Wn && (t.operator == "&&" || t.operator == "||") || t instanceof Jn || t.tail_node() === e) {
                    e = t;
                } else if (t instanceof bn) {
                    for (var i, r = t; i = this.parent(++n); r = i) {
                        if (i.TYPE == "Call") {
                            if (!(r instanceof sn) || r.name) return false;
                        } else if (r instanceof sn) {
                            return false;
                        }
                    }
                } else {
                    return false;
                }
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var pe = "break case catch const continue debugger default delete do else finally for function if in instanceof let new return switch throw try typeof var void while with";
    var M = "false null true";
    var D = [ "await abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized this throws transient volatile yield", M, pe ].join(" ");
    var j = "return new delete throw else case";
    pe = qe(pe);
    D = qe(D);
    j = qe(j);
    M = qe(M);
    var u = /^0b([01]+)$/i;
    var c = /^0x([0-9a-f]+)$/i;
    var l = /^0o?([0-7]+)$/i;
    var F = qe([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", ">>=", "<<=", ">>>=", "|=", "^=", "&=", "&&", "||" ]);
    var q = "\n\r\u2028\u2029";
    var C = "+-*&%=<>!?|~^";
    var N = "[{(,;:";
    var P = N + ")}]";
    var H = q + "  \t\f\v​             　\ufeff";
    var I = qe(e("./'\"" + C + P + H));
    q = qe(e(q));
    C = qe(e(C));
    N = qe(e(N));
    P = qe(e(P));
    H = qe(e(H));
    function Z(e) {
        return e >= 55296 && e <= 56319;
    }
    function ee(e) {
        return e >= 56320 && e <= 57343;
    }
    function R(e) {
        return e >= 48 && e <= 57;
    }
    function ne(e) {
        return !I[e];
    }
    function $t(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function U(e) {
        var n;
        if (n = u.exec(e)) return parseInt(n[1], 2);
        if (n = c.exec(e)) return parseInt(n[1], 16);
        if (n = l.exec(e)) return parseInt(n[1], 8);
        var t = parseFloat(e);
        if (t == e) return t;
    }
    function Mt(e, n, t, i, r) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = i;
        this.pos = r;
    }
    Mt.prototype = Object.create(Error.prototype);
    Mt.prototype.constructor = Mt;
    Mt.prototype.name = "SyntaxError";
    n(Mt);
    function de(e, n, t, i, r) {
        throw new Mt(e, n, t, i, r);
    }
    function he(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var B = {};
    function ve(r, a, o, s) {
        var f = {
            text: r,
            filename: a,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: []
        };
        var u = false;
        function c() {
            return f.text.charAt(f.pos);
        }
        function l(e, n) {
            var t = f.text.charAt(f.pos++);
            if (e && !t) throw B;
            if (q[t]) {
                f.col = 0;
                f.line++;
                if (!n) f.newline_before = true;
                if (t == "\r" && c() == "\n") {
                    f.pos++;
                    t = "\n";
                }
            } else {
                f.col++;
            }
            return t;
        }
        function p(e) {
            while (e-- > 0) l();
        }
        function d(e) {
            return f.text.substr(f.pos, e.length) == e;
        }
        function h() {
            var e = f.text;
            for (var n = f.pos; n < f.text.length; ++n) {
                if (q[e[n]]) return n;
            }
            return -1;
        }
        function i(e, n) {
            var t = f.text.indexOf(e, f.pos);
            if (n && t == -1) throw B;
            return t;
        }
        function v() {
            f.tokline = f.line;
            f.tokcol = f.col;
            f.tokpos = f.pos;
        }
        function _(e, n, t) {
            f.regex_allowed = e == "operator" && !jt[n] || e == "keyword" && j[n] || e == "punc" && N[n];
            if (e == "punc" && n == ".") u = true; else if (!t) u = false;
            var i = {
                type: e,
                value: n,
                line: f.tokline,
                col: f.tokcol,
                pos: f.tokpos,
                endline: f.line,
                endcol: f.col,
                endpos: f.pos,
                nlb: f.newline_before,
                file: a
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                i.raw = r.substring(i.pos, i.endpos);
            }
            if (!t) {
                i.comments_before = f.comments_before;
                i.comments_after = f.comments_before = [];
            }
            f.newline_before = false;
            return new Q(i);
        }
        function m() {
            while (H[c()]) l();
        }
        function t(e) {
            var n = "", t, i = 0;
            while ((t = c()) && e(t, i++)) n += l();
            return n;
        }
        function g(e) {
            de(e, a, f.tokline, f.tokcol, f.tokpos);
        }
        function b(i) {
            var r = false, a = false, o = false, s = i == ".";
            var e = t(function(e, n) {
                var t = e.charCodeAt(0);
                switch (t) {
                  case 120:
                  case 88:
                    return o ? false : o = true;

                  case 101:
                  case 69:
                    return o ? true : r ? false : r = a = true;

                  case 45:
                    return a || n == 0 && !i;

                  case 43:
                    return a;

                  case a = false, 46:
                    return !s && !o && !r ? s = true : false;
                }
                return R(t) || /[_0-9a-fo]/i.test(e);
            });
            if (i) e = i + e;
            if (/^0[0-7_]+$/.test(e)) {
                if ($.has_directive("use strict")) g("Legacy octal literals are not allowed in strict mode");
            } else {
                e = e.replace(o ? /([1-9a-f]|.0)_(?=[0-9a-f])/gi : /([1-9]|.0)_(?=[0-9])/gi, "$1");
            }
            var n = U(e);
            if (!isNaN(n)) return _("num", n);
            g("Invalid syntax: " + e);
        }
        function y(e) {
            var n = l(true, e);
            switch (n.charCodeAt(0)) {
              case 110:
                return "\n";

              case 114:
                return "\r";

              case 116:
                return "\t";

              case 98:
                return "\b";

              case 118:
                return "\v";

              case 102:
                return "\f";

              case 120:
                return String.fromCharCode(x(2));

              case 117:
                if (c() != "{") return String.fromCharCode(x(4));
                l();
                var t = 0;
                do {
                    var i = parseInt(l(true), 16);
                    if (isNaN(i)) g("Invalid hex-character pattern in string");
                    t = t * 16 + i;
                } while (c() != "}");
                l();
                if (t < 65536) return String.fromCharCode(t);
                if (t > 1114111) g("Invalid character code: " + t);
                return String.fromCharCode((t >> 10) + 55232) + String.fromCharCode((t & 1023) + 56320);

              case 13:
                if (c() == "\n") l(true, e);

              case 10:
                return "";
            }
            if (n >= "0" && n <= "7") return w(n);
            return n;
        }
        function w(e) {
            var n = c();
            if (n >= "0" && n <= "7") {
                e += l(true);
                if (e[0] <= "3" && (n = c()) >= "0" && n <= "7") e += l(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && $.has_directive("use strict")) g("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        function x(e) {
            var n = 0;
            for (;e > 0; --e) {
                var t = parseInt(l(true), 16);
                if (isNaN(t)) g("Invalid hex-character pattern in string");
                n = n << 4 | t;
            }
            return n;
        }
        var k = n("Unterminated string constant", function(e) {
            var n = l(), t = "";
            for (;;) {
                var i = l(true, true);
                if (i == "\\") i = y(true); else if (q[i]) g("Unterminated string constant"); else if (i == n) break;
                t += i;
            }
            var r = _("string", t);
            r.quote = e;
            return r;
        });
        function E(e) {
            var n = f.regex_allowed;
            var t = h(), i;
            if (t == -1) {
                i = f.text.substr(f.pos);
                f.pos = f.text.length;
            } else {
                i = f.text.substring(f.pos, t);
                f.pos = t;
            }
            f.col = f.tokcol + (f.pos - f.tokpos);
            f.comments_before.push(_(e, i, true));
            f.regex_allowed = n;
            return $;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = f.regex_allowed;
            var n = i("*/", true);
            var t = f.text.substring(f.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            p(t.length + 2);
            f.comments_before.push(_("comment2", t, true));
            f.regex_allowed = e;
            return $;
        });
        function S() {
            var e = false, n = "", t, i = false, r;
            while (t = c()) {
                if (!e) {
                    if (t == "\\") i = e = true, l(); else if (ne(t)) n += l(); else break;
                } else {
                    if (t != "u") g("Expecting UnicodeEscapeSequence -- uXXXX");
                    t = y();
                    if (!ne(t)) g("Unicode char: " + t.charCodeAt(0) + " is not valid in identifier");
                    n += t;
                    e = false;
                }
            }
            if (pe[n] && i) {
                r = n.charCodeAt(0).toString(16).toUpperCase();
                n = "\\u" + "0000".substr(r.length) + r + n.slice(1);
            }
            return n;
        }
        var T = n("Unterminated regular expression", function(e) {
            var n = false, t, i = false;
            while (t = l(true)) if (q[t]) {
                g("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                i = true;
                e += t;
            } else if (t == "]" && i) {
                i = false;
                e += t;
            } else if (t == "/" && !i) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var r = S();
            try {
                var a = new RegExp(e, r);
                a.raw_source = e;
                return _("regexp", a);
            } catch (e) {
                g(e.message);
            }
        });
        function D(e) {
            function t(e) {
                if (!c()) return e;
                var n = e + c();
                if (F[n]) {
                    l();
                    return t(n);
                } else {
                    return e;
                }
            }
            return _("operator", t(e || l()));
        }
        function O() {
            l();
            switch (c()) {
              case "/":
                l();
                return E("comment1");

              case "*":
                l();
                return e();
            }
            return f.regex_allowed ? T("") : D("/");
        }
        function A() {
            l();
            var e = c();
            if (e == ".") {
                var n = ".";
                do {
                    n += ".";
                    l();
                } while (c() == ".");
                return _("operator", n);
            }
            return R(e.charCodeAt(0)) ? b(".") : _("punc", ".");
        }
        function z() {
            var e = S();
            if (u) return _("name", e);
            return M[e] ? _("atom", e) : !pe[e] ? _("name", e) : F[e] ? _("operator", e) : _("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === B) g(n); else throw e;
                }
            };
        }
        function $(e) {
            if (e != null) return T(e);
            if (s && f.pos == 0 && d("#!")) {
                v();
                p(2);
                E("comment5");
            }
            for (;;) {
                m();
                v();
                if (o) {
                    if (d("\x3c!--")) {
                        p(4);
                        E("comment3");
                        continue;
                    }
                    if (d("--\x3e") && f.newline_before) {
                        p(3);
                        E("comment4");
                        continue;
                    }
                }
                var n = c();
                if (!n) return _("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return k(n);

                  case 46:
                    return A();

                  case 47:
                    var i = O();
                    if (i === $) continue;
                    return i;
                }
                if (R(t)) return b();
                if (P[n]) return _("punc", l());
                if (d("=>")) return _("punc", l() + l());
                if (C[n]) return D();
                if (t == 92 || !I[n]) return z();
                break;
            }
            g("Unexpected character '" + n + "'");
        }
        $.context = function(e) {
            if (e) f = e;
            return f;
        };
        $.add_directive = function(e) {
            f.directive_stack[f.directive_stack.length - 1].push(e);
            if (f.directives[e]) f.directives[e]++; else f.directives[e] = 1;
        };
        $.push_directives_stack = function() {
            f.directive_stack.push([]);
        };
        $.pop_directives_stack = function() {
            var e = f.directive_stack.pop();
            for (var n = e.length; --n >= 0; ) {
                f.directives[e[n]]--;
            }
        };
        $.has_directive = function(e) {
            return f.directives[e] > 0;
        };
        return $;
    }
    var _e = qe("typeof void delete -- ++ ! ~ - +");
    var jt = qe("-- ++");
    var me = qe("= += -= /= *= %= >>= <<= >>>= |= ^= &=");
    var Ft = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var i = e[t++];
            for (var r = 0; r < i.length; r++) {
                n[i[r]] = t;
            }
        }
        return n;
    }([ [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ] ], {});
    var ge = qe("atom num regexp string");
    function qt(e, f) {
        f = ue(f, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var u = {
            input: typeof e == "string" ? ve(e, f.filename, f.html5_comments, f.shebang) : e,
            in_async: false,
            in_directives: true,
            in_funarg: -1,
            in_function: 0,
            in_loop: 0,
            labels: [],
            peeked: null,
            prev: null,
            token: null
        };
        u.token = p();
        function c(e, n) {
            return he(u.token, e, n);
        }
        function l() {
            return u.peeked || (u.peeked = u.input());
        }
        function p() {
            u.prev = u.token;
            if (u.peeked) {
                u.token = u.peeked;
                u.peeked = null;
            } else {
                u.token = u.input();
            }
            u.in_directives = u.in_directives && (u.token.type == "string" || c("punc", ";"));
            return u.token;
        }
        function d() {
            return u.prev;
        }
        function o(e, n, t, i) {
            var r = u.input.context();
            de(e, r.filename, n != null ? n : r.tokline, t != null ? t : r.tokcol, i != null ? i : r.tokpos);
        }
        function r(e, n) {
            o(n, e.line, e.col);
        }
        function t(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function h(e) {
            if (e == null) e = u.token;
            r(e, "Unexpected token: " + t(e.type, e.value));
        }
        function a(e, n) {
            if (c(e, n)) return p();
            r(u.token, "Unexpected token: " + t(u.token.type, u.token.value) + ", expected: " + t(e, n));
        }
        function v(e) {
            return a("punc", e);
        }
        function s(e) {
            return e.nlb || !Ce(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function _() {
            return !f.strict && (c("eof") || c("punc", "}") || s(u.token));
        }
        function m(e) {
            if (c("punc", ";")) p(); else if (!e && !_()) a("punc", ";");
        }
        function g() {
            v("(");
            var e = se();
            v(")");
            return e;
        }
        function n(i) {
            return function() {
                var e = u.token;
                var n = i.apply(null, arguments);
                var t = d();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function b() {
            if (c("operator", "/") || c("operator", "/=")) {
                u.peeked = null;
                u.token = u.input(u.token.value.substr(1));
            }
        }
        var y = n(function() {
            b();
            switch (u.token.type) {
              case "string":
                var e = u.in_directives;
                var n = se();
                if (e) {
                    if (n instanceof bt) {
                        var t = n.start.raw.slice(1, -1);
                        u.input.add_directive(t);
                        n.value = t;
                    } else {
                        u.in_directives = e = false;
                    }
                }
                m();
                return e ? new Be(n) : new Le({
                    body: n
                });

              case "num":
              case "regexp":
              case "operator":
              case "atom":
                return x();

              case "name":
                switch (u.token.value) {
                  case "async":
                    if (he(l(), "keyword", "function")) {
                        p();
                        p();
                        return O(vn);
                    }

                  case "await":
                    if (u.in_async) return x();

                  default:
                    return he(l(), "punc", ":") ? w() : x();
                }

              case "punc":
                switch (u.token.value) {
                  case "{":
                    return new Ge({
                        start: u.token,
                        body: z(),
                        end: d()
                    });

                  case "[":
                  case "(":
                    return x();

                  case ";":
                    u.in_directives = false;
                    p();
                    return new Ye();

                  default:
                    h();
                }

              case "keyword":
                switch (u.token.value) {
                  case "break":
                    p();
                    return k(xn);

                  case "const":
                    p();
                    var i = F();
                    m();
                    return i;

                  case "continue":
                    p();
                    return k(kn);

                  case "debugger":
                    p();
                    m();
                    return new Ue();

                  case "do":
                    p();
                    var n = fe(y);
                    a("keyword", "while");
                    var r = g();
                    m(true);
                    return new Ze({
                        body: n,
                        condition: r
                    });

                  case "while":
                    p();
                    return new en({
                        condition: g(),
                        body: fe(y)
                    });

                  case "for":
                    p();
                    return E();

                  case "function":
                    p();
                    return O(_n);

                  case "if":
                    p();
                    return A();

                  case "let":
                    p();
                    var i = q();
                    m();
                    return i;

                  case "return":
                    if (u.in_function == 0 && !f.bare_returns) o("'return' outside of function");
                    p();
                    var t = null;
                    if (c("punc", ";")) {
                        p();
                    } else if (!_()) {
                        t = se();
                        m();
                    }
                    return new bn({
                        value: t
                    });

                  case "switch":
                    p();
                    return new Sn({
                        expression: g(),
                        body: fe($)
                    });

                  case "throw":
                    p();
                    if (s(u.token)) o("Illegal newline after 'throw'");
                    var t = se();
                    m();
                    return new yn({
                        value: t
                    });

                  case "try":
                    p();
                    return M();

                  case "var":
                    p();
                    var i = C();
                    m();
                    return i;

                  case "with":
                    if (u.input.has_directive("use strict")) {
                        o("Strict mode may not include a with statement");
                    }
                    p();
                    return new rn({
                        expression: g(),
                        body: y()
                    });
                }
            }
            h();
        });
        function w() {
            var n = J(ce);
            if (!Ce(u.labels, function(e) {
                return e.name != n.name;
            })) {
                o("Label " + n.name + " defined twice");
            }
            v(":");
            u.labels.push(n);
            var e = y();
            u.labels.pop();
            if (!(e instanceof Ke)) {
                n.references.forEach(function(e) {
                    if (e instanceof kn) {
                        r(e.label.start, "Continue label `" + n.name + "` must refer to IterationStatement");
                    }
                });
            }
            return new Xe({
                body: e,
                label: n
            });
        }
        function x() {
            var e = se();
            m();
            return new Le({
                body: e
            });
        }
        function k(e) {
            var n = null, t;
            if (!_()) {
                n = J(le, true);
            }
            if (n != null) {
                t = Se(function(e) {
                    return e.name == n.name;
                }, u.labels);
                if (!t) r(n.start, "Undefined label " + n.name);
                n.thedef = t;
            } else if (u.in_loop == 0) o(e.TYPE + " not inside a loop or switch");
            m();
            var i = new e({
                label: n
            });
            if (t) t.references.push(i);
            return i;
        }
        function E() {
            v("(");
            var e = null;
            if (!c("punc", ";")) {
                e = c("keyword", "const") ? (p(), F(true)) : c("keyword", "let") ? (p(), q(true)) : c("keyword", "var") ? (p(), 
                C(true)) : se(true);
                if (c("operator", "in")) {
                    if (e instanceof Mn) {
                        if (e.definitions.length > 1) {
                            r(e.start, "Only one variable declaration allowed in for..in loop");
                        }
                    } else if (!(re(e) || (e = ae(e)) instanceof Qn)) {
                        r(e.start, "Invalid left-hand side in for..in loop");
                    }
                    p();
                    return S(e);
                }
            }
            return i(e);
        }
        function i(e) {
            v(";");
            var n = c("punc", ";") ? null : se();
            v(";");
            var t = c("punc", ")") ? null : se();
            v(")");
            return new nn({
                init: e,
                condition: n,
                step: t,
                body: fe(y)
            });
        }
        function S(e) {
            var n = se();
            v(")");
            return new tn({
                init: e,
                object: n,
                body: fe(y)
            });
        }
        function T(e) {
            if (e instanceof Kn) return new Zn({
                start: e.start,
                elements: e.elements.map(function(e) {
                    return e instanceof St ? e : T(e);
                }),
                end: e.end
            });
            if (e instanceof tt) return new nt({
                start: e.start,
                properties: e.properties.map(function(e) {
                    if (!(e instanceof rt)) r(e.start, "Invalid destructuring assignment");
                    return new et({
                        start: e.start,
                        key: e.key,
                        value: T(e.value),
                        end: e.end
                    });
                }),
                end: e.end
            });
            if (e instanceof _t) return new pt(e);
            r(e.start, "Invalid arrow parameter");
        }
        function D(e, n) {
            var t = u.in_async;
            u.in_async = false;
            var i = u.in_funarg;
            u.in_funarg = u.in_function;
            var r = e.map(T);
            u.in_funarg = i;
            v("=>");
            var a, o;
            var s = u.in_loop;
            var f = u.labels;
            ++u.in_function;
            u.in_directives = true;
            u.input.push_directives_stack();
            u.in_loop = 0;
            u.labels = [];
            if (c("punc", "{")) {
                a = z();
                o = null;
                if (u.input.has_directive("use strict")) {
                    r.forEach(W);
                }
            } else {
                a = [];
                o = oe();
            }
            u.input.pop_directives_stack();
            --u.in_function;
            u.in_loop = s;
            u.labels = f;
            u.in_async = t;
            return new cn({
                start: n,
                argnames: r,
                body: a,
                value: o,
                end: d()
            });
        }
        var O = function(e) {
            var n = u.in_async;
            var t;
            if (e === vn) {
                t = J(dt);
                u.in_async = true;
            } else if (e === _n) {
                t = J(dt);
                u.in_async = false;
            } else {
                u.in_async = e === pn;
                t = J(ht, true);
            }
            if (t && e !== fn && !(t instanceof ft)) h(d());
            v("(");
            var i = u.in_funarg;
            u.in_funarg = u.in_function;
            var r = I(")", !f.strict, false, function() {
                return G(pt);
            });
            u.in_funarg = i;
            var a = u.in_loop;
            var o = u.labels;
            ++u.in_function;
            u.in_directives = true;
            u.input.push_directives_stack();
            u.in_loop = 0;
            u.labels = [];
            var s = z();
            if (u.input.has_directive("use strict")) {
                if (t) W(t);
                r.forEach(W);
            }
            u.input.pop_directives_stack();
            --u.in_function;
            u.in_loop = a;
            u.labels = o;
            u.in_async = n;
            return new e({
                name: t,
                argnames: r,
                body: s
            });
        };
        function A() {
            var e = g(), n = y(), t = null;
            if (c("keyword", "else")) {
                p();
                t = y();
            }
            return new En({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function z() {
            v("{");
            var e = [];
            while (!c("punc", "}")) {
                if (c("eof")) a("punc", "}");
                e.push(y());
            }
            p();
            return e;
        }
        function $() {
            v("{");
            var e = [], n, t, i, r;
            while (!c("punc", "}")) {
                if (c("eof")) a("punc", "}");
                if (c("keyword", "case")) {
                    if (n) n.end = d();
                    t = [];
                    n = new On({
                        start: (r = u.token, p(), r),
                        expression: se(),
                        body: t
                    });
                    e.push(n);
                    v(":");
                } else if (c("keyword", "default")) {
                    if (n) n.end = d();
                    if (i) o("More than one default clause in switch statement");
                    t = [];
                    n = new Dn({
                        start: (r = u.token, p(), v(":"), r),
                        body: t
                    });
                    e.push(n);
                    i = n;
                } else {
                    if (!t) h();
                    t.push(y());
                }
            }
            if (n) n.end = d();
            p();
            return e;
        }
        function M() {
            var e = z(), n = null, t = null;
            if (c("keyword", "catch")) {
                var i = u.token;
                p();
                var r = null;
                if (c("punc", "(")) {
                    p();
                    r = G(vt);
                    v(")");
                }
                n = new zn({
                    start: i,
                    argname: r,
                    body: z(),
                    end: d()
                });
            }
            if (c("keyword", "finally")) {
                var i = u.token;
                p();
                t = new $n({
                    start: i,
                    body: z(),
                    end: d()
                });
            }
            if (!n && !t) o("Missing catch/finally blocks");
            return new An({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function j(e, n) {
            var t = [];
            for (;;) {
                var i = u.token;
                var r = G(e);
                var a = null;
                if (c("operator", "=")) {
                    p();
                    a = oe(n);
                } else if (!n && (e === ut || r instanceof Qn)) {
                    o("Missing initializer in declaration");
                }
                t.push(new Cn({
                    start: i,
                    name: r,
                    value: a,
                    end: d()
                }));
                if (!c("punc", ",")) break;
                p();
            }
            return t;
        }
        var F = function(e) {
            return new jn({
                start: d(),
                definitions: j(ut, e),
                end: d()
            });
        };
        var q = function(e) {
            return new Fn({
                start: d(),
                definitions: j(ct, e),
                end: d()
            });
        };
        var C = function(e) {
            return new qn({
                start: d(),
                definitions: j(lt, e),
                end: d()
            });
        };
        var N = function(e) {
            var n = u.token;
            a("operator", "new");
            var t = H(false), i;
            if (c("punc", "(")) {
                p();
                i = I(")", !f.strict);
            } else {
                i = [];
            }
            var r = new Pn({
                start: n,
                expression: t,
                args: i,
                end: d()
            });
            X(r);
            return K(r, e);
        };
        function P() {
            var e = u.token, n;
            switch (e.type) {
              case "num":
                n = new yt({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "string":
                n = new bt({
                    start: e,
                    end: e,
                    value: e.value,
                    quote: e.quote
                });
                break;

              case "regexp":
                n = new wt({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "atom":
                switch (e.value) {
                  case "false":
                    n = new Ot({
                        start: e,
                        end: e
                    });
                    break;

                  case "true":
                    n = new At({
                        start: e,
                        end: e
                    });
                    break;

                  case "null":
                    n = new xt({
                        start: e,
                        end: e
                    });
                    break;
                }
                break;
            }
            p();
            return n;
        }
        var H = function(e) {
            if (c("operator", "new")) {
                return N(e);
            }
            var n = u.token;
            if (c("punc")) {
                switch (n.value) {
                  case "(":
                    p();
                    if (c("punc", ")")) {
                        p();
                        return D([], n);
                    }
                    var t = se(false, true);
                    var i = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = i;
                    if (i == 0 && n.comments_before.length > 0) {
                        var r = n.comments_before[0];
                        if (!r.nlb) {
                            r.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    v(")");
                    var a = d();
                    a.comments_before = t.end.comments_before;
                    [].push.apply(t.end.comments_after, a.comments_after);
                    a.comments_after.length = 0;
                    a.comments_after = t.end.comments_after;
                    t.end = a;
                    if (t instanceof Nn) X(t);
                    if (c("punc", "=>")) return D(t instanceof Hn ? t.expressions : [ t ], n);
                    return K(t, e);

                  case "[":
                    return K(R(), e);

                  case "{":
                    return K(B(), e);
                }
                h();
            }
            var o;
            if (c("name", "async") && he(l(), "keyword", "function")) {
                p();
                o = pn;
            } else if (c("keyword", "function")) {
                o = dn;
            }
            if (o) {
                p();
                var s = O(o);
                s.start = n;
                s.end = d();
                return K(s, e);
            }
            if (c("name")) {
                var f = V(_t, n);
                p();
                return c("punc", "=>") ? D([ f ], n) : K(f, e);
            }
            if (ge[u.token.type]) {
                return K(P(), e);
            }
            h();
        };
        function I(e, n, t, i) {
            if (!i) i = oe;
            var r = true, a = [];
            while (!c("punc", e)) {
                if (r) r = false; else v(",");
                if (n && c("punc", e)) break;
                if (t && c("punc", ",")) {
                    a.push(new St({
                        start: u.token,
                        end: u.token
                    }));
                } else if (i === oe && c("operator", "...")) {
                    a.push(new Bn({
                        start: u.token,
                        expression: (p(), i()),
                        end: d()
                    }));
                } else {
                    a.push(i());
                }
            }
            p();
            return a;
        }
        var R = n(function() {
            v("[");
            return new Kn({
                elements: I("]", !f.strict, true)
            });
        });
        var U = n(function() {
            return O(fn);
        });
        var B = n(function() {
            v("{");
            var e = true, n = [];
            while (!c("punc", "}")) {
                if (e) e = false; else v(",");
                if (!f.strict && c("punc", "}")) break;
                var t = u.token;
                if (c("operator", "...")) {
                    p();
                    n.push(new Bn({
                        start: t,
                        expression: oe(),
                        end: d()
                    }));
                    continue;
                }
                var i = Y();
                if (c("punc", "(")) {
                    var r = u.token;
                    var a = O(dn);
                    a.start = r;
                    a.end = d();
                    n.push(new rt({
                        start: t,
                        key: i,
                        value: a,
                        end: d()
                    }));
                    continue;
                }
                if (c("punc", ":")) {
                    p();
                    n.push(new rt({
                        start: t,
                        key: i,
                        value: oe(),
                        end: d()
                    }));
                    continue;
                }
                if (c("punc", ",") || c("punc", "}")) {
                    n.push(new rt({
                        start: t,
                        key: i,
                        value: V(_t, t),
                        end: d()
                    }));
                    continue;
                }
                if (t.type == "name") switch (i) {
                  case "async":
                    i = Y();
                    var r = u.token;
                    var a = O(pn);
                    a.start = r;
                    a.end = d();
                    n.push(new rt({
                        start: t,
                        key: i,
                        value: a,
                        end: d()
                    }));
                    continue;

                  case "get":
                    n.push(new ot({
                        start: t,
                        key: Y(),
                        value: U(),
                        end: d()
                    }));
                    continue;

                  case "set":
                    n.push(new at({
                        start: t,
                        key: Y(),
                        value: U(),
                        end: d()
                    }));
                    continue;
                }
                h();
            }
            p();
            return new tt({
                properties: n
            });
        });
        function Y() {
            var e = u.token;
            switch (e.type) {
              case "operator":
                if (!pe[e.value]) h();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                p();
                return "" + e.value;

              case "punc":
                v("[");
                var n = oe();
                v("]");
                return n;

              default:
                h();
            }
        }
        function L() {
            if (!c("name")) a("name");
            var e = u.token.value;
            p();
            return e;
        }
        function V(e, n) {
            var t = n.value;
            if (t === "await" && u.in_async) h(n);
            return new (t === "this" ? mt : e)({
                name: "" + t,
                start: n,
                end: n
            });
        }
        function W(e) {
            if (e.name == "arguments" || e.name == "eval") r(e.start, "Unexpected " + e.name + " in strict mode");
        }
        function J(e, n) {
            if (!c("name")) {
                if (!n) o("Name expected");
                return null;
            }
            var t = V(e, u.token);
            if (u.input.has_directive("use strict") && t instanceof ft) {
                W(t);
            }
            p();
            return t;
        }
        function G(e) {
            var n = u.token;
            if (c("punc", "[")) {
                p();
                return new Zn({
                    start: n,
                    elements: I("]", !f.strict, true, function() {
                        return G(e);
                    }),
                    end: d()
                });
            }
            if (c("punc", "{")) {
                p();
                var t = true, i = [];
                while (!c("punc", "}")) {
                    if (t) t = false; else v(",");
                    if (!f.strict && c("punc", "}")) break;
                    var r = u.token;
                    if (c("punc", "[") || he(l(), "punc", ":")) {
                        var a = Y();
                        v(":");
                        i.push(new et({
                            start: r,
                            key: a,
                            value: G(e),
                            end: d()
                        }));
                        continue;
                    }
                    i.push(new et({
                        start: r,
                        key: r.value,
                        value: J(e),
                        end: d()
                    }));
                }
                p();
                return new nt({
                    start: n,
                    properties: i,
                    end: d()
                });
            }
            return J(e);
        }
        function X(e) {
            var n = e.start;
            var t = n.comments_before;
            var i = Pe(n, "comments_before_length") ? n.comments_before_length : t.length;
            while (--i >= 0) {
                var r = t[i];
                if (/[@#]__PURE__/.test(r.value)) {
                    e.pure = r;
                    break;
                }
            }
        }
        var K = function(e, n) {
            var t = e.start;
            if (c("punc", ".")) {
                p();
                return K(new Rn({
                    start: t,
                    expression: e,
                    property: L(),
                    end: d()
                }), n);
            }
            if (c("punc", "[")) {
                p();
                var i = se();
                v("]");
                return K(new Un({
                    start: t,
                    expression: e,
                    property: i,
                    end: d()
                }), n);
            }
            if (n && c("punc", "(")) {
                p();
                var r = new Nn({
                    start: t,
                    expression: e,
                    args: I(")", !f.strict),
                    end: d()
                });
                X(r);
                return K(r, true);
            }
            return e;
        };
        function Q() {
            var e = u.token;
            if (c("operator") && _e[e.value]) {
                p();
                b();
                var n = Z(Ln, e, ee());
                n.start = e;
                n.end = d();
                return n;
            }
            var t = H(true);
            while (c("operator") && jt[u.token.value] && !s(u.token)) {
                t = Z(Vn, u.token, t);
                t.start = e;
                t.end = u.token;
                p();
            }
            return t;
        }
        function Z(e, n, t) {
            var i = n.value;
            switch (i) {
              case "++":
              case "--":
                if (!re(t)) r(n, "Invalid use of " + i + " operator");
                break;

              case "delete":
                if (t instanceof _t && u.input.has_directive("use strict")) r(t.start, "Calling delete on expression not allowed in strict mode");
                break;
            }
            return new e({
                operator: i,
                expression: t
            });
        }
        function ee() {
            var e = u.token;
            if (!(u.in_async && c("name", "await"))) return Q();
            if (u.in_funarg === u.in_function) o("Invalid use of await in function argument");
            u.input.context().regex_allowed = true;
            p();
            return new Xn({
                start: e,
                expression: ee(),
                end: d()
            });
        }
        var ne = function(e, n, t) {
            var i = c("operator") ? u.token.value : null;
            if (i == "in" && t) i = null;
            var r = i != null ? Ft[i] : null;
            if (r != null && r > n) {
                p();
                var a = ne(ee(), r, t);
                return ne(new Wn({
                    start: e.start,
                    left: e,
                    operator: i,
                    right: a,
                    end: a.end
                }), n, t);
            }
            return e;
        };
        function te(e) {
            return ne(ee(), 0, e);
        }
        var ie = function(e) {
            var n = u.token;
            var t = te(e);
            if (c("operator", "?")) {
                p();
                var i = oe();
                v(":");
                return new Jn({
                    start: n,
                    condition: t,
                    consequent: i,
                    alternative: oe(e),
                    end: d()
                });
            }
            return t;
        };
        function re(e) {
            return e instanceof In || e instanceof _t;
        }
        function ae(e) {
            if (e instanceof Kn) {
                var n = e.elements.map(ae);
                return Ce(n, function(e) {
                    return e instanceof Qn || e instanceof St || re(e);
                }) ? new Zn({
                    start: e.start,
                    elements: n,
                    end: e.end
                }) : e;
            }
            if (!(e instanceof tt)) return e;
            var t = [];
            for (var i = 0; i < e.properties.length; i++) {
                var r = e.properties[i];
                if (!(r instanceof rt)) return e;
                var a = ae(r.value);
                if (!(a instanceof Qn || re(a))) return e;
                t.push(new et({
                    start: r.start,
                    key: r.key,
                    value: a,
                    end: r.end
                }));
            }
            return new nt({
                start: e.start,
                properties: t,
                end: e.end
            });
        }
        function oe(e) {
            var n = u.token;
            var t = ie(e), i = u.token.value;
            if (c("operator") && me[i]) {
                if (re(t) || i == "=" && (t = ae(t)) instanceof Qn) {
                    p();
                    return new Gn({
                        start: n,
                        left: t,
                        operator: i,
                        right: oe(e),
                        end: d()
                    });
                }
                o("Invalid assignment");
            }
            return t;
        }
        function se(e, n) {
            var t = u.token;
            var i = [];
            while (true) {
                i.push(oe(e));
                if (!c("punc", ",")) break;
                p();
                if (n && c("punc", ")") && he(l(), "punc", "=>")) break;
            }
            return i.length == 1 ? i[0] : new Hn({
                start: t,
                expressions: i,
                end: d()
            });
        }
        function fe(e) {
            ++u.in_loop;
            var n = e();
            --u.in_loop;
            return n;
        }
        if (f.expression) {
            b();
            return se();
        }
        return function() {
            var e = u.token;
            var n = [];
            u.input.push_directives_stack();
            while (!c("eof")) n.push(y());
            u.input.pop_directives_stack();
            var t = d();
            var i = f.toplevel;
            if (i) {
                i.body = i.body.concat(n);
                i.end = t;
            } else {
                i = new on({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return i;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Ct(e, n) {
        zt.call(this);
        this.before = e;
        this.after = n;
    }
    Ct.prototype = new zt();
    (function(e) {
        function t(e, n) {
            return $e(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(Ie, Te);
        e(Xe, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(Le, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(Je, function(e, n) {
            e.body = t(e.body, n);
        });
        e(Ze, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(en, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(nn, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(tn, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(rn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(gn, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(wn, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(En, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(Sn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(On, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(An, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(zn, function(e, n) {
            if (e.argname) e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(Mn, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(Cn, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(sn, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            e.body = t(e.body, n);
        });
        e(cn, function(e, n) {
            e.argnames = t(e.argnames, n);
            if (e.value) {
                e.value = e.value.transform(n);
            } else {
                e.body = t(e.body, n);
            }
        });
        e(Nn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(Hn, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(Xn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Rn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Un, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(Bn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Yn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Wn, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(Jn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(Kn, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(Zn, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(et, function(e, n) {
            if (e.key instanceof Ie) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(nt, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(tt, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(it, function(e, n) {
            if (e.key instanceof Ie) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
    })(function(e, r) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, i;
            e.push(this);
            if (e.before) t = e.before(this, r, n);
            if (typeof t === "undefined") {
                t = this;
                r(t, e);
                if (e.after) {
                    i = e.after(t, n);
                    if (typeof i !== "undefined") t = i;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function d(e, n, t, i) {
        this.eliminated = 0;
        this.global = false;
        this.id = e;
        this.init = i;
        this.lambda = t instanceof ht;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.scope = n;
        this.undeclared = false;
    }
    d.prototype = {
        forEach: function(e) {
            this.orig.forEach(e);
            this.references.forEach(e);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t = this.redefined();
                if (t) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = g(this, e);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            var e = this.defun;
            if (!e) return;
            var n = this.name;
            var t = e.variables.get(n) || e instanceof on && e.globals.get(n) || this.orig[0] instanceof ut && Se(function(e) {
                return e.name == n;
            }, e.enclosed);
            if (t && t !== this) return t.redefined() || t;
        },
        unmangleable: function(e) {
            return this.global && !e.toplevel || this.undeclared || !e.eval && this.scope.pinned() || e.keep_fnames && (this.orig[0] instanceof ht || this.orig[0] instanceof dt);
        }
    };
    var Nt = qe("delete ++ --");
    on.DEFMETHOD("figure_out_scope", function(u) {
        u = ue(u, {
            cache: null,
            ie8: false
        });
        var c = this;
        var o = null;
        var t = 0;
        var s = c.parent_scope = null;
        var l = new zt(function(i, e) {
            if (hn(i)) {
                i.name.walk(l);
                r(function() {
                    i.argnames.forEach(function(e) {
                        e.walk(l);
                    });
                    We(i, l);
                });
                return true;
            }
            if (i instanceof Tn) {
                i.init_vars(s);
                e();
                return true;
            }
            if (i instanceof An) {
                r(function() {
                    We(i, l);
                });
                if (i.bcatch) i.bcatch.walk(l);
                if (i.bfinally) i.bfinally.walk(l);
                return true;
            }
            if (i instanceof rn) {
                var n = s;
                do {
                    n = n.resolve();
                    if (n.uses_with) break;
                    n.uses_with = true;
                } while (n = n.parent_scope);
                r(e);
                return true;
            }
            if (i instanceof Ve) {
                r(e);
                return true;
            }
            if (i instanceof st) {
                i.scope = s;
            }
            if (i instanceof ce) {
                i.thedef = i;
                i.references = [];
            }
            if (i instanceof vt) {
                s.def_variable(i).defun = o;
            } else if (i instanceof ut) {
                s.def_variable(i).defun = o;
            } else if (i instanceof dt) {
                o.def_function(i, l.parent());
                a(o, s);
            } else if (i instanceof pt) {
                o.def_variable(i);
                a(o, s);
            } else if (i instanceof ht) {
                var t = o.def_function(i, i.name == "arguments" ? undefined : o);
                if (u.ie8) t.defun = o.parent_scope.resolve();
            } else if (i instanceof ct) {
                s.def_variable(i);
            } else if (i instanceof lt) {
                o.def_variable(i, null);
                a(o, s);
            }
            function r(e) {
                i.init_vars(s);
                var n = o;
                var t = s;
                if (i instanceof an) o = i;
                s = i;
                e();
                s = t;
                o = n;
            }
            function a(e, n) {
                if (e === n) return;
                i.mark_enclosed(u);
                var t = n.find_variable(i.name);
                if (i.thedef === t) return;
                i.thedef = t;
                t.orig.push(i);
                i.mark_enclosed(u);
            }
        });
        c.make_def = function(e, n) {
            return new d(++t, this, e, n);
        };
        c.walk(l);
        c.globals = new Ne();
        var p = [];
        var l = new zt(function(e) {
            if (e instanceof zn) {
                if (!(e.argname instanceof Qn)) return;
                p.push(e);
                e.argname.walk(l);
                p.pop();
                We(e, l);
                return true;
            }
            if (e instanceof sn) {
                p.push(e);
                e.argnames.forEach(function(e) {
                    e.walk(l);
                });
                p.pop();
                if (e instanceof cn && e.value) {
                    e.value.walk(l);
                } else {
                    We(e, l);
                }
                return true;
            }
            if (e instanceof wn) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof vt) {
                var n = e.definition().redefined();
                if (n) for (var t = e.scope; t; t = t.parent_scope) {
                    Me(t.enclosed, n);
                    if (t === n.scope) break;
                }
                return true;
            }
            if (e instanceof ut) {
                var i = e.definition().redefined();
                if (i) i.const_redefs = true;
                return true;
            }
            if (e instanceof _t) {
                var r = e.name;
                var a = e.scope.find_variable(r);
                for (var o = p.length; o > 0 && a; ) {
                    o = p.lastIndexOf(a.scope, o - 1);
                    if (o < 0) break;
                    var s = a.orig[0];
                    if (s instanceof vt || s instanceof pt || s instanceof ht) {
                        e.in_arg = true;
                        break;
                    }
                    a = a.scope.parent_scope.find_variable(r);
                }
                if (!a) {
                    a = c.def_global(e);
                } else if (r == "arguments" && a.orig[0] instanceof pt && !(a.orig[1] instanceof pt) && !(a.scope instanceof cn)) {
                    var f = l.parent();
                    if (f instanceof Gn && f.left === e || f instanceof Yn && Nt[f.operator]) {
                        a.scope.uses_arguments = 3;
                    } else if (a.scope.uses_arguments < 2 && !(f instanceof In && f.expression === e)) {
                        a.scope.uses_arguments = 2;
                    } else if (!a.scope.uses_arguments) {
                        a.scope.uses_arguments = true;
                    }
                }
                if (r == "eval") {
                    var f = l.parent();
                    if (f.TYPE == "Call" && f.expression === e) {
                        var t = e.scope;
                        do {
                            t = t.resolve();
                            if (t.uses_eval) break;
                            t.uses_eval = true;
                        } while (t = t.parent_scope);
                    } else if (a.undeclared) {
                        c.uses_eval = true;
                    }
                }
                e.thedef = a;
                e.reference(u);
                return true;
            }
        });
        c.walk(l);
        if (u.ie8) c.walk(new zt(function(e) {
            if (e instanceof vt) {
                var n = e.thedef.defun;
                if (n.name instanceof ht && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                i(e, n);
                return true;
            }
            if (e instanceof ht) {
                var t = e.thedef;
                i(e, e.scope.parent_scope.resolve());
                if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function i(e, n) {
            var t = e.name;
            var i = e.thedef;
            if (!Ce(i.orig, function(e) {
                return !(e instanceof ut || e instanceof ct);
            })) return;
            var r = n.find_variable(t);
            if (r) {
                var a = r.redefined();
                if (a) r = a;
            } else {
                r = c.globals.get(t);
            }
            if (r) {
                r.orig.push(e);
            } else {
                r = n.def_variable(e);
            }
            i.defun = r.scope;
            i.forEach(function(e) {
                e.redef = true;
                e.thedef = r;
                e.reference(u);
            });
            if (i.lambda) r.lambda = true;
            if (r.undeclared) c.variables.set(t, r);
        }
    });
    on.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var i = this.make_def(e);
            i.undeclared = true;
            i.global = true;
            n.set(t, i);
            return i;
        }
    });
    function p(e, n) {
        e.enclosed = [];
        e.parent_scope = n;
        e.functions = new Ne();
        e.variables = new Ne();
        if (n) e.make_def = n.make_def;
    }
    function _(e, n) {
        p(e, n);
        e.uses_eval = false;
        e.uses_with = false;
    }
    Ve.DEFMETHOD("init_vars", function(e) {
        p(this, e);
    });
    an.DEFMETHOD("init_vars", function(e) {
        _(this, e);
    });
    cn.DEFMETHOD("init_vars", function(e) {
        _(this, e);
    });
    sn.DEFMETHOD("init_vars", function(e) {
        _(this, e);
        this.uses_arguments = false;
        this.def_variable(new pt({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
        return this;
    });
    st.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            Me(t.enclosed, n);
            if (e.keep_fnames) {
                t.functions.each(function(e) {
                    Me(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    st.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    Ve.DEFMETHOD("find_variable", function(e) {
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    Ve.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || hn(t.init)) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    Ve.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (un(t.init)) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    function m(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.cname = -1;
            e.cname_holes = [];
            e.names_in_use = t = Object.create(null);
            var i = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t[e.name] = true;
                if (e.global && i && i.has(e.name)) {
                    t[i.get(e.name)] = true;
                }
            });
        }
        return t;
    }
    function g(e, i) {
        var n = e.scope;
        var t = m(n, i);
        var r = n.cname_holes;
        var a = Object.create(null);
        var o = [ n ];
        e.forEach(function(e) {
            var n = e.scope;
            do {
                if (o.indexOf(n) < 0) {
                    for (var t in m(n, i)) {
                        a[t] = true;
                    }
                    o.push(n);
                } else break;
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < r.length; f++) {
            s = y(r[f]);
            if (a[s]) continue;
            r.splice(f, 1);
            t[s] = true;
            return s;
        }
        while (true) {
            s = y(++n.cname);
            if (t[s] || D[s] || i.reserved.has[s]) continue;
            if (!a[s]) break;
            r.push(n.cname);
        }
        t[s] = true;
        return s;
    }
    st.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    ce.DEFMETHOD("unmangleable", De);
    st.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    function b(e) {
        e = ue(e, {
            eval: false,
            ie8: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false,
            webkit: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        Me(e.reserved, "arguments");
        e.reserved.has = qe(e.reserved);
        return e;
    }
    on.DEFMETHOD("mangle_names", function(a) {
        a = b(a);
        var o = -1;
        if (a.cache && a.cache.props) {
            var n = m(this, a);
            a.cache.props.each(function(e) {
                n[e] = true;
            });
        }
        var s = [];
        var f = new zt(function(n, e) {
            if (n instanceof Xe) {
                var t = o;
                e();
                o = t;
                return true;
            }
            if (n instanceof Ve) {
                if (a.webkit && n instanceof Ke && n.init instanceof Fn) {
                    n.init.definitions.forEach(function(e) {
                        e.name.match_symbol(function(e) {
                            if (!(e instanceof ct)) return;
                            var n = e.definition();
                            var t = e.scope.parent_scope;
                            var i = t.def_variable(e);
                            e.thedef = n;
                            t.to_mangle.push(i);
                            n.redefined = function() {
                                return i;
                            };
                        });
                    }, true);
                }
                n.to_mangle = [];
                n.variables.each(function(e) {
                    if (!c(e)) n.to_mangle.push(e);
                });
                e();
                if (a.cache && n instanceof on) {
                    n.globals.each(u);
                }
                if (n instanceof _n && f.has_directive("use asm")) {
                    var i = new _t(n.name);
                    i.scope = n;
                    i.reference(a);
                }
                n.to_mangle.forEach(u);
                return true;
            }
            if (n instanceof ce) {
                var r;
                do {
                    r = y(++o);
                } while (D[r]);
                n.mangled_name = r;
                return true;
            }
        });
        this.walk(f);
        s.forEach(u);
        function u(e) {
            if (a.reserved.has[e.name]) return;
            e.mangle(a);
        }
        function c(n) {
            var e = n.orig[0];
            var t = n.redefined();
            if (!t) {
                if (!(e instanceof ut)) return false;
                var i = n.scope.resolve();
                if (n.scope === i) return false;
                t = i.def_variable(e);
                i.to_mangle.push(t);
            }
            s.push(n);
            n.references.forEach(r);
            if (e instanceof vt || e instanceof ut) r(e);
            return true;
            function r(e) {
                e.thedef = t;
                e.reference(a);
                e.thedef = n;
            }
        }
    });
    on.DEFMETHOD("find_colliding_names", function(t) {
        var i = t.cache && t.cache.props;
        var n = Object.create(D);
        t.reserved.forEach(r);
        this.globals.each(a);
        this.walk(new zt(function(e) {
            if (e instanceof Ve) e.variables.each(a);
        }));
        return n;
        function r(e) {
            n[e] = true;
        }
        function a(e) {
            var n = e.name;
            if (e.global && i && i.has(n)) n = i.get(n); else if (!e.unmangleable(t)) return;
            r(n);
        }
    });
    on.DEFMETHOD("expand_names", function(i) {
        y.reset();
        y.sort();
        i = b(i);
        var n = this.find_colliding_names(i);
        var t = 0;
        this.globals.each(a);
        this.walk(new zt(function(e) {
            if (e instanceof Ve) e.variables.each(a);
        }));
        function r() {
            var e;
            do {
                e = y(t++);
            } while (n[e]);
            return e;
        }
        function a(n) {
            if (n.global && i.cache) return;
            if (n.unmangleable(i)) return;
            if (i.reserved.has[n.name]) return;
            var e = n.redefined();
            var t = e ? e.rename || e.name : r();
            n.rename = t;
            n.forEach(function(e) {
                if (e.definition() === n) e.name = t;
            });
        }
    });
    Ie.DEFMETHOD("tail_node", Ae);
    Hn.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    on.DEFMETHOD("compute_char_frequency", function(e) {
        e = b(e);
        y.reset();
        var n = st.prototype.add_source_map;
        try {
            st.prototype.add_source_map = function() {
                if (!this.unmangleable(e)) y.consider(this.name, -1);
            };
            if (e.properties) {
                Rn.prototype.add_source_map = function() {
                    y.consider(this.property, -1);
                };
                Un.prototype.add_source_map = function() {
                    t(this.property);
                };
            }
            y.consider(this.print_to_string(), 1);
        } finally {
            st.prototype.add_source_map = n;
            delete Rn.prototype.add_source_map;
            delete Un.prototype.add_source_map;
        }
        y.sort();
        function t(e) {
            if (e instanceof bt) {
                y.consider(e.value, -1);
            } else if (e instanceof Jn) {
                t(e.consequent);
                t(e.alternative);
            } else if (e instanceof Hn) {
                t(e.tail_node());
            }
        }
    });
    var y = function() {
        var r = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var i = e[t];
                n.push(i);
                r[i] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var i, a;
        function o() {
            a = Object.create(r);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                a[e[t]] += n;
            }
        };
        function s(e, n) {
            return a[n] - a[e];
        }
        f.sort = function() {
            i = t.sort(s).concat(n.sort(s));
        };
        f.reset = o;
        o();
        function f(e) {
            var n = "", t = 54;
            e++;
            do {
                e--;
                n += i[e % t];
                e = Math.floor(e / t);
                t = 64;
            } while (e > 0);
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function te(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function Pt(f) {
        var e = !f;
        f = ue(f, {
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            galio: false,
            ie8: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            v8: false,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = De;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var t = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, t - 1), f.comments.substr(t + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = te;
            } else {
                u = Oe;
            }
        }
        var r = f.indent_start;
        var a = 0;
        var o = 1;
        var c = 0;
        var s = "";
        var l = f.ascii_only ? function(e, t) {
            if (t) e = e.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(e) {
                return "\\u{" + (e.charCodeAt(0) - 55232 << 10 | e.charCodeAt(1) - 56320).toString(16) + "}";
            });
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, i = 0; t < e.length; t++) {
                var r = e.charCodeAt(t);
                if (Z(r)) {
                    if (ee(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!ee(r)) {
                    continue;
                }
                n += e.slice(i, t) + "\\u" + r.toString(16);
                i = t + 1;
            }
            return i == 0 ? e : n + e.slice(i);
        };
        function i(t, e) {
            var i = 0, r = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++i;
                    return '"';

                  case "'":
                    ++r;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie8 ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            function n() {
                return "'" + t.replace(/\x27/g, "\\'") + "'";
            }
            function a() {
                return '"' + t.replace(/\x22/g, '\\"') + '"';
            }
            t = l(t);
            switch (f.quote_style) {
              case 1:
                return n();

              case 2:
                return a();

              case 3:
                return e == "'" ? n() : a();

              default:
                return i > r ? n() : a();
            }
        }
        function p(e, n) {
            var t = i(e, n);
            if (f.inline_script) {
                t = t.replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                t = t.replace(/\x3c!--/g, "\\x3c!--");
                t = t.replace(/--\x3e/g, "--\\x3e");
            }
            return t;
        }
        function d(e) {
            e = e.toString();
            e = l(e, true);
            return e;
        }
        var h = false;
        var v = 0;
        var _ = true;
        var m = false;
        var g = false;
        var b = false;
        var y = false;
        var w = -1;
        var x = "";
        var k, E, S = f.source_map && [];
        var T = S ? function(n, t) {
            S.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : Te;
        var D = S ? function() {
            S.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            S = [];
        } : Te;
        function O(e) {
            var n = s.lastIndexOf("\n");
            if (v < n) v = n;
            var t = s.slice(0, v);
            var i = s.slice(v);
            T(e, i.length - a);
            o += e;
            c += e;
            a = i.length;
            s = t;
            while (e--) s += "\n";
            s += i;
        }
        var A = f.max_line_len ? function() {
            if (_) {
                if (a > f.max_line_len) {
                    Ie.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (a > f.max_line_len) O(1);
            _ = true;
            D();
        } : Te;
        var z = qe("( [ + * / - , .");
        function $(e) {
            e = String(e);
            var n = e.charAt(0);
            if (b && n) {
                b = false;
                if (n != "\n") {
                    $("\n");
                    j();
                }
            }
            if (y && n) {
                y = false;
                if (!/[\s;})]/.test(n)) {
                    M();
                }
            }
            w = -1;
            var t = x.slice(-1);
            if (g) {
                g = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    if (f.semicolons || z[n]) {
                        s += ";";
                        a++;
                        c++;
                    } else {
                        A();
                        s += "\n";
                        c++;
                        o++;
                        a = 0;
                        if (/^\s+$/.test(e)) {
                            g = true;
                        }
                    }
                    if (!f.beautify) m = false;
                }
            }
            if (m) {
                if (ne(t) && (ne(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == x || e == "--" && x == "!" || e == "in" && t == "/" || x == "--" && n == ">") {
                    s += " ";
                    a++;
                    c++;
                }
                if (t != "<" || e != "!") m = false;
            }
            if (k) {
                S.push({
                    token: k,
                    name: E,
                    line: o,
                    col: a
                });
                k = false;
                if (_) D();
            }
            s += e;
            h = e.slice(-1) == "(";
            c += e.length;
            var i = e.split(/\r?\n/), r = i.length - 1;
            o += r;
            a += i[0].length;
            if (r > 0) {
                A();
                a = i[r].length;
            }
            x = e;
        }
        var M = f.beautify ? function() {
            $(" ");
        } : function() {
            m = true;
        };
        var j = f.beautify ? function(e) {
            $(K(" ", e ? r - (f.indent_level >> 1) : r));
        } : Te;
        var F = f.beautify ? function(e, n) {
            if (e === true) e = H();
            var t = r;
            r = e;
            var i = n();
            r = t;
            return i;
        } : function(e, n) {
            return n();
        };
        var q = f.max_line_len || f.preserve_line ? function() {
            A();
            v = s.length;
            _ = false;
        } : Te;
        var C = f.beautify ? function() {
            if (w < 0) return $("\n");
            if (s[w] != "\n") {
                s = s.slice(0, w) + "\n" + s.slice(w);
                c++;
                o++;
            }
            w++;
        } : q;
        var N = f.beautify ? function() {
            $(";");
        } : function() {
            g = true;
        };
        function P() {
            if (g) $(";");
            $(";");
        }
        function H() {
            return r + f.indent_level;
        }
        function I(e) {
            var n;
            $("{");
            C();
            F(H(), function() {
                n = e();
            });
            j();
            $("}");
            return n;
        }
        function R(e) {
            $("(");
            q();
            var n = e();
            q();
            $(")");
            return n;
        }
        function U(e) {
            $("[");
            q();
            var n = e();
            q();
            $("]");
            return n;
        }
        function B() {
            q();
            $(",");
            q();
            M();
        }
        function Y() {
            $(":");
            M();
        }
        var L = S ? function(e, n) {
            k = e;
            E = n;
        } : Te;
        function V() {
            if (!_) A();
            return s;
        }
        function W() {
            var e = s.lastIndexOf("\n");
            return /^ *$/.test(s.slice(e + 1));
        }
        function J(e) {
            var i = this;
            var r = e instanceof gn && e.value;
            var a = s(e);
            if (!a) a = [];
            if (r) {
                var o = new zt(function(e) {
                    var n = o.parent();
                    if (n instanceof gn || n instanceof Wn && n.left === e || n.TYPE == "Call" && n.expression === e || n instanceof Jn && n.condition === e || n instanceof Rn && n.expression === e || n instanceof Hn && n.expressions[0] === e || n instanceof Un && n.expression === e || n instanceof Vn) {
                        var t = s(e);
                        if (t) a = a.concat(t);
                    } else {
                        return true;
                    }
                });
                o.push(e);
                e.value.walk(o);
            }
            if (c == 0) {
                if (a.length > 0 && f.shebang && a[0].type == "comment5") {
                    $("#!" + a.shift().value + "\n");
                    j();
                }
                var n = f.preamble;
                if (n) {
                    $(n.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g, "\n"));
                }
            }
            a = a.filter(u, e);
            if (a.length == 0) return;
            var t = W();
            a.forEach(function(e, n) {
                if (!t) {
                    if (e.nlb) {
                        $("\n");
                        j();
                        t = true;
                    } else if (n > 0) {
                        M();
                    }
                }
                if (/comment[134]/.test(e.type)) {
                    $("//" + e.value.replace(/[@#]__PURE__/g, " ") + "\n");
                    j();
                    t = true;
                } else if (e.type == "comment2") {
                    $("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    t = false;
                }
            });
            if (!t) {
                if (e.start.nlb) {
                    $("\n");
                    j();
                } else {
                    M();
                }
            }
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!r) return;
                    e.start = n = new Q();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!r) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === i) return;
                t._dumped = i;
                return t;
            }
        }
        function G(e, t) {
            var n = this;
            var i = e.end;
            if (!i) return;
            var r = i[t ? "comments_before" : "comments_after"];
            if (!r || r._dumped === n) return;
            if (!(e instanceof Re || Ce(r, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            r._dumped = n;
            var a = s.length;
            r.filter(u, e).forEach(function(e, n) {
                y = false;
                if (b) {
                    $("\n");
                    j();
                    b = false;
                } else if (e.nlb && (n > 0 || !W())) {
                    $("\n");
                    j();
                } else if (n > 0 || !t) {
                    M();
                }
                if (/comment[134]/.test(e.type)) {
                    $("//" + e.value.replace(/[@#]__PURE__/g, " "));
                    b = true;
                } else if (e.type == "comment2") {
                    $("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    y = true;
                }
            });
            if (s.length > a) w = a;
        }
        var X = [];
        return {
            get: V,
            toString: V,
            indent: j,
            should_break: e ? Te : function() {
                return f.width && a - r >= f.width;
            },
            has_parens: function() {
                return h;
            },
            newline: C,
            print: $,
            space: M,
            comma: B,
            colon: Y,
            last: function() {
                return x;
            },
            semicolon: N,
            force_semicolon: P,
            to_utf8: l,
            print_name: function(e) {
                $(d(e));
            },
            print_string: function(e, n) {
                $(p(e, n));
            },
            next_indent: H,
            with_indent: F,
            with_block: I,
            with_parens: R,
            with_square: U,
            add_mapping: L,
            option: function(e) {
                return f[e];
            },
            prepend_comments: e ? Te : J,
            append_comments: e || u === De ? Te : G,
            line: function() {
                return o;
            },
            col: function() {
                return a;
            },
            pos: function() {
                return c;
            },
            push_node: function(e) {
                X.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = X.pop();
                if (e.start && e.start.line > o) {
                    O(e.start.line - o);
                }
            } : function() {
                X.pop();
            },
            parent: function(e) {
                return X[X.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var s = false;
        Ie.DEFMETHOD("print", function(e, n) {
            var t = this;
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(i);
            } else {
                i();
            }
            e.pop_node();
            function i() {
                e.prepend_comments(t);
                t.add_source_map(e);
                t._codegen(e);
                e.append_comments(t);
            }
        });
        Ie.DEFMETHOD("print_to_string", function(e) {
            var n = Pt(e);
            this.print(n);
            return n.get();
        });
        function n(e, n) {
            e.DEFMETHOD("needs_parens", n);
        }
        n(Ie, De);
        function t(e) {
            if (!e.has_parens() && He(e)) return true;
            if (e.option("webkit")) {
                var n = e.parent();
                if (n instanceof In && n.expression === this) return true;
            }
            if (e.option("wrap_iife")) {
                var n = e.parent();
                if (n instanceof Nn && n.expression === this) return true;
            }
        }
        n(pn, t);
        n(dn, t);
        function i(e) {
            return !e.has_parens() && He(e, true);
        }
        n(tt, i);
        n(Yn, function(e) {
            var n = e.parent();
            return (n instanceof Nn || n instanceof In) && n.expression === this;
        });
        n(Hn, function(e) {
            var n = e.parent();
            return n instanceof Kn || n instanceof cn && n.value === this || n instanceof Xn || n instanceof Wn || n instanceof Nn || n instanceof Jn || n instanceof et || n instanceof it || n instanceof In && n.expression === this || n instanceof Bn || n instanceof Yn || n instanceof Cn;
        });
        n(Wn, function(e) {
            var n = e.parent();
            if (n instanceof Xn) return true;
            if (n instanceof Wn) {
                var t = n.operator, i = Ft[t];
                var r = this.operator, a = Ft[r];
                return i > a || i == a && this === n.right;
            }
            if (n instanceof Nn) return n.expression === this;
            if (n instanceof In) return n.expression === this;
            if (n instanceof Yn) return true;
        });
        n(In, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof Pn && t.expression === n) {
                do {
                    n = n.expression;
                } while (n instanceof In);
                return n.TYPE == "Call";
            }
        });
        n(Nn, function(e) {
            var n = e.parent();
            if (n instanceof Pn) return n.expression === this;
            if (e.option("webkit")) {
                var t = e.parent(1);
                return this.expression instanceof dn && n instanceof In && n.expression === this && t instanceof Gn && t.left === n;
            }
        });
        n(Pn, function(e) {
            if (w(this, e)) return false;
            var n = e.parent();
            if (n instanceof Nn) return n.expression === this;
            return n instanceof In;
        });
        n(yt, function(e) {
            var n = e.parent();
            if (n instanceof In && n.expression === this) {
                var t = this.value;
                return t < 0 || e.option("galio") && /^0/.test(k(t));
            }
        });
        function r(e, n) {
            var t = n.parent();
            if (t instanceof Xn) return true;
            if (t instanceof Wn) return !(t instanceof Gn);
            if (t instanceof Nn) return t.expression === e;
            if (t instanceof Jn) return t.condition === e;
            if (t instanceof In) return t.expression === e;
            if (t instanceof Yn) return true;
        }
        n(cn, function(e) {
            return r(this, e);
        });
        n(Gn, function(e) {
            if (r(this, e)) return true;
            if (e.option("v8")) return this.left instanceof Qn;
            if (this.left instanceof nt) return i(e);
        });
        n(Jn, function(e) {
            return r(this, e);
        });
        n(Xn, function(e) {
            var n = e.parent();
            if (n instanceof Nn) return n.expression === this;
            if (n instanceof In) return n.expression === this;
        });
        e(Be, function(e) {
            var n = this.quote;
            var t = this.value;
            switch (e.option("quote_style")) {
              case 0:
              case 2:
                if (t.indexOf('"') == -1) n = '"';
                break;

              case 1:
                if (t.indexOf("'") == -1) n = "'";
                break;
            }
            e.print(n + t + n);
            e.semicolon();
        });
        e(Ue, function(e) {
            e.print("debugger");
            e.semicolon();
        });
        function a(e, t, i, n) {
            var r = e.length - 1;
            var a = n;
            var o = s;
            e.forEach(function(e, n) {
                if (a) {
                    if (e instanceof Be) {
                        if (e.value == "use asm") s = true;
                    } else if (!(e instanceof Ye)) {
                        if (e instanceof Le && e.body instanceof bt) {
                            i.force_semicolon();
                        }
                        a = false;
                    }
                }
                if (e instanceof Ye) return;
                i.indent();
                e.print(i);
                if (n == r && t) return;
                i.newline();
                if (t) i.newline();
            });
            s = o;
        }
        e(Re, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        e(on, function(e) {
            a(this.body, true, e, true);
            e.print("");
        });
        e(Xe, function(e) {
            this.label.print(e);
            e.colon();
            this.body.print(e);
        });
        e(Le, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        function o(e, n) {
            n.print("{");
            n.with_indent(n.next_indent(), function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function f(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    a(e.body, false, n, t);
                });
            } else o(e, n);
        }
        e(Ge, function(e) {
            f(this, e);
        });
        e(Ye, function(e) {
            e.semicolon();
        });
        e(Ze, function(e) {
            var n = this;
            e.print("do");
            e.space();
            E(n.body, e);
            e.space();
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.semicolon();
        });
        e(en, function(e) {
            var n = this;
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.space();
            y(n.body, e);
        });
        e(nn, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                if (n.init) {
                    if (n.init instanceof Mn) {
                        n.init.print(e);
                    } else {
                        v(n.init, e, true);
                    }
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.condition) {
                    n.condition.print(e);
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.step) {
                    n.step.print(e);
                }
            });
            e.space();
            y(n.body, e);
        });
        e(tn, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                n.init.print(e);
                e.space();
                e.print("in");
                e.space();
                n.object.print(e);
            });
            e.space();
            y(n.body, e);
        });
        e(rn, function(e) {
            var n = this;
            e.print("with");
            e.space();
            e.with_parens(function() {
                n.expression.print(e);
            });
            e.space();
            y(n.body, e);
        });
        e(cn, function(t) {
            var e = this;
            if (e.argnames.length == 1 && e.argnames[0] instanceof pt) {
                e.argnames[0].print(t);
            } else t.with_parens(function() {
                e.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
            t.space();
            t.print("=>");
            t.space();
            if (e.value) {
                e.value.print(t);
            } else {
                f(e, t, true);
            }
        });
        function u(e, t) {
            if (e.name) {
                t.space();
                e.name.print(t);
            }
            t.with_parens(function() {
                e.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
            t.space();
            f(e, t, true);
        }
        e(sn, function(e) {
            e.print("function");
            u(this, e);
        });
        function c(e) {
            e.print("async");
            e.space();
            e.print("function");
            u(this, e);
        }
        e(vn, c);
        e(pn, c);
        function l(t, i) {
            return function(e) {
                e.print(t);
                var n = this[i];
                if (n) {
                    e.space();
                    n.print(e);
                }
                e.semicolon();
            };
        }
        e(bn, l("return", "value"));
        e(yn, l("throw", "value"));
        e(xn, l("break", "label"));
        e(kn, l("continue", "label"));
        function p(e, n) {
            var t = e.body;
            if (n.option("braces") && !(t instanceof jn || t instanceof Fn) || n.option("ie8") && t instanceof Ze) return E(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof En) {
                    if (!t.alternative) {
                        E(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof T) {
                    t = t.body;
                } else break;
            }
            y(e.body, n);
        }
        e(En, function(e) {
            var n = this;
            e.print("if");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.space();
            if (n.alternative) {
                p(n, e);
                e.space();
                e.print("else");
                e.space();
                if (n.alternative instanceof En) n.alternative.print(e); else y(n.alternative, e);
            } else {
                y(n.body, e);
            }
        });
        e(Sn, function(t) {
            var e = this;
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var i = e.body.length - 1;
            if (i < 0) o(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < i && e.body.length > 0) t.newline();
                });
            });
        });
        function d(e, n) {
            n.newline();
            e.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        e(Dn, function(e) {
            e.print("default:");
            d(this, e);
        });
        e(On, function(e) {
            var n = this;
            e.print("case");
            e.space();
            n.expression.print(e);
            e.print(":");
            d(n, e);
        });
        e(An, function(e) {
            var n = this;
            e.print("try");
            e.space();
            f(n, e);
            if (n.bcatch) {
                e.space();
                n.bcatch.print(e);
            }
            if (n.bfinally) {
                e.space();
                n.bfinally.print(e);
            }
        });
        e(zn, function(e) {
            var n = this;
            e.print("catch");
            if (n.argname) {
                e.space();
                e.with_parens(function() {
                    n.argname.print(e);
                });
            }
            e.space();
            f(n, e);
        });
        e($n, function(e) {
            e.print("finally");
            e.space();
            f(this, e);
        });
        function h(i) {
            return function(t) {
                var e = this;
                t.print(i);
                t.space();
                e.definitions.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                var n = t.parent();
                if (n && n.init !== e || !(n instanceof nn || n instanceof tn)) t.semicolon();
            };
        }
        e(jn, h("const"));
        e(Fn, h("let"));
        e(qn, h("var"));
        function v(e, n, t) {
            var i = false;
            if (t) e.walk(new zt(function(e) {
                if (i) return true;
                if (e instanceof Wn && e.operator == "in") return i = true;
                if (e instanceof an && !(e instanceof cn && e.value)) return true;
            }));
            e.print(n, i);
        }
        e(Cn, function(e) {
            var n = this;
            n.name.print(e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                var t = e.parent(1);
                var i = t instanceof nn || t instanceof tn;
                v(n.value, e, i);
            }
        });
        function _(e, t) {
            if (e.expression instanceof Nn || e.expression instanceof sn) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        }
        e(Nn, function(e) {
            this.expression.print(e);
            _(this, e);
        });
        e(Pn, function(e) {
            var n = this;
            e.print("new");
            e.space();
            n.expression.print(e);
            if (w(n, e)) _(n, e);
        });
        e(Hn, function(t) {
            this.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(Rn, function(e) {
            var n = this;
            var t = n.expression;
            t.print(e);
            var i = n.property;
            if (e.option("ie8") && D[i]) {
                e.print("[");
                e.add_mapping(n.end);
                e.print_string(i);
                e.print("]");
            } else {
                if (t instanceof yt && t.value >= 0) {
                    if (!/[xa-f.)]/i.test(e.last())) {
                        e.print(".");
                    }
                }
                e.print(".");
                e.add_mapping(n.end);
                e.print_name(i);
            }
        });
        e(Un, function(e) {
            this.expression.print(e);
            e.print("[");
            this.property.print(e);
            e.print("]");
        });
        e(Bn, function(e) {
            e.print("...");
            this.expression.print(e);
        });
        e(Ln, function(e) {
            var n = this.operator;
            var t = this.expression;
            e.print(n);
            if (/^[a-z]/i.test(n) || /[+-]$/.test(n) && t instanceof Ln && /^[+-]/.test(t.operator)) {
                e.space();
            }
            t.print(e);
        });
        e(Vn, function(e) {
            this.expression.print(e);
            e.print(this.operator);
        });
        e(Wn, function(e) {
            var n = this;
            n.left.print(e);
            e.space();
            e.print(n.operator);
            e.space();
            n.right.print(e);
        });
        e(Jn, function(e) {
            var n = this;
            n.condition.print(e);
            e.space();
            e.print("?");
            e.space();
            n.consequent.print(e);
            e.space();
            e.colon();
            n.alternative.print(e);
        });
        e(Xn, function(e) {
            e.print("await");
            e.space();
            this.expression.print(e);
        });
        e(Kn, function(t) {
            var e = this.elements, i = e.length;
            t.with_square(i > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === i - 1 && e instanceof St) t.comma();
                });
                t.space();
            } : Te);
        });
        e(Zn, function(t) {
            var e = this.elements, i = e.length;
            t.with_square(i > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === i - 1 && e instanceof St) t.comma();
                });
                t.space();
            } : Te);
        });
        e(et, g);
        e(nt, function(t) {
            var e = this.properties;
            if (e.length > 0) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else o(this, t);
        });
        e(tt, function(t) {
            var e = this.properties;
            if (e.length > 0) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else o(this, t);
        });
        function m(e, n) {
            var t = e.key;
            if (t instanceof Ie) {
                n.with_square(function() {
                    t.print(n);
                });
            } else if (n.option("quote_keys")) {
                n.print_string(t);
            } else if ("" + +t == t && t >= 0) {
                n.print(k(t));
            } else {
                var i = e.start && e.start.quote;
                if (D[t] ? !n.option("ie8") : $t(t)) {
                    if (i && n.option("keep_quoted_props")) {
                        n.print_string(t, i);
                    } else {
                        n.print_name(t);
                    }
                } else {
                    n.print_string(t, i);
                }
            }
        }
        function g(e) {
            var n = this;
            m(n, e);
            e.colon();
            n.value.print(e);
        }
        e(rt, g);
        function b(t) {
            return function(e) {
                var n = this;
                e.print(t);
                e.space();
                m(n, e);
                u(n.value, e);
            };
        }
        e(ot, b("get"));
        e(at, b("set"));
        e(st, function(e) {
            var n = this.definition();
            e.print_name(n && n.mangled_name || this.name);
        });
        e(St, Te);
        e(mt, function(e) {
            e.print("this");
        });
        e(gt, function(e) {
            e.print(this.value);
        });
        e(bt, function(e) {
            e.print_string(this.value, this.quote);
        });
        e(yt, function(e) {
            var n = this.start;
            if (s && n && n.raw != null) {
                e.print(n.raw);
            } else {
                e.print(k(this.value));
            }
        });
        e(wt, function(e) {
            var n = this.value;
            var t = n.toString();
            var i = t.lastIndexOf("/");
            if (n.raw_source) {
                t = "/" + n.raw_source + t.slice(i);
            } else if (i == 1) {
                t = "/(?:)" + t.slice(i);
            } else if (t.indexOf("/", 1) < i) {
                t = "/" + t.slice(1, i).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + t.slice(i);
            }
            e.print(e.to_utf8(t).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
            var r = e.parent();
            if (r instanceof Wn && /^in/.test(r.operator) && r.left === this) e.print(" ");
        });
        function y(e, n) {
            if (n.option("braces") && !(e instanceof jn || e instanceof Fn)) {
                E(e, n);
            } else if (!e || e instanceof Ye) {
                n.force_semicolon();
            } else {
                e.print(n);
            }
        }
        function w(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function x(e) {
            var n = e[0], t = n.length;
            for (var i = 1; i < e.length; ++i) {
                if (e[i].length < t) {
                    n = e[i];
                    t = n.length;
                }
            }
            return n;
        }
        function k(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var i, r, a;
            if (i = /^\.0+/.exec(n)) {
                r = i[0].length;
                a = n.slice(r);
                t.push(a + "e-" + (a.length + r - 1));
            } else if (i = /0+$/.exec(n)) {
                r = i[0].length;
                t.push(n.slice(0, -r) + "e" + r);
            } else if (i = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(i[1] + i[2] + "e" + (i[3] - i[2].length));
            }
            return x(t);
        }
        function E(e, n) {
            if (!e || e instanceof Ye) n.print("{}"); else if (e instanceof Ge) e.print(n); else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function S(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        S([ Ie, Xe ], Te);
        S([ Kn, Ge, zn, gt, Ue, Mn, Qn, $n, mn, sn, Pn, tt, T, st, Sn, Tn, An ], function(e) {
            e.add_mapping(this.start);
        });
        S([ et, it ], function(e) {
            if (typeof this.key == "string") e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Ht(e, n) {
        if (!(this instanceof Ht)) return new Ht(e, n);
        Ct.call(this, this.before, this.after);
        this.options = ue(e, {
            arguments: !n,
            arrows: !n,
            assignments: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie8: false,
            if_return: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n || "strict",
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            merge_vars: !n,
            negate_iife: !n,
            objects: !n,
            passes: 1,
            properties: !n,
            pure_getters: !n && "strict",
            pure_funcs: null,
            reduce_funcs: !n,
            reduce_vars: !n,
            sequences: !n,
            side_effects: !n,
            spread: !n,
            strings: !n,
            switches: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            varify: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var i = this.options["global_defs"];
        if (typeof i == "object") for (var r in i) {
            if (/^@/.test(r) && Pe(i, r)) {
                i[r.slice(1)] = qt(i[r], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 3;
        var a = this.options["keep_fargs"];
        this.drop_fargs = a == "strict" ? function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var i = t.definition();
            if (i.direct_access) return false;
            var r = i.escaped;
            return r && r.depth != 1;
        } : a ? De : Oe;
        var o = this.options["pure_funcs"];
        if (typeof o == "function") {
            this.pure_funcs = o;
        } else if (typeof o == "string") {
            this.pure_funcs = function(e) {
                return o !== e.expression.print_to_string();
            };
        } else if (Array.isArray(o)) {
            this.pure_funcs = function(e) {
                return !Ee(e.expression.print_to_string(), o);
            };
        } else {
            this.pure_funcs = Oe;
        }
        var s = this.options["sequences"];
        this.sequences_limit = s == 1 ? 800 : s | 0;
        var f = this.options["top_retain"];
        if (f instanceof RegExp) {
            this.top_retain = function(e) {
                return f.test(e.name);
            };
        } else if (typeof f == "function") {
            this.top_retain = f;
        } else if (f) {
            if (typeof f == "string") {
                f = f.split(/,/);
            }
            this.top_retain = function(e) {
                return Ee(e.name, f);
            };
        }
        var u = this.options["toplevel"];
        this.toplevel = typeof u == "string" ? {
            funcs: /funcs/.test(u),
            vars: /vars/.test(u)
        } : {
            funcs: u,
            vars: u
        };
    }
    Ht.prototype = new Ct();
    t(Ht.prototype, {
        option: function(e) {
            return this.options[e];
        },
        exposed: function(e) {
            if (e.undeclared) return true;
            if (!(e.global || e.scope.resolve() instanceof on)) return false;
            var n = this.toplevel;
            return !Ce(e.orig, function(e) {
                return n[e instanceof dt ? "funcs" : "vars"];
            });
        },
        compress: function(e) {
            e = e.resolve_defines(this);
            if (this.option("expression")) {
                e.process_expression(true);
            }
            var n = +this.options.passes || 1;
            var t = 1 / 0;
            var i = false;
            var r = {
                ie8: this.option("ie8")
            };
            for (var a = 0; a < n; a++) {
                e.figure_out_scope(r);
                if (a > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
                e = e.transform(this);
                if (n > 1) {
                    var o = 0;
                    e.walk(new zt(function() {
                        o++;
                    }));
                    Ie.info("pass {pass}: last_count: {min_count}, count: {count}", {
                        pass: a,
                        min_count: t,
                        count: o
                    });
                    if (o < t) {
                        t = o;
                        i = false;
                    } else if (i) {
                        break;
                    } else {
                        i = true;
                    }
                }
            }
            if (this.option("expression")) {
                e.process_expression(false);
            }
            return e;
        },
        before: function(e, n, t) {
            if (e._squeezed) return e;
            var i = e instanceof an;
            if (i) {
                e.hoist_properties(this);
                e.hoist_declarations(this);
                e.process_boolean_returns(this);
            }
            n(e, this);
            n(e, this);
            var r = e.optimize(this);
            if (i && r === e && !this.has_directive("use asm") && !r.pinned()) {
                r.merge_variables(this);
                r.drop_unused(this);
                n(r, this);
            }
            if (r === e) r._squeezed = true;
            return r;
        }
    });
    (function(e) {
        e(Ie, function(e, n) {
            return e;
        });
        Ie.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        an.DEFMETHOD("process_expression", function(t, i) {
            var r = this;
            var a = new Ct(function(e) {
                if (t && e instanceof Le) {
                    return ve(bn, e, {
                        value: e.body
                    });
                }
                if (!t && e instanceof bn) {
                    return i ? i(e) : ve(Le, e, {
                        body: e.value || ve(Ln, e, {
                            operator: "void",
                            expression: ve(yt, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof sn && e !== r) {
                    return e;
                }
                if (e instanceof Je) {
                    var n = e.body.length - 1;
                    if (n >= 0) {
                        e.body[n] = e.body[n].transform(a);
                    }
                } else if (e instanceof En) {
                    e.body = e.body.transform(a);
                    if (e.alternative) {
                        e.alternative = e.alternative.transform(a);
                    }
                } else if (e instanceof rn) {
                    e.body = e.body.transform(a);
                }
                return e;
            });
            r.transform(a);
        });
        function T(e, n) {
            var t = n.getProperty();
            if (t instanceof Ie) return;
            var i;
            if (e instanceof Kn) {
                var r = e.elements;
                if (t == "length") return D(r.length, e);
                if (typeof t == "number" && t in r) i = r[t];
            } else if (e instanceof sn) {
                if (t == "length") {
                    e.length_read = true;
                    return D(e.argnames.length, e);
                }
            } else if (e instanceof tt) {
                t = "" + t;
                var a = e.properties;
                for (var o = a.length; --o >= 0; ) {
                    var s = a[o];
                    if (!(s instanceof rt)) return;
                    if (!i && a[o].key === t) i = a[o].value;
                }
            }
            return i instanceof _t && i.fixed_value() || i;
        }
        function l(e, n) {
            if (e instanceof Dt) return g.Boolean[n];
            if (e instanceof yt) return g.Number[n];
            if (e instanceof bt) return g.String[n];
            if (n == "valueOf") return false;
            if (e instanceof Kn) return g.Array[n];
            if (e instanceof sn) return g.Function[n];
            if (e instanceof tt) return g.Object[n];
            if (e instanceof wt) return g.RegExp[n] && !e.value.global;
        }
        function le(e, n, t, i, r, a, o) {
            var s = n.parent(r);
            if (e.option("unsafe") && s instanceof Rn && l(i, s.property)) {
                return;
            }
            var f = ye(t, s);
            if (f) return f;
            if (s instanceof Kn) return le(e, n, s, s, r + 1);
            if (s instanceof Nn) {
                return !a && s.expression === t && !s.is_expr_pure(e) && (!un(i) || !(s instanceof Pn) && i.contains_this());
            }
            if (s instanceof tn) return s.init === t;
            if (s instanceof rt) {
                if (s.value !== t) return;
                var u = n.parent(r + 1);
                return le(e, n, u, u, r + 2);
            }
            if (s instanceof In) {
                if (s.expression !== t) return;
                var c = T(i, s);
                return (!a || o) && le(e, n, s, c, r + 1);
            }
        }
        function pe(e) {
            if (e.name != "arguments") return false;
            var n = e.orig;
            return n.length == 1 && n[0] instanceof pt;
        }
        function L(e, n) {
            do {
                if (e === n) return false;
                if (n instanceof an) return true;
            } while (n = n.parent_scope);
        }
        function de(e, n) {
            var t = e.definition().orig;
            if (e.in_arg && (t[0] instanceof pt || t[1] instanceof pt)) return false;
            return Ce(t, function(e) {
                return !(e instanceof ut || e instanceof ct || n && e instanceof ht);
            });
        }
        (function(e) {
            e(Ie, Te);
            function o(e, n, t) {
                t.assignments = 0;
                t.bool_fn = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.const_redefs && !t.scope.pinned() && !n.exposed(t) && !(un(t.init) && t.init !== t.scope) && t.init;
                if (hn(t.fixed) && !Ce(t.references, function(e) {
                    var n = e.scope.resolve();
                    do {
                        if (t.scope === n) return true;
                    } while (un(n) && (n = n.parent_scope.resolve()));
                })) {
                    e.defun_ids[t.id] = false;
                }
                t.recursive_refs = 0;
                t.references = [];
                t.should_replace = undefined;
                t.single_use = undefined;
            }
            function u(n, t, e) {
                e.variables.each(function(e) {
                    o(n, t, e);
                    if (e.fixed === null) {
                        e.safe_ids = n.safe_ids;
                        h(n, e);
                    } else if (e.fixed) {
                        n.loop_ids[e.id] = n.in_loop;
                        h(n, e);
                    }
                });
                e.may_call_this = function() {
                    e.may_call_this = Te;
                    if (!e.contains_this()) return;
                    e.functions.each(function(e) {
                        if (hn(e.init) && !(e.id in n.defun_ids)) {
                            n.defun_ids[e.id] = false;
                        }
                    });
                };
                if (e.uses_arguments) e.each_argname(function(e) {
                    e.definition().last_ref = false;
                });
                if (t.option("ie8")) e.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function c(n, t) {
                if (t.id in n.defun_ids) {
                    var e = n.defun_ids[t.id];
                    if (!e) return;
                    var i = n.defun_visited[t.id];
                    if (e === n.safe_ids) {
                        if (!i) return t.fixed;
                    } else if (i) {
                        t.init.enclosed.forEach(function(e) {
                            if (t.init.variables.get(e.name) === e) return;
                            if (!_(n, e)) e.fixed = false;
                        });
                    } else {
                        n.defun_ids[t.id] = false;
                    }
                } else {
                    if (!n.in_loop) {
                        n.defun_ids[t.id] = n.safe_ids;
                        return t.fixed;
                    }
                    n.defun_ids[t.id] = false;
                }
            }
            function l(n, e) {
                e.functions.each(function(e) {
                    if (hn(e.init) && !n.defun_visited[e.id]) {
                        n.defun_ids[e.id] = n.safe_ids;
                        e.init.walk(n);
                    }
                });
            }
            function p(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function d(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function h(e, n) {
                e.safe_ids[n.id] = {};
            }
            function v(e, n) {
                e.references.push(n);
                if (e.last_ref !== false) e.last_ref = n;
            }
            function _(e, n) {
                if (n.single_use == "m") return false;
                var t = e.safe_ids[n.id];
                if (t) {
                    if (!Pe(e.safe_ids, n.id)) t.read = t.read && t.read !== e.safe_ids ? true : e.safe_ids;
                    if (n.fixed == null) {
                        if (pe(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        e.loop_ids[n.id] = null;
                        n.fixed = ve(Et, n.orig[0]);
                        return true;
                    }
                    return !t.assign || t.assign === e.safe_ids;
                }
                return hn(n.fixed);
            }
            function m(e, n, t) {
                if (!(t || Ce(n.orig, function(e) {
                    return !(e instanceof ut);
                }))) return false;
                if (n.fixed === undefined) return t || Ce(n.orig, function(e) {
                    return !(e instanceof ct);
                });
                if (n.fixed === null && n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    delete n.safe_ids;
                    return true;
                }
                if (n.fixed === false) return false;
                var i = e.safe_ids[n.id];
                if (!Pe(e.safe_ids, n.id)) {
                    if (!i) return false;
                    if (i.read && n.scope !== e.find_parent(an)) return false;
                    i.assign = i.assign && i.assign !== e.safe_ids ? true : e.safe_ids;
                }
                if (n.fixed != null && i.read) {
                    if (i.read !== e.safe_ids) return false;
                    if (e.loop_ids[n.id] !== e.in_loop) return false;
                }
                return _(e, n) && Ce(n.orig, function(e) {
                    return !(e instanceof ht);
                });
            }
            function g(e, n) {
                var t = ve(_t, e, e);
                t.fixed = n || ve(Et, e);
                return t;
            }
            function b(e, n) {
                return e.option("unused") && !n.scope.pinned() && n.single_use !== false && n.references.length - n.recursive_refs == 1;
            }
            function y(e) {
                if (!e) return false;
                return e.is_constant() || e instanceof sn || e instanceof mt;
            }
            function w(e, n, t) {
                if (t instanceof Gn) return t.operator == "=" && t.right === n;
                if (t instanceof Nn) return t.expression !== n || t instanceof Pn;
                if (t instanceof gn) return t.value === n && n.scope !== e.scope;
                if (t instanceof Cn) return t.value === n;
            }
            function x(e, n) {
                if (n instanceof Kn) return true;
                if (n instanceof Wn) return be[n.operator];
                if (n instanceof Jn) return n.condition !== e;
                if (n instanceof Hn) return n.tail_node() === e;
            }
            function k(e, n, t, i, r, a, o) {
                var s = e.parent(a);
                if (r && r.is_constant()) return;
                if (w(n, i, s)) {
                    n.escaped.push(s);
                    if (o > 1 && !(r && r.is_constant_expression(t))) o = 1;
                    if (!n.escaped.depth || n.escaped.depth > o) n.escaped.depth = o;
                    return;
                } else if (x(i, s)) {
                    k(e, n, t, s, s, a + 1, o);
                } else if (s instanceof rt && s.value === i) {
                    var f = e.parent(a + 1);
                    k(e, n, t, f, f, a + 2, o);
                } else if (s instanceof In && s.expression === i) {
                    r = T(r, s);
                    k(e, n, t, s, r, a + 1, o + 1);
                    if (r) return;
                }
                if (a > 0) return;
                if (s instanceof Nn && s.expression === i) return;
                if (s instanceof Hn && s.tail_node() !== i) return;
                if (s instanceof Le) return;
                if (s instanceof Yn && !Nt[s.operator]) return;
                n.direct_access = true;
            }
            function E(e) {
                if (!(e instanceof Un)) return;
                var n = e.expression;
                if (!(n instanceof _t)) return;
                var t = n.definition();
                if (!pe(t)) return;
                var i = e.property;
                if (i.is_constant()) i = i.value;
                if (!(i instanceof Ie) && !/^[1-9]*[0-9]$/.test(i)) return;
                t.reassigned = true;
                (i instanceof Ie ? t.scope.argnames : [ t.scope.argnames[i] ]).forEach(function(e) {
                    if (e instanceof pt) e.definition().fixed = false;
                });
            }
            function S(a, e, o, n) {
                var s = new zt(function(i) {
                    if (i instanceof Zn) {
                        f(i);
                        var r = o;
                        i.elements.forEach(function(e, n) {
                            if (e instanceof St) return f(e);
                            o = function() {
                                return ve(Un, e, {
                                    expression: r(),
                                    property: ve(yt, e, {
                                        value: n
                                    })
                                });
                            };
                            e.walk(s);
                        });
                        o = r;
                        return true;
                    }
                    if (i instanceof nt) {
                        f(i);
                        var r = o;
                        i.properties.forEach(function(t) {
                            f(t);
                            if (t.key instanceof Ie) {
                                p(a);
                                t.key.walk(a);
                                d(a);
                            }
                            o = function() {
                                var e = t.key;
                                var n = Un;
                                if (typeof e == "string") {
                                    if ($t(e)) {
                                        n = Rn;
                                    } else {
                                        e = D(e, t);
                                    }
                                }
                                return ve(n, t, {
                                    expression: r(),
                                    property: e
                                });
                            };
                            t.value.walk(s);
                        });
                        o = r;
                        return true;
                    }
                    n(i, o, function() {
                        var e = a.stack.length;
                        for (var n = 0, t = s.stack.length - 1; n < t; n++) {
                            a.stack.push(s.stack[n]);
                        }
                        i.walk(a);
                        a.stack.length = e;
                    });
                    return true;
                });
                e.walk(s);
            }
            function n(e, n, t) {
                var i = this.name.definition().id;
                if (e.defun_visited[i]) return true;
                if (e.defun_ids[i] !== e.safe_ids) return true;
                e.defun_visited[i] = true;
                this.inlined = false;
                p(e);
                u(e, t, this);
                n();
                d(e);
                l(e, this);
                return true;
            }
            function s(o, e, n) {
                var t = this;
                t.inlined = false;
                var s = o.parent();
                var i = t instanceof pn;
                var r = false;
                t.walk(new zt(function(e) {
                    if (i) return r = true;
                    if (e instanceof bn) return i = true;
                    if (e instanceof an && e !== t) return true;
                }));
                if (r) p(o);
                u(o, n, t);
                var f = !t.uses_arguments || o.has_directive("use strict");
                t.argnames.forEach(function(r, a) {
                    var n = s.args[a];
                    S(o, r, function() {
                        var e = t.argnames.indexOf(r);
                        return (e < 0 ? n : s.args[e]) || ve(Et, s);
                    }, function(e, n) {
                        var t = e.definition();
                        if (f && t.fixed === undefined) {
                            h(o, t);
                            o.loop_ids[t.id] = o.in_loop;
                            var i = s.args[a];
                            t.fixed = n;
                            t.fixed.assigns = [ r ];
                        } else {
                            t.fixed = false;
                        }
                    });
                });
                if (t instanceof cn && t.value) {
                    t.value.walk(o);
                } else {
                    We(t, o);
                }
                var a = o.safe_ids;
                d(o);
                l(o, t);
                if (!r) o.safe_ids = a;
                return true;
            }
            e(Gn, function(r, e, a) {
                var o = this;
                var s = o.left;
                if (o.operator == "=" && s.equivalent_to(o.right) && !s.has_side_effects(a)) {
                    o.right.walk(r);
                    f(s);
                    o.__drop = true;
                } else if (!(s instanceof Qn || s instanceof _t)) {
                    E(s);
                    return;
                } else if (o.operator == "=") {
                    o.right.walk(r);
                    S(r, s, function() {
                        return o.right;
                    }, function(e, n, t) {
                        if (!(e instanceof _t)) {
                            E(e);
                            t();
                            return;
                        }
                        var i = e.definition();
                        i.assignments++;
                        if (!le(a, r, o, o.right, 0) && de(e) && m(r, i)) {
                            v(i, e);
                            h(r, i);
                            if (i.single_use && s instanceof Qn) i.single_use = false;
                            r.loop_ids[i.id] = r.in_loop;
                            k(r, i, e.scope, o, o.right, 0, 1);
                            e.fixed = i.fixed = n;
                            e.fixed.assigns = [ o ];
                        } else {
                            t();
                            i.fixed = false;
                        }
                    });
                } else {
                    var n = s.definition();
                    n.assignments++;
                    var t = n.fixed;
                    if (le(a, r, o, o, 0)) {
                        n.fixed = false;
                        return;
                    }
                    var i = _(r, n);
                    o.right.walk(r);
                    if (i && m(r, n)) {
                        v(n, s);
                        h(r, n);
                        if (n.single_use) n.single_use = false;
                        s.fixed = n.fixed = function() {
                            return ve(Wn, o, {
                                operator: o.operator.slice(0, -1),
                                left: g(s, t),
                                right: o.right
                            });
                        };
                        s.fixed.assigns = !t || !t.assigns ? [] : t.assigns.slice();
                        s.fixed.assigns.push(o);
                    } else {
                        s.walk(r);
                        n.fixed = false;
                    }
                }
                return true;
                function f(e) {
                    if (e instanceof Rn) {
                        f(e.expression);
                    } else if (e instanceof Un) {
                        f(e.expression);
                        e.property.walk(r);
                    } else if (e instanceof _t) {
                        var n = e.definition();
                        v(n, e);
                        e.fixed = n.fixed;
                    } else {
                        e.walk(r);
                    }
                }
            });
            e(vn, n);
            e(Wn, function(e) {
                if (!be[this.operator]) return;
                this.left.walk(e);
                p(e);
                this.right.walk(e);
                d(e);
                return true;
            });
            e(Ve, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
            });
            e(Nn, function(n, e) {
                n.find_parent(an).may_call_this();
                var t = this.expression;
                if (un(t)) {
                    var i = !t.name;
                    this.args.forEach(function(e) {
                        e.walk(n);
                        if (e instanceof Bn) i = false;
                    });
                    if (i) t.reduce_vars = s;
                    t.walk(n);
                    if (i) delete t.reduce_vars;
                    return true;
                } else if (t instanceof _t) {
                    var r = t.definition();
                    if (this.TYPE == "Call" && n.in_boolean_context()) r.bool_fn++;
                    if (!hn(r.fixed)) return;
                    var a = c(n, r);
                    if (!a) return;
                    e();
                    a.walk(n);
                    return true;
                } else if (this.TYPE == "Call" && t instanceof Gn && t.operator == "=" && t.left instanceof _t && n.in_boolean_context()) {
                    t.left.definition().bool_fn++;
                }
            });
            e(Jn, function(e) {
                this.condition.walk(e);
                p(e);
                this.consequent.walk(e);
                d(e);
                p(e);
                this.alternative.walk(e);
                d(e);
                return true;
            });
            e(_n, n);
            e(Ze, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                p(e);
                this.body.walk(e);
                if (j(this, e.parent())) {
                    d(e);
                    p(e);
                }
                this.condition.walk(e);
                d(e);
                e.in_loop = n;
                return true;
            });
            e(nn, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                if (this.init) this.init.walk(n);
                var i = n.in_loop;
                n.in_loop = this;
                p(n);
                if (this.condition) this.condition.walk(n);
                this.body.walk(n);
                if (this.step) {
                    if (j(this, n.parent())) {
                        d(n);
                        p(n);
                    }
                    this.step.walk(n);
                }
                d(n);
                n.in_loop = i;
                return true;
            });
            e(tn, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                this.object.walk(n);
                var i = n.in_loop;
                n.in_loop = this;
                p(n);
                var r = this.init;
                r.walk(n);
                if (r instanceof Mn) {
                    r.definitions[0].name.match_symbol(function(e) {
                        if (e instanceof ft) {
                            var n = e.definition();
                            n.assignments++;
                            n.fixed = false;
                        }
                    }, true);
                } else if (r instanceof _t && !r.is_immutable()) {
                    var a = r.definition();
                    a.assignments++;
                    a.fixed = false;
                }
                this.body.walk(n);
                d(n);
                n.in_loop = i;
                return true;
            });
            e(En, function(e) {
                this.condition.walk(e);
                p(e);
                this.body.walk(e);
                d(e);
                if (this.alternative) {
                    p(e);
                    this.alternative.walk(e);
                    d(e);
                }
                return true;
            });
            e(Xe, function(e) {
                p(e);
                this.body.walk(e);
                d(e);
                return true;
            });
            e(sn, function(e, n, t) {
                var i = this;
                i.inlined = false;
                p(e);
                u(e, t, i);
                n();
                d(e);
                if (i.name) k(e, i.name.definition(), i, i.name, i, 0, 1);
                l(e, i);
                return true;
            });
            e(Sn, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                this.expression.walk(n);
                var i = true;
                this.body.forEach(function(e) {
                    if (e instanceof Dn) return;
                    e.expression.walk(n);
                    if (i) {
                        i = false;
                        p(n);
                    }
                });
                if (!i) d(n);
                We(this, n);
                return true;
            });
            e(Tn, function(e) {
                p(e);
                We(this, e);
                d(e);
                return true;
            });
            e(vt, function() {
                this.definition().fixed = false;
            });
            e(_t, function(e, n, t) {
                var i = this.definition();
                v(i, this);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof dt) {
                    e.loop_ids[i.id] = e.in_loop;
                }
                if (i.fixed === false) {
                    var r = i.redefined();
                    if (r && L(i.scope, this.scope)) r.single_use = false;
                } else if (i.fixed === undefined || !_(e, i)) {
                    i.fixed = false;
                } else if (i.fixed) {
                    if (this.in_arg && i.orig[0] instanceof ht) this.fixed = i.scope;
                    var a = this.fixed_value();
                    var o = xe(e, i);
                    if (o) {
                        i.recursive_refs++;
                    } else if (a && b(t, i)) {
                        i.in_loop = e.loop_ids[i.id] !== e.in_loop;
                        i.single_use = a instanceof sn && !a.pinned() && (!i.in_loop || e.parent() instanceof Nn) || !i.in_loop && i.scope === this.scope.resolve() && a.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if (le(t, e, this, a, 0, y(a), o)) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = false;
                        }
                    }
                    if (i.fixed && e.loop_ids[i.id] !== e.in_loop) {
                        i.cross_loop = true;
                    }
                    k(e, i, this.scope, this, a, 0, 1);
                }
                if (!this.fixed) this.fixed = i.fixed;
                var s;
                if (hn(i.fixed) && !((s = e.parent()) instanceof Nn && s.expression === this)) {
                    var f = c(e, i);
                    if (f) f.walk(e);
                }
            });
            e(on, function(n, e, t) {
                this.globals.each(function(e) {
                    o(n, t, e);
                });
                p(n);
                u(n, t, this);
                e();
                d(n);
                l(n, this);
                return true;
            });
            e(An, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                p(n);
                We(this, n);
                d(n);
                if (this.bcatch) {
                    p(n);
                    this.bcatch.walk(n);
                    d(n);
                }
                if (this.bfinally) this.bfinally.walk(n);
                return true;
            });
            e(Yn, function(e, n) {
                var t = this;
                if (!jt[t.operator]) return;
                var i = t.expression;
                if (!(i instanceof _t)) {
                    E(i);
                    return;
                }
                var r = i.definition();
                r.assignments++;
                var a = r.fixed;
                if (_(e, r) && m(e, r)) {
                    v(r, i);
                    h(e, r);
                    if (r.single_use) r.single_use = false;
                    r.fixed = function() {
                        return ve(Wn, t, {
                            operator: t.operator.slice(0, -1),
                            left: ve(Ln, t, {
                                operator: "+",
                                expression: g(i, a)
                            }),
                            right: ve(yt, t, {
                                value: 1
                            })
                        });
                    };
                    r.fixed.assigns = a && a.assigns ? a.assigns.slice() : [];
                    r.fixed.assigns.push(t);
                    if (t instanceof Ln) {
                        i.fixed = r.fixed;
                    } else {
                        i.fixed = function() {
                            return ve(Ln, t, {
                                operator: "+",
                                expression: g(i, a)
                            });
                        };
                        i.fixed.assigns = a && a.assigns;
                    }
                } else {
                    i.walk(e);
                    r.fixed = false;
                }
                return true;
            });
            e(Cn, function(i) {
                var r = this;
                if (!r.value) return;
                r.value.walk(i);
                S(i, r.name, function() {
                    return r.value;
                }, function(e, n) {
                    var t = e.definition();
                    if (m(i, t, true)) {
                        h(i, t);
                        i.loop_ids[t.id] = i.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ r ];
                        if (e instanceof ut && t.redefined() || !(de(e) || ie(t))) {
                            t.single_use = false;
                        }
                    } else {
                        t.fixed = false;
                    }
                });
                return true;
            });
            e(en, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                p(e);
                n();
                d(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        function f(e) {
            e._squeezed = false;
            e._optimized = false;
            delete e.fixed;
            if (e instanceof an) delete e._var_names;
        }
        on.DEFMETHOD("reset_opt_flags", function(t) {
            var i = new zt(t.option("reduce_vars") ? function(e, n) {
                f(e);
                return e.reduce_vars(i, n, t);
            } : f);
            i.defun_ids = Object.create(null);
            i.defun_visited = Object.create(null);
            i.in_loop = null;
            i.loop_ids = Object.create(null);
            i.safe_ids = Object.create(null);
            this.walk(i);
        });
        st.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (!e) return e;
            if (this.fixed) e = this.fixed;
            return e instanceof Ie ? e : e();
        });
        _t.DEFMETHOD("is_immutable", function() {
            var e = this.definition();
            if (e.orig.length != 1) return false;
            var n = e.orig[0];
            return n instanceof ht && e.scope.name === n;
        });
        Ie.DEFMETHOD("convert_symbol", Te);
        Qn.DEFMETHOD("convert_symbol", function(t, i) {
            return this.transform(new Ct(function(e, n) {
                if (e instanceof Qn) {
                    e = e.clone();
                    n(e, this);
                    return e;
                }
                if (e instanceof et) {
                    e = e.clone();
                    e.value = e.value.transform(this);
                    return e;
                }
                return e.convert_symbol(t, i);
            }));
        });
        function n(e, n) {
            var t = ve(e, this, this);
            n(t, this);
            return t;
        }
        ft.DEFMETHOD("convert_symbol", n);
        _t.DEFMETHOD("convert_symbol", n);
        Qn.DEFMETHOD("mark_symbol", function(n, t) {
            var i = new zt(function(e) {
                if (e instanceof et) {
                    if (e.key instanceof Ie) e.key.walk(t);
                    e.value.walk(i);
                    return true;
                }
                return n(e);
            });
            this.walk(i);
        });
        function t(e) {
            return e(this);
        }
        ft.DEFMETHOD("mark_symbol", t);
        _t.DEFMETHOD("mark_symbol", t);
        Ie.DEFMETHOD("match_symbol", function(e) {
            return e(this);
        });
        Qn.DEFMETHOD("match_symbol", function(n, t) {
            var i = false;
            var r = new zt(function(e) {
                if (i) return true;
                if (e instanceof et) {
                    if (!t && e.key instanceof Ie) return i = true;
                    e.value.walk(r);
                    return true;
                }
                if (n(e)) return i = true;
            });
            this.walk(r);
            return i;
        });
        function V(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t.variables) return t;
            }
        }
        function he(e, n) {
            if (e instanceof mt) return true;
            if (e instanceof _t) {
                var t = e.definition();
                return t.lambda || n.exposed(t) && Q[t.name];
            }
            if (e instanceof In) {
                e = e.expression;
                if (e instanceof _t) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.is_constant()) return true;
                return he(e, n);
            }
            return false;
        }
        function ve(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function W(e, n) {
            if (n.length == 1) return n[0];
            return ve(Hn, e, {
                expressions: n.reduce(_, [])
            });
        }
        function D(e, n) {
            switch (typeof e) {
              case "string":
                return ve(bt, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return ve(kt, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? ve(Ln, n, {
                        operator: "-",
                        expression: ve(yt, n, {
                            value: -e
                        })
                    }) : ve(yt, n, {
                        value: e
                    });
                }
                return e < 0 ? ve(Ln, n, {
                    operator: "-",
                    expression: ve(Tt, n)
                }) : ve(Tt, n);

              case "boolean":
                return ve(e ? At : Ot, n);

              case "undefined":
                return ve(Et, n);

              default:
                if (e === null) {
                    return ve(xt, n, {
                        value: null
                    });
                }
                if (e instanceof RegExp) {
                    return ve(wt, n, {
                        value: e
                    });
                }
                throw new Error(je("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function J(e, n) {
            return n instanceof In || K(n) && n.name == "eval";
        }
        function _e(e, n, t, i) {
            var r = false;
            if (n.TYPE == "Call") {
                r = n.expression === t && J(e, i);
            } else if (n instanceof Ln) {
                r = n.operator == "delete" || n.operator == "typeof" && K(i);
            }
            return r ? W(t, [ ve(yt, t, {
                value: 0
            }), i ]) : i;
        }
        function _(e, n) {
            if (n instanceof Hn) {
                e.push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function O(e) {
            if (e === null) return [];
            if (e instanceof Ge) return Ce(e.body, function(e) {
                return !(e instanceof jn || e instanceof Fn);
            }) ? e.body : [ e ];
            if (e instanceof Ye) return [];
            if (e instanceof Re) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function G(e) {
            if (e === null) return true;
            if (e instanceof Ye) return true;
            if (e instanceof Ge) return e.body.length == 0;
            return false;
        }
        function x(e) {
            return Ce(e.body, function(e) {
                return G(e) || e instanceof _n || e instanceof qn && Ce(e.definitions, function(e) {
                    return !e.value;
                });
            });
        }
        function A(e) {
            if (e instanceof Ke) {
                return e.body instanceof Ge ? e.body : e;
            }
            return e;
        }
        function me(e) {
            while (e instanceof In) e = e.expression;
            return e;
        }
        function X(e) {
            if (e.TYPE != "Call") return false;
            var n = e.expression;
            return n instanceof pn || n instanceof dn || X(n);
        }
        function K(e) {
            return e instanceof _t && e.definition().undeclared;
        }
        function ge(e) {
            return e[e instanceof Gn ? "right" : "value"];
        }
        var i = qe("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");
        _t.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && i[this.name];
        });
        var Q = qe("Infinity NaN undefined");
        function o(e) {
            return e instanceof Tt || e instanceof kt || e instanceof Et;
        }
        function m(e) {
            return Ce(e.definitions, function(e) {
                return !e.value;
            });
        }
        function z(e) {
            return e instanceof _n || e instanceof qn && m(e);
        }
        function u(e, f) {
            var se, fe, ue;
            t();
            var ce, n = 10;
            do {
                ce = false;
                r(e);
                if (f.option("dead_code")) {
                    o(e, f);
                }
                if (f.option("if_return")) {
                    a(e, f);
                }
                if (f.sequences_limit > 0) {
                    s(e, f);
                    u(e, f);
                }
                if (f.option("join_vars")) {
                    v(e);
                }
                if (f.option("collapse_vars")) {
                    i(e, f);
                }
            } while (ce && n-- > 0);
            return e;
            function t() {
                var e = f.self(), n = 0;
                do {
                    if (e instanceof zn) {
                        if (!f.parent(n).bfinally) n++;
                    } else if (e instanceof $n) {
                        n++;
                    } else if (e instanceof Ke) {
                        se = true;
                    } else if (e instanceof an) {
                        ue = e;
                        break;
                    } else if (e instanceof An) {
                        if (!fe) fe = e;
                    }
                } while (e = f.parent(n++));
            }
            function i(a, l) {
                if (ue.pinned()) return a;
                var c;
                var o = Object.create(null);
                var p = [];
                var s = Object.create(null);
                var t;
                var f = a.length;
                var d = new Ct(function(e, n) {
                    if ($) return e;
                    if (!z) {
                        if (e !== u[h]) return e;
                        h++;
                        if (h < u.length) return N(e, d);
                        z = true;
                        m = (_ ? Y : B)(e, 0);
                        if (m === e) $ = true;
                        return e;
                    }
                    var t = d.parent();
                    if (P(e, t)) {
                        $ = true;
                        return e;
                    }
                    if (!g && H(e, t)) {
                        g = t;
                    }
                    if (e.single_use && t instanceof Cn && t.value === e) return e;
                    var i;
                    if (!(e instanceof ft) && (w && b.equivalent_to(e) || x && (i = x(e, this)))) {
                        if (!F || g && (i || !D || !A)) {
                            if (!i || !_) $ = true;
                            return e;
                        }
                        if (ye(e, t)) {
                            if (_ && !i) {
                                j = true;
                                M++;
                            }
                            return e;
                        } else if (_) {
                            if (!i) M++;
                            return e;
                        } else {
                            M++;
                        }
                        ce = $ = true;
                        Ie.info("Collapsing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (v instanceof Vn) {
                            if (b instanceof _t) b.definition().fixed = false;
                            return ve(Ln, v, v);
                        }
                        if (v instanceof Cn) {
                            var r = v.name.definition();
                            if (r.references.length - r.replaced == 1 && !l.exposed(r)) {
                                r.replaced++;
                                return _e(l, t, e, v.value);
                            }
                            return ve(Gn, v, {
                                operator: "=",
                                left: ve(_t, v.name, v.name),
                                right: v.value
                            });
                        }
                        v.write_only = false;
                        return v;
                    }
                    if (I(e, t) || k(e)) {
                        m = e;
                        if (e instanceof an) $ = true;
                    }
                    if (e instanceof fn) {
                        var a = F;
                        F = false;
                        n(e, d);
                        F = a;
                        return e;
                    }
                    return N(e, d);
                }, function(e) {
                    if ($) return;
                    if (m === e) $ = true;
                    if (g === e) g = null;
                });
                var i = new Ct(function(e) {
                    if ($) return e;
                    if (!z) {
                        if (e !== u[h]) return e;
                        h++;
                        switch (u.length - h) {
                          case 0:
                            z = true;
                            if (j) return e;
                            if (e instanceof Cn) return e;
                            q.replaced++;
                            var n = i.parent();
                            if (n instanceof Hn && n.tail_node() !== e) {
                                _.replaced++;
                                return $e.skip;
                            }
                            return O;

                          case 1:
                            if (!j && e.body === v) {
                                z = true;
                                q.replaced++;
                                _.replaced++;
                                return null;
                            }

                          default:
                            return;
                        }
                    }
                    if (e instanceof _t && e.name == q.name) {
                        if (!--M) $ = true;
                        if (ye(e, i.parent())) return e;
                        q.replaced++;
                        var t = O.clone();
                        _.references.push(t);
                        return t;
                    }
                    if (e instanceof Dn || e instanceof an) return e;
                }, ee);
                while (--f >= 0) {
                    if (f == 0 && l.option("unused")) R();
                    var u = [];
                    U(a[f]);
                    while (p.length > 0) {
                        u = p.pop();
                        var h = 0;
                        var v = u[u.length - 1];
                        var _ = null;
                        var m = null;
                        var g = null;
                        var b = W(v);
                        var y = b && b.has_side_effects(l);
                        var w = b && !y && !he(b, l);
                        var x = G(v);
                        if (!w && !x) continue;
                        var r = v.name instanceof pt;
                        var k = De;
                        if (v.may_throw(l)) {
                            if (r && ue instanceof pn) continue;
                            k = fe ? function(e) {
                                return e.has_side_effects(l);
                            } : oe;
                        }
                        var E = false;
                        var S = false;
                        var T = Q(v);
                        var D = ne(b);
                        var O = ge(v);
                        if (!y) y = te();
                        var A = ie(v);
                        var z = r;
                        var $ = false;
                        var M = 0;
                        var j = false;
                        var F = !c || !z;
                        if (!F) {
                            for (var e = ue.argnames.lastIndexOf(v.name) + 1; !$ && e < c.length; e++) {
                                c[e].transform(d);
                            }
                            F = true;
                        }
                        for (var n = f; !$ && n < a.length; n++) {
                            a[n].transform(d);
                        }
                        if (_) {
                            var q = b.definition();
                            var C = q.references.length - q.replaced;
                            if (v instanceof Gn) C--;
                            if (M && C == M) {
                                $ = false;
                            } else {
                                p.push(u);
                                t = true;
                                continue;
                            }
                            if (M) {
                                h = 0;
                                z = r;
                                for (var n = f; !$ && n < a.length; n++) {
                                    if (!a[n].transform(i)) a.splice(n--, 1);
                                }
                                if (v instanceof Cn) {
                                    M = !l.exposed(q) && q.references.length == q.replaced;
                                }
                                _.single_use = false;
                            }
                        }
                        if (M && !Z(v)) a.splice(f, 1);
                    }
                }
                function N(e, n) {
                    if (!(e instanceof Ve)) return;
                    if (e instanceof an) return e;
                    if (!(e.variables && e.variables.all(function(e) {
                        return !T.has(e.name);
                    }))) {
                        $ = true;
                        return e;
                    }
                    if (e instanceof tn) {
                        e.object = e.object.transform(n);
                        $ = true;
                        return e;
                    }
                    if (e instanceof Sn) {
                        e.expression = e.expression.transform(n);
                        for (var t = 0; !$ && t < e.body.length; t++) {
                            var i = e.body[t];
                            if (i instanceof On) {
                                if (!z) {
                                    if (i !== u[h]) continue;
                                    h++;
                                }
                                i.expression = i.expression.transform(n);
                                if (!A) break;
                                x = false;
                            }
                        }
                        $ = true;
                        return e;
                    }
                }
                function P(e, n) {
                    if (e === O) return true;
                    if (n instanceof nn) return e !== n.init;
                    if (e instanceof Gn) {
                        return e.operator != "=" && b.equivalent_to(e.left);
                    }
                    if (e instanceof Nn) {
                        if (!(b instanceof In)) return false;
                        if (!b.equivalent_to(e.expression)) return false;
                        return !(O instanceof dn && !O.contains_this());
                    }
                    if (e instanceof Ue) return true;
                    if (e instanceof _n) return r && b.name === e.name.name;
                    if (e instanceof Qn) return n instanceof Gn;
                    if (e instanceof et) return e.key instanceof Ie;
                    if (e instanceof Qe) return true;
                    if (e instanceof wn) return true;
                    if (e instanceof _t) {
                        if (e.is_declared(l)) {
                            if (e.fixed_value()) return false;
                            if (de(e)) {
                                return !(n instanceof In && n.expression === e) && pe(e.definition());
                            }
                        } else if (n instanceof Gn && n.operator == "=" && n.left === e) {
                            return false;
                        }
                        if (!A) return true;
                        x = false;
                        return false;
                    }
                    if (e instanceof An) return true;
                    if (e instanceof rn) return true;
                    return false;
                }
                function H(e, n) {
                    if (n instanceof Wn) return be[n.operator] && n.left !== e;
                    if (n instanceof On) return n.expression !== e;
                    if (n instanceof Jn) return n.condition !== e;
                    return n instanceof En && n.condition !== e;
                }
                function I(e, n) {
                    if (e instanceof Xn) return true;
                    if (e.TYPE == "Binary") return e.operator == "in" && !we(e.right);
                    if (e instanceof Nn) {
                        var t, i = e.expression;
                        if (i instanceof _t) {
                            t = i.definition();
                            i = i.fixed_value();
                        }
                        if (!(i instanceof sn)) return true;
                        if (t && xe(l, t)) return true;
                        if (!Ce(i.argnames, function(e) {
                            return !(e instanceof Qn);
                        })) return true;
                        if (i.collapse_scanning) return false;
                        i.collapse_scanning = true;
                        var r = F;
                        F = false;
                        var a = m;
                        var o = g;
                        if (i instanceof cn && i.value) {
                            i.value.transform(d);
                        } else for (var s = 0; !$ && s < i.body.length; s++) {
                            var f = i.body[s];
                            if (f instanceof bn) {
                                if (f.value) f.value.transform(d);
                                break;
                            }
                            f.transform(d);
                        }
                        g = o;
                        m = a;
                        F = r;
                        delete i.collapse_scanning;
                        if (!$) return false;
                        $ = false;
                        return true;
                    }
                    if (e instanceof gn) {
                        if (fe) {
                            if (fe.bfinally) return true;
                            if (fe.bcatch && e instanceof yn) return true;
                        }
                        return y || b instanceof In || ae(b);
                    }
                    if (e instanceof dn) {
                        return l.option("ie8") && e.name && T.has(e.name.name);
                    }
                    if (e instanceof In) {
                        var u = e.expression;
                        return y || !_ && u.may_throw_on_access(l) || u instanceof _t && pe(u.definition());
                    }
                    if (e instanceof Bn) return true;
                    if (e instanceof _t) {
                        if (re(e, n)) {
                            return !(n instanceof Gn && n.operator == "=" && n.left === e);
                        }
                        if (y && ae(e)) return true;
                        var t = e.definition();
                        return (fe || t.scope.resolve() !== ue) && !de(e);
                    }
                    if (e instanceof mt) return re(e, n);
                    if (e instanceof Cn) {
                        if ((fe || !D) && e.name instanceof Qn) return true;
                        return (e.value || n instanceof Fn) && e.name.match_symbol(function(e) {
                            return e instanceof ft && (T.has(e.name) || y && ae(e));
                        });
                    }
                    var c = ye(e.left, e);
                    if (!c) return false;
                    if (c instanceof In) return true;
                    if ((fe || !D) && c instanceof Qn) return true;
                    return c.match_symbol(function(e) {
                        return e instanceof _t && (T.has(e.name) || E && l.exposed(e.definition()));
                    });
                }
                function R() {
                    var e, t = l.self();
                    if (un(t) && !t.name && !t.uses_arguments && !t.pinned() && (e = l.parent()) instanceof Nn && e.expression === t && Ce(e.args, function(e) {
                        return !(e instanceof Bn);
                    })) {
                        var i = l.has_directive("use strict");
                        if (i && !Ee(i, t.body)) i = false;
                        var r = t instanceof pn ? function(e) {
                            return e instanceof st && e.name == "await";
                        } : function(e) {
                            return e instanceof Xn && !a.find_parent(an);
                        };
                        var a = new zt(function(e) {
                            if (!u) return true;
                            if (r(e)) {
                                u = null;
                                return true;
                            }
                            if (e instanceof _t && t.variables.has(e.name)) {
                                var n = e.definition().scope;
                                if (n !== ue) while (n = n.parent_scope) {
                                    if (n === ue) return true;
                                }
                                u = null;
                            }
                            if (e instanceof mt && (i || !a.find_parent(an))) {
                                u = null;
                                return true;
                            }
                        });
                        var n = t.argnames.length;
                        c = e.args.slice(n);
                        var o = Object.create(null);
                        for (var s = n; --s >= 0; ) {
                            var f = t.argnames[s];
                            var u = e.args[s];
                            c.unshift(ve(Cn, f, {
                                name: f,
                                value: u
                            }));
                            if (f instanceof Qn) {
                                if (!f.match_symbol(De)) continue;
                                p.length = 0;
                                break;
                            }
                            if (f.name in o) continue;
                            o[f.name] = true;
                            if (!u) {
                                u = ve(Et, f).transform(l);
                            } else if (u instanceof sn && u.pinned()) {
                                u = null;
                            } else {
                                u.walk(a);
                            }
                            if (u) p.unshift([ ve(Cn, f, {
                                name: f,
                                value: u
                            }) ]);
                        }
                    }
                }
                function U(e) {
                    u.push(e);
                    if (e instanceof Kn) {
                        e.elements.forEach(U);
                    } else if (e instanceof Gn) {
                        if (!(e.left instanceof Qn)) p.push(u.slice());
                        U(e.left);
                        U(e.right);
                        if (e.left instanceof _t) {
                            o[e.left.name] = (o[e.left.name] || 0) + 1;
                        }
                    } else if (e instanceof Xn) {
                        U(e.expression);
                    } else if (e instanceof Wn) {
                        U(e.left);
                        U(e.right);
                    } else if (e instanceof Nn) {
                        U(e.expression);
                        e.args.forEach(U);
                    } else if (e instanceof On) {
                        U(e.expression);
                    } else if (e instanceof Jn) {
                        U(e.condition);
                        U(e.consequent);
                        U(e.alternative);
                    } else if (e instanceof Mn) {
                        e.definitions.forEach(U);
                    } else if (e instanceof Rn) {
                        U(e.expression);
                    } else if (e instanceof Qe) {
                        U(e.condition);
                        if (!(e.body instanceof Je)) {
                            U(e.body);
                        }
                    } else if (e instanceof gn) {
                        if (e.value) U(e.value);
                    } else if (e instanceof nn) {
                        if (e.init) U(e.init);
                        if (e.condition) U(e.condition);
                        if (e.step) U(e.step);
                        if (!(e.body instanceof Je)) {
                            U(e.body);
                        }
                    } else if (e instanceof tn) {
                        U(e.object);
                        if (!(e.body instanceof Je)) {
                            U(e.body);
                        }
                    } else if (e instanceof En) {
                        U(e.condition);
                        if (!(e.body instanceof Je)) {
                            U(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof Je)) {
                            U(e.alternative);
                        }
                    } else if (e instanceof tt) {
                        e.properties.forEach(function(e) {
                            u.push(e);
                            if (e.key instanceof Ie) U(e.key);
                            if (e instanceof rt) U(e.value);
                            u.pop();
                        });
                    } else if (e instanceof Hn) {
                        e.expressions.forEach(U);
                    } else if (e instanceof Le) {
                        U(e.body);
                    } else if (e instanceof Bn) {
                        U(e.expression);
                    } else if (e instanceof Un) {
                        U(e.expression);
                        U(e.property);
                    } else if (e instanceof Sn) {
                        U(e.expression);
                        e.body.forEach(U);
                    } else if (e instanceof Yn) {
                        if (jt[e.operator]) {
                            p.push(u.slice());
                        } else {
                            U(e.expression);
                        }
                    } else if (e instanceof Cn) {
                        if (e.name instanceof lt) {
                            if (e.value) {
                                var n = e.name.definition();
                                if (n.references.length > n.replaced) {
                                    p.push(u.slice());
                                }
                            } else {
                                s[e.name.name] = (s[e.name.name] || 0) + 1;
                            }
                        }
                        if (e.value) U(e.value);
                    }
                    u.pop();
                }
                function B(e, n) {
                    var t = d.parent(n);
                    if (t instanceof Kn) return e;
                    if (t instanceof Gn) return e;
                    if (t instanceof Xn) return e;
                    if (t instanceof Wn) return e;
                    if (t instanceof Nn) return e;
                    if (t instanceof On) return e;
                    if (t instanceof Jn) return e;
                    if (t instanceof Mn) return L(t, n + 1);
                    if (t instanceof gn) return e;
                    if (t instanceof En) return e;
                    if (t instanceof Ke) return e;
                    if (t instanceof it) return e;
                    if (t instanceof In) return e;
                    if (t instanceof Hn) {
                        return (t.tail_node() === e ? B : L)(t, n + 1);
                    }
                    if (t instanceof Le) return L(t, n + 1);
                    if (t instanceof Bn) return e;
                    if (t instanceof Sn) return e;
                    if (t instanceof Yn) return e;
                    if (t instanceof Cn) return e;
                    return null;
                }
                function Y(e, n) {
                    var t = d.parent(n);
                    if (t instanceof Kn) return Y(t, n + 1);
                    if (t instanceof Gn) return k(t) || t.left.match_symbol(function(e) {
                        return e instanceof _t && (b.name == e.name || _.name == e.name);
                    }) ? e : Y(t, n + 1);
                    if (t instanceof Wn) {
                        if (be[t.operator] && t.left !== e) {
                            do {
                                e = t;
                                t = d.parent(++n);
                            } while (t instanceof Wn && t.operator == e.operator);
                            return e;
                        }
                        return Y(t, n + 1);
                    }
                    if (t instanceof Nn) return t;
                    if (t instanceof On) {
                        if (t.expression !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof Jn) {
                        if (t.condition !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof Mn) return L(t, n + 1);
                    if (t instanceof Ze) return e;
                    if (t instanceof gn) return L(t, n + 1);
                    if (t instanceof nn) {
                        if (t.init !== e && t.condition !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof tn) {
                        if (t.init !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof En) {
                        if (t.condition !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof it) {
                        var i = d.parent(n + 1);
                        return Ce(i.properties, function(e) {
                            return e instanceof rt;
                        }) ? Y(i, n + 2) : i;
                    }
                    if (t instanceof In) return Y(t, n + 1);
                    if (t instanceof Hn) {
                        return (t.tail_node() === e ? Y : L)(t, n + 1);
                    }
                    if (t instanceof Le) return L(t, n + 1);
                    if (t instanceof Bn) return Y(t, n + 1);
                    if (t instanceof Sn) {
                        if (t.expression !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof Yn) {
                        if (t.operator == "delete") return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof Cn) return t.name.match_symbol(function(e) {
                        return e instanceof ft && (b.name == e.name || _.name == e.name);
                    }) ? e : Y(t, n + 1);
                    if (t instanceof en) {
                        if (t.condition !== e) return e;
                        return Y(t, n + 1);
                    }
                    return null;
                }
                function L(e, n) {
                    var t = d.parent(n);
                    if (I(e, t)) return e;
                    if (H(e, t)) return e;
                    if (t instanceof Kn) return L(t, n + 1);
                    if (t instanceof Gn) {
                        return k(t) ? e : L(t, n + 1);
                    }
                    if (t instanceof Xn) return e;
                    if (t instanceof Wn) return L(t, n + 1);
                    if (t instanceof Nn) return L(t, n + 1);
                    if (t instanceof On) return L(t, n + 1);
                    if (t instanceof Jn) return L(t, n + 1);
                    if (t instanceof Mn) return L(t, n + 1);
                    if (t instanceof gn) return L(t, n + 1);
                    if (t instanceof En) return L(t, n + 1);
                    if (t instanceof Ke) return e;
                    if (t instanceof it) {
                        var i = d.parent(n + 1);
                        return Ce(i.properties, function(e) {
                            return e instanceof rt;
                        }) ? L(i, n + 2) : i;
                    }
                    if (t instanceof In) {
                        var r = t.expression;
                        if (r === e) return L(t, n + 1);
                        var a = me(r);
                        if (!(a instanceof _t)) return L(t, n + 1);
                        var o = T.get(a.name);
                        return !o || Ce(o, function(e) {
                            return !(e instanceof In);
                        }) ? L(t, n + 1) : e;
                    }
                    if (t instanceof Hn) return L(t, n + 1);
                    if (t instanceof Le) return L(t, n + 1);
                    if (t instanceof Bn) return e;
                    if (t instanceof Sn) return L(t, n + 1);
                    if (t instanceof Yn) return L(t, n + 1);
                    if (t instanceof Cn) {
                        return k(t) ? e : L(t, n + 1);
                    }
                    return null;
                }
                function V(e) {
                    if (t) {
                        t = false;
                        return;
                    }
                    if (!(e instanceof _t)) return;
                    var n = e.definition();
                    if (n.undeclared) return;
                    if (pe(n)) return;
                    return _ = n;
                }
                function W(e) {
                    if (e instanceof Cn) {
                        var n = e.name.definition();
                        if (n.const_redefs) return;
                        if (!Ee(e.name, n.orig)) return;
                        var t = n.orig.length - n.eliminated - (s[n.name] || 0);
                        var i = n.references.length - n.replaced - (o[n.name] || 0);
                        if (t > 1 && !(e.name instanceof pt)) {
                            V(e.value);
                            return ve(_t, e.name, e.name);
                        }
                        if (V(e.value) || i == 1 && !l.exposed(n)) {
                            return ve(_t, e.name, e.name);
                        }
                    } else if (e instanceof Gn) {
                        var n, r = e.left;
                        if (e.operator == "=" && r instanceof _t && (n = r.definition()).references[0] === r && !l.exposed(n)) {
                            var i = n.references.length - n.replaced;
                            if (i > 1) V(e.right);
                        }
                        return r;
                    } else {
                        return e.expression;
                    }
                }
                function J(e) {
                    if (e instanceof Kn) return false;
                    if (e instanceof Wn && be[e.operator]) {
                        return J(e.left) && J(e.right);
                    }
                    if (e instanceof Nn) return false;
                    if (e instanceof Jn) {
                        return J(e.consequent) && J(e.alternative);
                    }
                    if (e instanceof tt) return false;
                    return !e.has_side_effects(l);
                }
                function G(n) {
                    if (n instanceof Gn && n.right.single_use) return;
                    var t = Object.create(null);
                    var e = new zt(function(e) {
                        if (e instanceof _t) t[e.definition().id] = true;
                    });
                    while (n instanceof Gn && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof _t) {
                        var i = n.evaluate(l);
                        if (i === n) return a;
                        return X(i, a);
                    }
                    if (n instanceof mt) return a;
                    if (n.is_truthy()) return X(true, De);
                    if (n.is_constant()) {
                        return X(n.evaluate(l), a);
                    }
                    if (!(b instanceof _t)) return false;
                    if (!J(n)) return false;
                    var r;
                    n.walk(new zt(function(e) {
                        if (r) return true;
                        if (e instanceof _t && t[e.definition().id]) r = true;
                    }));
                    return !r && a;
                    function a(e) {
                        return n.equivalent_to(e);
                    }
                }
                function X(t, i) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (t && e.is_truthy() && !e.has_side_effects(l)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                return !e.evaluate(l) == !t;
                            }
                        }
                        return i(e);
                    };
                }
                function K(e) {
                    if (e instanceof _t) {
                        e = e.fixed_value();
                        if (!e) return true;
                    }
                    if (e instanceof Gn) return e.operator == "=" && K(e.right);
                    return e instanceof In || e instanceof mt;
                }
                function Q(i) {
                    var r = new Ne();
                    if (i instanceof Cn) r.add(i.name.name, b);
                    var a = ue.uses_arguments && !l.has_directive("use strict");
                    var o = ue instanceof on;
                    var s = new zt(function(e) {
                        var n;
                        if (e instanceof _t) {
                            n = e.fixed_value() || e;
                        } else if (e instanceof mt) {
                            n = e;
                        }
                        if (n) r.add(e.name, le(l, s, e, n, 0));
                        if (a && e instanceof Un) {
                            ue.each_argname(function(e) {
                                if (!l.option("reduce_vars") || e.definition().assignments) {
                                    r.add(e.name, true);
                                }
                            });
                            a = false;
                        }
                        if (!o) return;
                        if (e.TYPE == "Call") {
                            if (S) return;
                            var t = e.expression;
                            if (t instanceof In) return;
                            if (t instanceof dn && !t.contains_this()) return;
                            S = true;
                        } else if (e instanceof In && K(e.expression)) {
                            if (e === b && !(i instanceof Yn)) {
                                S = true;
                            } else {
                                E = true;
                            }
                        }
                    });
                    i.walk(s);
                    return r;
                }
                function Z(e) {
                    if (e.name instanceof pt) {
                        var n = l.self().argnames.indexOf(e.name);
                        var t = l.parent().args;
                        if (t[n]) {
                            t[n] = ve(yt, t[n], {
                                value: 0
                            });
                            e.name.definition().fixed = false;
                        }
                        return true;
                    }
                    var i = u.length - 1;
                    if (u[i - 1].body === u[i]) i--;
                    var r = new Ct(function(e, n, t) {
                        if (z) return e;
                        if (e !== u[h]) return e;
                        h++;
                        if (h <= i) return N(e, r);
                        z = true;
                        if (e instanceof Cn) {
                            e.value = null;
                            s[e.name.name] = (s[e.name.name] || 0) + 1;
                            if (_) _.replaced++;
                            return e;
                        }
                        return t ? $e.skip : null;
                    }, ee);
                    $ = false;
                    z = false;
                    h = 0;
                    return a[f].transform(r);
                }
                function ee(e) {
                    if (e instanceof Hn) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return e.expressions[0];
                    }
                }
                function ne(e) {
                    var n = me(e);
                    return n instanceof _t && n.definition().scope === ue && !(se && (T.has(n.name) && T.get(n.name)[0] !== e || v instanceof Yn || v instanceof Gn && v.operator != "="));
                }
                function te() {
                    if (v instanceof Yn) return false;
                    return O.has_side_effects(l);
                }
                function ie(e) {
                    if (e instanceof Yn) return false;
                    if (y) return false;
                    if (_) return true;
                    if (!(b instanceof _t)) return false;
                    var n;
                    if (e instanceof Cn) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = b.definition();
                    return t.references.length - t.replaced == n;
                }
                function re(e, n) {
                    var t = T.get(e.name);
                    if (!t || Ce(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== b) return true;
                    x = false;
                }
                function ae(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof dt) return false;
                    if (n.scope !== ue) return true;
                    if (S && l.exposed(n)) return true;
                    return !Ce(n.references, function(e) {
                        return e.scope.resolve() === ue;
                    });
                }
                function oe(e, n) {
                    if (e instanceof Gn) return oe(e.left, true);
                    if (e instanceof Yn) return oe(e.expression, true);
                    if (e instanceof Cn) return e.value && oe(e.value);
                    if (n) {
                        if (e instanceof Rn) return oe(e.expression, true);
                        if (e instanceof Un) return oe(e.expression, true);
                        if (e instanceof _t) return e.definition().scope !== ue;
                    }
                    return false;
                }
            }
            function r(e) {
                var n = [];
                for (var t = 0; t < e.length; ) {
                    var i = e[t];
                    if (i instanceof Ge) {
                        if (Ce(i.body, function(e) {
                            return !(e instanceof jn || e instanceof Fn);
                        })) {
                            ce = true;
                            r(i.body);
                            [].splice.apply(e, [ t, 1 ].concat(i.body));
                            t += i.body.length;
                            continue;
                        }
                    }
                    if (i instanceof Be) {
                        if (Ee(i.value, n)) {
                            ce = true;
                            e.splice(t, 1);
                            continue;
                        }
                        n.push(i.value);
                    }
                    if (i instanceof Ye) {
                        ce = true;
                        e.splice(t, 1);
                        continue;
                    }
                    t++;
                }
            }
            function a(t, r) {
                var a = r.self();
                var e = r.parent();
                var i = w(function(e) {
                    return e instanceof sn;
                });
                var n = i && e && e.TYPE == "Call";
                var o = g(t);
                for (var s = t.length; --s >= 0; ) {
                    var f = t[s];
                    var u = T(s);
                    var c = t[u];
                    if (i && !c && f instanceof bn) {
                        if (!f.value) {
                            ce = true;
                            t.splice(s, 1);
                            continue;
                        }
                        if (f.value instanceof Ln && f.value.operator == "void") {
                            ce = true;
                            t[s] = ve(Le, f, {
                                body: f.value.expression
                            });
                            continue;
                        }
                    }
                    if (f instanceof En) {
                        var l = M(f.body);
                        if (k(l)) {
                            if (l.label) Fe(l.label.thedef.references, l);
                            ce = true;
                            f = f.clone();
                            f.condition = f.condition.negate(r);
                            var p = S(f.body, l);
                            f.body = ve(Ge, f, {
                                body: O(f.alternative).concat(E())
                            });
                            f.alternative = ve(Ge, f, {
                                body: p
                            });
                            t[s] = f;
                            t[s] = f.transform(r);
                            continue;
                        }
                        if (l && !f.alternative && f.body instanceof Ge && c instanceof mn) {
                            var d = f.condition.negate(r);
                            if (d.print_to_string().length <= f.condition.print_to_string().length) {
                                ce = true;
                                f = f.clone();
                                f.condition = d;
                                t[u] = f.body;
                                f.body = c;
                                t[s] = f;
                                t[s] = f.transform(r);
                                continue;
                            }
                        }
                        var h = M(f.alternative);
                        if (k(h)) {
                            if (h.label) Fe(h.label.thedef.references, h);
                            ce = true;
                            f = f.clone();
                            f.body = ve(Ge, f.body, {
                                body: O(f.body).concat(E())
                            });
                            var p = S(f.alternative, h);
                            f.alternative = ve(Ge, f.alternative, {
                                body: p
                            });
                            t[s] = f;
                            t[s] = f.transform(r);
                            continue;
                        }
                        if (r.option("typeofs")) {
                            if (l && !h) {
                                q(f.condition, null, ve(Ge, a, {
                                    body: t.slice(s + 1)
                                }));
                            }
                            if (!l && h) {
                                q(f.condition, ve(Ge, a, {
                                    body: t.slice(s + 1)
                                }));
                            }
                        }
                    }
                    if (f instanceof En && f.body instanceof bn) {
                        var v = f.body.value;
                        var _ = f.body.in_bool || c instanceof bn && c.in_bool;
                        if (!v && !f.alternative && (i && !c || c instanceof bn && !c.value)) {
                            ce = true;
                            t[s] = ve(Le, f.condition, {
                                body: f.condition
                            });
                            continue;
                        }
                        if (!f.alternative && c instanceof bn) {
                            ce = true;
                            f = f.clone();
                            f.alternative = c;
                            t.splice(s, 1, f.transform(r));
                            t.splice(u, 1);
                            continue;
                        }
                        if (!f.alternative && !c && i && (_ || v && o)) {
                            ce = true;
                            f = f.clone();
                            f.alternative = ve(bn, f, {
                                value: null
                            });
                            t.splice(s, 1, f.transform(r));
                            continue;
                        }
                        var m = t[D(s)];
                        if (r.option("sequences") && i && !f.alternative && (!m && n || m instanceof En && m.body instanceof bn) && T(u) == t.length && c instanceof Le) {
                            ce = true;
                            f = f.clone();
                            f.alternative = ve(Ge, c, {
                                body: [ c, ve(bn, c, {
                                    value: null
                                }) ]
                            });
                            t.splice(s, 1, f.transform(r));
                            t.splice(u, 1);
                            continue;
                        }
                    }
                }
                function g(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var i = e[t];
                        if (i instanceof En && i.body instanceof bn) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function b(e) {
                    return !e || e instanceof Ln && e.operator == "void";
                }
                function y(e, n) {
                    var t = e.lastIndexOf(n);
                    if (t < 0) return false;
                    while (++t < e.length) {
                        if (!z(e[t])) return false;
                    }
                    return true;
                }
                function w(e) {
                    var n = a, t, i = 0;
                    do {
                        do {
                            if (e(n)) return true;
                            n = r.parent(i++);
                        } while (n instanceof En && (t = n));
                    } while ((n instanceof Ge || n instanceof an) && y(n.body, t));
                }
                function x(n) {
                    return w(function(e) {
                        return e === n;
                    });
                }
                function k(e) {
                    if (e instanceof bn) return i && b(e.value);
                    if (!(e instanceof wn)) return false;
                    var n = r.loopcontrol_target(e);
                    if (e instanceof kn) return x(A(n));
                    if (n instanceof Ke) return false;
                    return x(n);
                }
                function E() {
                    var e = t.slice(s + 1);
                    t.length = s + 1;
                    return e.filter(function(e) {
                        if (e instanceof _n) {
                            t.push(e);
                            return false;
                        }
                        return true;
                    });
                }
                function S(e, n) {
                    var t = O(e);
                    var i = t, r;
                    while ((r = i[i.length - 1]) !== n) {
                        i = r.body;
                    }
                    i.pop();
                    if (n.value) t.push(ve(Le, n.value, {
                        body: n.value.expression
                    }));
                    return t;
                }
                function T(e) {
                    for (var n = e + 1; n < t.length; n++) {
                        if (!z(t[n])) break;
                    }
                    return n;
                }
                function D(e) {
                    for (var n = e; --n >= 0; ) {
                        if (!z(t[n])) break;
                    }
                    return n;
                }
            }
            function o(n, t) {
                var e;
                var i = t.self();
                for (var r = 0, a = 0, o = n.length; r < o; r++) {
                    var s = n[r];
                    if (s instanceof wn) {
                        var f = t.loopcontrol_target(s);
                        if (s instanceof xn && !(f instanceof Ke) && A(f) === i || s instanceof kn && A(f) === i) {
                            if (s.label) Fe(s.label.thedef.references, s);
                        } else {
                            n[a++] = s;
                        }
                    } else {
                        n[a++] = s;
                    }
                    if (M(s)) {
                        e = n.slice(r + 1);
                        break;
                    }
                }
                n.length = a;
                ce = a != o;
                if (e) e.forEach(function(e) {
                    k(t, e, n);
                });
            }
            function s(n, e) {
                if (n.length < 2) return;
                var t = [], i = 0;
                function r() {
                    if (!t.length) return;
                    var e = W(t[0], t);
                    n[i++] = ve(Le, e, {
                        body: e
                    });
                    t = [];
                }
                for (var a = 0, o = n.length; a < o; a++) {
                    var s = n[a];
                    if (s instanceof Le) {
                        if (t.length >= e.sequences_limit) r();
                        var f = s.body;
                        if (t.length > 0) f = f.drop_side_effect_free(e);
                        if (f) _(t, f);
                    } else if (z(s)) {
                        n[i++] = s;
                    } else {
                        r();
                        n[i++] = s;
                    }
                }
                r();
                n.length = i;
                if (i != o) ce = true;
            }
            function p(e, n) {
                if (!(e instanceof Ge)) return e;
                var t = null;
                for (var i = 0; i < e.body.length; i++) {
                    var r = e.body[i];
                    if (r instanceof qn && m(r)) {
                        n.push(r);
                    } else if (t || r instanceof jn || r instanceof Fn) {
                        return false;
                    } else {
                        t = r;
                    }
                }
                return t;
            }
            function u(e, n) {
                function t(e) {
                    i--;
                    ce = true;
                    var n = r.body;
                    return W(n, [ n, e ]);
                }
                var i = 0, r;
                for (var a = 0; a < e.length; a++) {
                    var o = e[a];
                    if (r) {
                        if (o instanceof gn) {
                            o.value = t(o.value || ve(Et, o)).transform(n);
                        } else if (o instanceof nn) {
                            if (!(o.init instanceof Mn)) {
                                var s = false;
                                r.body.walk(new zt(function(e) {
                                    if (s || e instanceof an) return true;
                                    if (e instanceof Wn && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (o.init) o.init = t(o.init); else {
                                        o.init = r.body;
                                        i--;
                                        ce = true;
                                    }
                                }
                            }
                        } else if (o instanceof tn) {
                            o.object = t(o.object);
                        } else if (o instanceof En) {
                            o.condition = t(o.condition);
                        } else if (o instanceof Sn) {
                            o.expression = t(o.expression);
                        } else if (o instanceof rn) {
                            o.expression = t(o.expression);
                        }
                    }
                    if (n.option("conditionals") && o instanceof En) {
                        var f = [];
                        var u = p(o.body, f);
                        var c = p(o.alternative, f);
                        if (u !== false && c !== false && f.length > 0) {
                            var l = f.length;
                            f.push(ve(En, o, {
                                condition: o.condition,
                                body: u || ve(Ye, o.body),
                                alternative: c
                            }));
                            f.unshift(i, 1);
                            [].splice.apply(e, f);
                            a += l;
                            i += l + 1;
                            r = null;
                            ce = true;
                            continue;
                        }
                    }
                    e[i++] = o;
                    r = o instanceof Le ? o : null;
                }
                e.length = i;
            }
            function c(e, n, t) {
                var i;
                if (n instanceof Gn) {
                    i = [ n ];
                } else if (n instanceof Hn) {
                    i = n.expressions.slice();
                }
                if (!i) return;
                var r = false;
                for (var a = i.length - 1; --a >= 0; ) {
                    var o = i[a];
                    if (!(o instanceof Gn)) continue;
                    if (o.operator != "=") continue;
                    if (!(o.left instanceof _t)) continue;
                    var s = i.slice(a + 1);
                    if (!h(o.left, o.right, s)) continue;
                    r = true;
                    i = i.slice(0, a + 1).concat(s);
                }
                if (e instanceof Mn) {
                    t = t || 0;
                    for (var a = e.definitions.length; --a >= 0; ) {
                        var f = e.definitions[a];
                        if (!f.value) continue;
                        if (h(f.name, f.value, i)) r = true;
                        if (l(f, i, t)) r = true;
                        break;
                    }
                    if (e instanceof qn && d(e.definitions, i, t)) r = true;
                }
                return r && i;
            }
            function l(e, n, t) {
                if (!f.option("conditionals")) return;
                if (e.name instanceof Qn) return;
                var i = false;
                var r = e.name.definition();
                while (n.length > t) {
                    var a = I(f, r, e.value, n[0]);
                    if (!a) break;
                    e.value = a;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function d(e, n, t) {
                var i = false;
                while (n.length > t) {
                    var r = n[0];
                    if (!(r instanceof Gn)) break;
                    if (r.operator != "=") break;
                    var a = r.left;
                    if (!(a instanceof _t)) break;
                    if (K(a)) break;
                    if (a.scope.resolve() !== ue) break;
                    var o = a.definition();
                    if (o.scope !== ue) break;
                    if (o.orig.length > o.eliminated + 1) break;
                    if (o.orig[0].TYPE != "SymbolVar") break;
                    var s = ve(lt, a, a);
                    e.push(ve(Cn, r, {
                        name: s,
                        value: r.right
                    }));
                    o.orig.push(s);
                    o.replaced++;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function h(e, n, t) {
                if (!(n instanceof tt)) return;
                var i = false;
                do {
                    var r = t[0];
                    if (!(r instanceof Gn)) break;
                    if (r.operator != "=") break;
                    if (!(r.left instanceof In)) break;
                    var a = r.left.expression;
                    if (!(a instanceof _t)) break;
                    if (e.name != a.name) break;
                    if (!r.right.is_constant_expression(ue)) break;
                    var o = r.left.property;
                    if (o instanceof Ie) {
                        o = o.evaluate(f);
                    }
                    if (o instanceof Ie) break;
                    o = "" + o;
                    var s = o == "__proto__" || f.has_directive("use strict") ? function(e) {
                        return typeof e.key == "string" && e.key != o;
                    } : function(e) {
                        if (e instanceof ot || e instanceof at) {
                            return typeof e.key == "string" && e.key != o;
                        }
                        return true;
                    };
                    if (!Ce(n.properties, s)) break;
                    n.properties.push(ve(rt, r, {
                        key: o,
                        value: r.right
                    }));
                    t.shift();
                    i = true;
                } while (t.length);
                return i;
            }
            function v(e) {
                var r;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var i = e[n];
                    var a = e[t];
                    if (i instanceof Mn) {
                        if (a && a.TYPE == i.TYPE) {
                            a.definitions = a.definitions.concat(i.definitions);
                            ce = true;
                        } else if (r && r.TYPE == i.TYPE && m(i)) {
                            r.definitions = r.definitions.concat(i.definitions);
                            ce = true;
                        } else {
                            e[++t] = i;
                            if (i instanceof qn) r = i;
                        }
                        continue;
                    } else if (i instanceof gn) {
                        i.value = f(i.value);
                    } else if (i instanceof nn) {
                        var o = c(a, i.init);
                        if (o) {
                            ce = true;
                            i.init = o.length ? W(i.init, o) : null;
                        } else if (a instanceof qn && (!i.init || i.init.TYPE == a.TYPE)) {
                            if (i.init) {
                                a.definitions = a.definitions.concat(i.init.definitions);
                            }
                            r = i.init = a;
                            e[t] = u(i);
                            ce = true;
                            continue;
                        } else if (r && i.init && r.TYPE == i.init.TYPE && m(i.init)) {
                            r.definitions = r.definitions.concat(i.init.definitions);
                            i.init = null;
                            ce = true;
                        } else if (i.init instanceof qn) {
                            r = i.init;
                        }
                    } else if (i instanceof tn) {
                        if (r && r.TYPE == i.init.TYPE) {
                            var s = r.definitions.slice();
                            i.init = i.init.definitions[0].name.convert_symbol(_t, function(e, n) {
                                s.push(ve(Cn, n, {
                                    name: n,
                                    value: null
                                }));
                                n.definition().references.push(e);
                            });
                            r.definitions = s;
                            ce = true;
                        }
                        i.object = f(i.object);
                    } else if (i instanceof En) {
                        i.condition = f(i.condition);
                    } else if (i instanceof Le) {
                        var o = c(a, i.body);
                        if (o) {
                            ce = true;
                            if (!o.length) continue;
                            i.body = W(i.body, o);
                        }
                    } else if (i instanceof Sn) {
                        i.expression = f(i.expression);
                    } else if (i instanceof rn) {
                        i.expression = f(i.expression);
                    }
                    e[++t] = r ? u(i) : i;
                }
                e.length = t + 1;
                function f(e) {
                    var n = c(a, e, 1);
                    if (!n) return e;
                    ce = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return W(e, n);
                }
                function u(e) {
                    return e.transform(new Ct(function(e, n, t) {
                        if (e instanceof Mn) {
                            if (r === e) return e;
                            if (r.TYPE != e.TYPE) return e;
                            var i = this.parent();
                            if (i instanceof tn && i.init === e) return e;
                            if (!m(e)) return e;
                            r.definitions = r.definitions.concat(e.definitions);
                            ce = true;
                            if (i instanceof nn && i.init === e) return null;
                            return t ? $e.skip : ve(Ye, e);
                        }
                        if (e instanceof an) return e;
                        if (!(e instanceof Re)) return e;
                    }));
                }
            }
        }
        function k(r, a, o) {
            if (!(a instanceof Mn || hn(a))) {
                Ie.warn("Dropping unreachable code [{file}:{line},{col}]", a.start);
            }
            var s;
            a.walk(new zt(function(e, n) {
                if (e instanceof Mn) {
                    var t = [];
                    if (e.remove_initializers(r, t)) {
                        Ie.warn("Dropping initialization in unreachable code [{file}:{line},{col}]", e.start);
                    }
                    if (t.length > 0) {
                        e.definitions = t;
                        f(e);
                    }
                    return true;
                }
                if (hn(e)) {
                    f(e);
                    return true;
                }
                if (e instanceof an) return true;
                if (e instanceof Ve) {
                    var i = s;
                    s = [];
                    n();
                    if (s.required) {
                        o.push(ve(Ge, a, {
                            body: s
                        }));
                    } else if (s.length) {
                        [].push.apply(o, s);
                    }
                    s = i;
                    return true;
                }
            }));
            function f(e) {
                if (s) {
                    s.push(e);
                    if (e instanceof jn || e instanceof Fn) s.required = true;
                } else {
                    o.push(e);
                }
            }
        }
        function $(e, n) {
            return e.is_undefined || e instanceof Et || e instanceof Ln && e.operator == "void" && !e.expression.has_side_effects(n);
        }
        (function(e) {
            e(Ie, De);
            e(Kn, Oe);
            e(Gn, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(sn, Oe);
            e(tt, Oe);
            e(wt, Oe);
            e(Hn, function() {
                return this.tail_node().is_truthy();
            });
            e(_t, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = De;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(Ie, Oe);
            e(Kn, De);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof gt) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                    return true;

                  default:
                    return false;
                }
            }
            e(Gn, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(Wn, function() {
                return n(this.operator, this.left, this.right);
            });
            e(gt, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(sn, De);
            e(tt, De);
            e(wt, De);
            e(Hn, function() {
                return this.tail_node().is_negative_zero();
            });
            e(_t, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = Oe;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e(Ln, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            Ie.DEFMETHOD("may_throw_on_access", function(e) {
                return !e.option("pure_getters") || this._dot_throw(e);
            });
            function t(e) {
                return /strict/.test(e.option("pure_getters"));
            }
            e(Ie, t);
            e(Kn, De);
            e(Gn, function(e) {
                if (this.operator != "=") return false;
                var n = this.right;
                if (!n._dot_throw(e)) return false;
                var t = this.left;
                if (!(t instanceof _t)) return true;
                if (n instanceof Wn && n.operator == "||" && t.name == n.left.name) {
                    return n.right._dot_throw(e);
                }
                return true;
            });
            e(Wn, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left._dot_throw(e) || this.right._dot_throw(e);

                  case "||":
                    return this.right._dot_throw(e);

                  default:
                    return false;
                }
            });
            e(Jn, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(gt, De);
            e(Rn, function(e) {
                if (!t(e)) return false;
                var n = this.expression;
                if (n instanceof _t) n = n.fixed_value();
                return !(n instanceof sn && this.property == "prototype");
            });
            e(sn, De);
            e(xt, Oe);
            e(tt, function(e) {
                return t(e) && !Ce(this.properties, function(e) {
                    return e instanceof rt;
                });
            });
            e(Hn, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(_t, function(e) {
                if (this.is_undefined) return true;
                if (!t(e)) return false;
                if (K(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                if (pe(this.definition())) return false;
                var n = this.fixed_value();
                if (!n) return true;
                this._dot_throw = Oe;
                if (n._dot_throw(e)) {
                    delete this._dot_throw;
                    return true;
                }
                this._dot_throw = De;
                return false;
            });
            e(mt, function(e) {
                return t(e) && !this.scope.new;
            });
            e(Ln, function() {
                return this.operator == "void";
            });
            e(Vn, De);
            e(Et, Oe);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(Ie, De);
            e(Kn, Oe);
            e(Gn, function(e) {
                return this.operator != "=" || this.right.is_defined(e);
            });
            e(Wn, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left.is_defined(e) && this.right.is_defined(e);

                  case "||":
                    return this.left.is_truthy() || this.right.is_defined(e);

                  default:
                    return true;
                }
            });
            e(Jn, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(gt, Oe);
            e(sn, Oe);
            e(tt, Oe);
            e(Hn, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(_t, function(e) {
                if (this.is_undefined) return false;
                if (K(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = De;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(Ln, function() {
                return this.operator != "void";
            });
            e(Vn, Oe);
            e(Et, De);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(Ie, De);
            e(Gn, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = qe("in instanceof == != === !== < <= >= >");
            e(Wn, function(e) {
                return n[this.operator] || be[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(Dt, Oe);
            var t = qe("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(Nn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Rn && (t[n.property] || n.property == "test" && n.expression instanceof wt);
            });
            e(Jn, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(Pn, De);
            e(Hn, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(_t, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = De;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var i = qe("! delete");
            e(Ln, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(Ie, De);
            var n = qe("- * / % & | ^ << >> >>>");
            e(Gn, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(Wn, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = qe([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear", "toExponential", "toFixed", "toPrecision" ]);
            e(Nn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Rn && (t[n.property] || K(n.expression) && n.expression.name == "Math");
            });
            e(Jn, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(Pn, De);
            e(yt, Oe);
            e(Hn, function(e) {
                return this.tail_node().is_number(e);
            });
            e(_t, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_number = De;
                var t = n.is_number(e);
                delete this.is_number;
                return t;
            });
            var i = qe("+ - ~ ++ --");
            e(Yn, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(Ie, De);
            e(Gn, function(e) {
                switch (this.operator) {
                  case "+=":
                    if (this.left.is_string(e)) return true;

                  case "=":
                    return this.right.is_string(e);
                }
            });
            e(Wn, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = qe([ "charAt", "substr", "substring", "toLowerCase", "toString", "toUpperCase", "trim" ]);
            e(Nn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Rn && t[n.property];
            });
            e(Jn, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(Hn, function(e) {
                return this.tail_node().is_string(e);
            });
            e(bt, Oe);
            e(_t, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = De;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(Ln, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var be = qe("&& ||");
        function ye(e, n) {
            if (n instanceof Gn) return n.left === e && e;
            if (n instanceof Qn) return e;
            if (n instanceof et) return e;
            if (n instanceof Yn) return Nt[n.operator] && n.expression;
        }
        (function(e) {
            function r(e, n) {
                if (e instanceof Ie) return e.clone(true);
                if (Array.isArray(e)) return ve(Kn, n, {
                    elements: e.map(function(e) {
                        return r(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var i in e) if (Pe(e, i)) {
                        t.push(ve(rt, n, {
                            key: i,
                            value: r(e[i], n)
                        }));
                    }
                    return ve(tt, n, {
                        properties: t
                    });
                }
                return D(e, n);
            }
            function o(e) {
                Ie.warn("global_defs {node} redefined [{file}:{line},{col}]", {
                    node: e,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            on.DEFMETHOD("resolve_defines", function(a) {
                if (!a.option("global_defs")) return this;
                this.figure_out_scope({
                    ie8: a.option("ie8")
                });
                return this.transform(new Ct(function(e) {
                    var n = e._find_defs(a, "");
                    if (!n) return;
                    var t = 0, i = e, r;
                    while (r = this.parent(t++)) {
                        if (!(r instanceof In)) break;
                        if (r.expression !== i) break;
                        i = r;
                    }
                    if (ye(i, r)) {
                        o(e);
                        return;
                    }
                    return n;
                }));
            });
            e(Ie, Te);
            e(Rn, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(ft, function(e) {
                if (!this.definition().global) return;
                if (Pe(e.option("global_defs"), this.name)) o(this);
            });
            e(_t, function(e, n) {
                if (!this.definition().global) return;
                var t = e.option("global_defs");
                var i = this.name + n;
                if (Pe(t, i)) return r(t[i], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function Z(e, n, t) {
            var i = n.print_to_string().length - e.print_to_string().length;
            return i < (t || 0) ? n : e;
        }
        function a(e, n, t) {
            return Z(ve(Le, e, {
                body: e
            }), ve(Le, n, {
                body: n
            }), t).body;
        }
        function ee(e, n, t, i) {
            return (He(e) ? a : Z)(n, t, i);
        }
        function r(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = qe(n[e]);
            });
            return t;
        }
        function s(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof Be)) return t;
            }
        }
        cn.DEFMETHOD("first_statement", function() {
            if (this.value) return ve(bn, this.value, {
                value: this.value
            });
            return s(this.body);
        });
        sn.DEFMETHOD("first_statement", function() {
            return s(this.body);
        });
        function ne(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = D(t, n).optimize(e);
            return ee(e, n, t, e.eval_threshold);
        }
        var c = [ "constructor", "toString", "valueOf" ];
        var g = r({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(c),
            Boolean: c,
            Function: c,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(c),
            Object: c,
            RegExp: [ "exec", "test" ].concat(c),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(c)
        });
        var b = r({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode" ]
        });
        (function(e) {
            e(Ie, De);
            e(gt, Oe);
            e(wt, De);
            var n = qe("! ~ - + void");
            e(Ln, function() {
                return n[this.operator] && this.expression instanceof gt;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant", n);
        });
        (function(e) {
            Ie.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var i = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return i;
                if (!i || i instanceof RegExp) return i;
                if (typeof i == "function" || typeof i == "object") return this;
                return i;
            });
            var u = new zt(function(e) {
                if (e instanceof Gn) c(e.left);
                if (e instanceof Yn && jt[e.operator]) c(e.expression);
            });
            function c(e) {
                if (e instanceof In) {
                    c(e.expression);
                } else if (e instanceof _t) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(Re, function() {
                throw new Error(je("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(fn, Ae);
            e(Ie, Ae);
            e(gt, function() {
                return this.value;
            });
            e(Gn, function(e, n, t, i) {
                var r = this.left;
                if (!n) {
                    if (!(r instanceof _t)) return this;
                    if (!Pe(r, "_eval")) {
                        if (!r.fixed) return this;
                        var a = r.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                        if (a.single_use == "m") return this;
                    }
                }
                var o = this.operator;
                var s;
                if (!Pe(r, "_eval") && r instanceof _t && r.fixed && r.definition().fixed) {
                    s = r;
                } else if (o == "=") {
                    r.walk(u);
                    s = this.right;
                } else {
                    s = ve(Wn, this, {
                        operator: o.slice(0, -1),
                        left: r,
                        right: this.right
                    });
                }
                var f = s._eval(e, n, t, i);
                if (typeof f == "object") return this;
                c(r);
                return f;
            });
            e(Hn, function(e, n, t, i) {
                if (!n) return this;
                var r = this.expressions;
                for (var a = 0, o = r.length - 1; a < o; a++) {
                    r[a].walk(u);
                }
                var s = r[o];
                var f = s._eval(e, n, t, i);
                return f === s ? this : f;
            });
            e(sn, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(Kn, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = [];
                    for (var a = 0; a < this.elements.length; a++) {
                        var o = this.elements[a];
                        if (o instanceof St) return this;
                        var s = o._eval(e, n, t, i);
                        if (o === s) return this;
                        r.push(s);
                    }
                    return r;
                }
                return this;
            });
            e(tt, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = {};
                    for (var a = 0; a < this.properties.length; a++) {
                        var o = this.properties[a];
                        if (!(o instanceof rt)) return this;
                        var s = o.key;
                        if (s instanceof Ie) {
                            s = s._eval(e, n, t, i);
                            if (s === o.key) return this;
                        }
                        if (o.value instanceof dn && typeof Object.prototype[s] == "function") return this;
                        r[s] = o.value._eval(e, n, t, i);
                        if (r[s] === o.value) return this;
                    }
                    return r;
                }
                return this;
            });
            var f = qe("! typeof void");
            e(Ln, function(e, n, t, i) {
                var r = this.expression;
                var a = this.operator;
                if (e.option("typeofs") && a == "typeof" && (r instanceof sn || r instanceof _t && r.fixed_value() instanceof sn)) {
                    return typeof function() {};
                }
                var o = r instanceof _t && r.definition();
                if (!f[a] && !(o && o.fixed)) i++;
                var s = r._eval(e, n, t, i);
                if (s === r) {
                    if (n && a == "void") return;
                    return this;
                }
                switch (a) {
                  case "!":
                    return !s;

                  case "typeof":
                    if (s instanceof RegExp) return this;
                    return typeof s;

                  case "void":
                    return;

                  case "~":
                    return ~s;

                  case "-":
                    return -s;

                  case "+":
                    return +s;

                  case "++":
                  case "--":
                    if (!o) return this;
                    if (!n) {
                        if (o.undeclared) return this;
                        if (o.last_ref !== r) return this;
                    }
                    if (Pe(r, "_eval")) s = +(a[0] + 1) + +s;
                    c(r);
                    return s;
                }
                return this;
            });
            e(Vn, function(e, n, t, i) {
                var r = this.expression;
                if (!(r instanceof _t)) {
                    if (!n) return this;
                } else if (!Pe(r, "_eval")) {
                    if (!r.fixed) return this;
                    if (!n) {
                        var a = r.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                    }
                }
                if (!(r instanceof _t && r.definition().fixed)) i++;
                var o = r._eval(e, n, t, i);
                if (o === r) return this;
                c(r);
                return +o;
            });
            var l = qe("&& || === !==");
            e(Wn, function(e, n, t, i) {
                if (!l[this.operator]) i++;
                var r = this.left._eval(e, n, t, i);
                if (r === this.left) return this;
                if (this.operator == (r ? "||" : "&&")) return r;
                var a = n && !(r && typeof r == "object");
                var o = this.right._eval(e, a, t, i);
                if (o === this.right) return this;
                var s;
                switch (this.operator) {
                  case "&&":
                    s = r && o;
                    break;

                  case "||":
                    s = r || o;
                    break;

                  case "|":
                    s = r | o;
                    break;

                  case "&":
                    s = r & o;
                    break;

                  case "^":
                    s = r ^ o;
                    break;

                  case "+":
                    s = r + o;
                    break;

                  case "-":
                    s = r - o;
                    break;

                  case "*":
                    s = r * o;
                    break;

                  case "/":
                    s = r / o;
                    break;

                  case "%":
                    s = r % o;
                    break;

                  case "<<":
                    s = r << o;
                    break;

                  case ">>":
                    s = r >> o;
                    break;

                  case ">>>":
                    s = r >>> o;
                    break;

                  case "==":
                    s = r == o;
                    break;

                  case "===":
                    s = r === o;
                    break;

                  case "!=":
                    s = r != o;
                    break;

                  case "!==":
                    s = r !== o;
                    break;

                  case "<":
                    s = r < o;
                    break;

                  case "<=":
                    s = r <= o;
                    break;

                  case ">":
                    s = r > o;
                    break;

                  case ">=":
                    s = r >= o;
                    break;

                  case "in":
                    if (o && typeof o == "object" && Pe(o, r)) {
                        s = true;
                        break;
                    }

                  default:
                    return this;
                }
                if (isNaN(s)) return e.find_parent(rn) ? this : s;
                if (e.option("unsafe_math") && !n && s && typeof s == "number" && (this.operator == "+" || this.operator == "-")) {
                    var f = Math.max(0, u(r), u(o));
                    if (f < 16) return +s.toFixed(f);
                }
                return s;
                function u(e) {
                    var n = /(\.[0-9]*)?(e.+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(Jn, function(e, n, t, i) {
                var r = this.condition._eval(e, n, t, i);
                if (r === this.condition) return this;
                var a = r ? this.consequent : this.alternative;
                var o = a._eval(e, n, t, i);
                return o === a ? this : o;
            });
            function o(n, e) {
                var t = n.definition().escaped;
                switch (t.length) {
                  case 0:
                    return true;

                  case 1:
                    var i = false;
                    t[0].walk(new zt(function(e) {
                        if (i) return true;
                        if (e === n) return i = true;
                        if (e instanceof an) return true;
                    }));
                    return i;

                  default:
                    return e <= t.depth;
                }
            }
            e(_t, function(e, n, t, i) {
                var r = this.fixed_value();
                if (!r) return this;
                var a;
                if (Pe(r, "_eval")) {
                    a = r._eval();
                } else {
                    this._eval = Ae;
                    a = r._eval(e, n, t, i);
                    delete this._eval;
                    if (a === r) return this;
                    r._eval = function() {
                        return a;
                    };
                    t.push(r);
                }
                return a && typeof a == "object" && !o(this, i) ? this : a;
            });
            var _ = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var p = r({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var d = qe("global ignoreCase multiline source");
            e(In, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r;
                    var a = this.expression;
                    if (!K(a)) {
                        r = a._eval(e, n, t, i + 1);
                        if (r == null || r === a) return this;
                    }
                    var o = this.property;
                    if (o instanceof Ie) {
                        o = o._eval(e, n, t, i);
                        if (o === this.property) return this;
                    }
                    if (r === undefined) {
                        var s = p[a.name];
                        if (!s || !s[o]) return this;
                        r = _[a.name];
                    } else if (r instanceof RegExp) {
                        if (!d[o]) return this;
                    } else if (typeof r == "object") {
                        if (!Pe(r, o)) return this;
                    } else if (typeof r == "function") switch (o) {
                      case "name":
                        return r.node.name ? r.node.name.name : "";

                      case "length":
                        return r.node.argnames.length;

                      default:
                        return this;
                    }
                    return r[o];
                }
                return this;
            });
            e(Nn, function(a, o, s, f) {
                var e = this.expression;
                var n = e instanceof _t ? e.fixed_value() : e;
                if (n instanceof _n || n instanceof dn) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(a)) return this;
                    if (!Ce(n.argnames, function(e) {
                        return !(e instanceof Qn);
                    })) return this;
                    var r = v(this.args);
                    if (!r && !o) return this;
                    var t = n.first_statement();
                    if (!(t instanceof bn)) {
                        if (o) {
                            var i = false;
                            n.walk(new zt(function(e) {
                                if (i) return true;
                                if (e instanceof bn) {
                                    if (e.value && e.value._eval(a, true, s, f) !== undefined) {
                                        i = true;
                                    }
                                    return true;
                                }
                                if (e instanceof an && e !== n) return true;
                            }));
                            if (!i) return;
                        }
                        return this;
                    }
                    var u = t.value;
                    if (!u) return;
                    var c = [];
                    if (!r || Ce(n.argnames, function(e, n) {
                        var t = r[n];
                        var i = e.definition();
                        if (i.orig[i.orig.length - 1] !== e) return false;
                        i.references.forEach(function(e) {
                            e._eval = function() {
                                return t;
                            };
                            c.push(e);
                        });
                        return true;
                    }) || o) {
                        n.evaluating = true;
                        u = u._eval(a, o, s, f);
                        delete n.evaluating;
                    }
                    c.forEach(function(e) {
                        delete e._eval;
                    });
                    return u === t.value ? this : u;
                } else if (a.option("unsafe") && e instanceof In) {
                    var l = e.property;
                    if (l instanceof Ie) {
                        l = l._eval(a, o, s, f);
                        if (l === e.property) return this;
                    }
                    var u;
                    var p = e.expression;
                    if (K(p)) {
                        var d = b[p.name];
                        if (!d || !d[l]) return this;
                        u = _[p.name];
                    } else {
                        u = p._eval(a, o, s, f + 1);
                        if (u == null || u === p) return this;
                        var h = g[u.constructor.name];
                        if (!h || !h[l]) return this;
                        if (u instanceof RegExp && u.global && !(p instanceof wt)) return this;
                    }
                    var r = v(this.args);
                    if (!r) return this;
                    if (l == "replace" && typeof r[1] == "function") return this;
                    try {
                        return u[l].apply(u, r);
                    } catch (e) {
                        Ie.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this,
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    } finally {
                        if (u instanceof RegExp) u.lastIndex = 0;
                    }
                }
                return this;
                function v(e) {
                    var n = [];
                    for (var t = 0; t < e.length; t++) {
                        var i = e[t];
                        var r = i._eval(a, o, s, f);
                        if (i === r) return;
                        n.push(r);
                    }
                    return n;
                }
            });
            e(Pn, Ae);
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function a(e) {
                return ve(Ln, e, {
                    operator: "!",
                    expression: e
                });
            }
            function r(e, n, t) {
                var i = a(e);
                if (t) {
                    var r = ve(Le, n, {
                        body: n
                    });
                    return Z(i, r) === r ? n : i;
                }
                return Z(i, n);
            }
            e(Ie, function() {
                return a(this);
            });
            e(Re, function() {
                throw new Error("Cannot negate a statement");
            });
            e(cn, function() {
                return a(this);
            });
            e(pn, function() {
                return a(this);
            });
            e(dn, function() {
                return a(this);
            });
            e(Ln, function() {
                if (this.operator == "!") return this.expression;
                return a(this);
            });
            e(Hn, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return W(this, n);
            });
            e(Jn, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return r(this, t, n);
            });
            e(Wn, function(e, n) {
                var t = this.clone(), i = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (i) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (i) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);
                }
                return a(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var p = qe("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        Nn.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (K(n) && p[n.name]) return true;
                if (n instanceof Rn && K(n.expression)) {
                    var t = b[n.expression.name];
                    return t && (t[n.property] || n.expression.name == "Math" && n.property == "random");
                }
            }
            return this.pure || !e.pure_funcs(this);
        });
        Ie.DEFMETHOD("is_call_pure", De);
        Nn.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof Rn)) return false;
            var t = n.expression;
            var i;
            var r = n.property;
            if (t instanceof Kn) {
                i = g.Array;
            } else if (t.is_boolean(e)) {
                i = g.Boolean;
            } else if (t.is_number(e)) {
                i = g.Number;
            } else if (t instanceof wt) {
                i = g.RegExp;
            } else if (t.is_string(e)) {
                i = g.String;
                if (r == "replace") {
                    var a = this.args[1];
                    if (a && !a.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                i = g.Object;
            }
            return i && i[r];
        });
        function d(e) {
            while ((e = e.tail_node()) instanceof _t) {
                e = e.fixed_value();
                if (!e) return true;
            }
            return !(e instanceof Kn || e.TYPE == "Binary" && !be[e.operator] || e instanceof gt || e instanceof sn || e instanceof tt && Ce(e.properties, function(e) {
                return !(e instanceof ot || e instanceof Bn);
            }) || e instanceof mt || e instanceof Yn);
        }
        (function(e) {
            function n(e, n, t) {
                return !Ce(e, t ? function(e) {
                    return e instanceof Bn ? !t(e, n) : !e.has_side_effects(n);
                } : function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function t(e, n) {
                return !e.expression.is_string(n) || e.expression.has_side_effects(n);
            }
            e(Ie, Oe);
            e(Kn, function(e) {
                return n(this.elements, e, t);
            });
            e(Gn, function(e) {
                var n = this.left;
                if (!(n instanceof In)) return true;
                var t = n.expression;
                return !(t instanceof mt) || !t.scope.new || n instanceof Un && n.property.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(Wn, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e) || this.operator == "in" && !we(this.right);
            });
            e(Je, function(e) {
                return n(this.body, e);
            });
            e(Nn, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return n(this.args, e, t);
            });
            e(On, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(Jn, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(gt, De);
            e(Mn, function(e) {
                return n(this.definitions, e);
            });
            e(Zn, function(e) {
                return n(this.elements, e);
            });
            e(et, function(e) {
                return this.key instanceof Ie && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(nt, function(e) {
                return n(this.properties, e);
            });
            e(Rn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(Ye, De);
            e(En, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(Xe, function(e) {
                return this.body.has_side_effects(e);
            });
            e(sn, De);
            e(tt, function(e) {
                return n(this.properties, e, function(e, n) {
                    var t = e.expression;
                    return d(t) || t.has_side_effects(n);
                });
            });
            e(it, function(e) {
                return this.key instanceof Ie && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(Hn, function(e) {
                return n(this.expressions, e);
            });
            e(Le, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Un, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(Sn, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(ft, De);
            e(_t, function(e) {
                return !this.is_declared(e) || !de(this);
            });
            e(mt, De);
            e(An, function(e) {
                return n(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(Yn, function(e) {
                return Nt[this.operator] || this.expression.has_side_effects(e);
            });
            e(Cn, function(e) {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(Ie, Oe);
            e(gt, De);
            e(Ye, De);
            e(sn, De);
            e(ft, De);
            e(mt, De);
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            e(Kn, function(e) {
                return n(this.elements, e);
            });
            e(Gn, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof _t) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(Wn, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e) || this.operator == "in" && !we(this.right);
            });
            e(Je, function(e) {
                return n(this.body, e);
            });
            e(Nn, function(e) {
                if (n(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (this.expression.may_throw(e)) return true;
                return !(this.expression instanceof sn) || n(this.expression.body, e);
            });
            e(On, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(Jn, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(Mn, function(e) {
                return n(this.definitions, e);
            });
            e(Rn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(En, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(Xe, function(e) {
                return this.body.may_throw(e);
            });
            e(tt, function(e) {
                return n(this.properties, e);
            });
            e(it, function(e) {
                return this.key instanceof Ie && this.key.may_throw(e) || this.value.may_throw(e);
            });
            e(bn, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(Hn, function(e) {
                return n(this.expressions, e);
            });
            e(Le, function(e) {
                return this.body.may_throw(e);
            });
            e(Un, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(Sn, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(_t, function(e) {
                return !this.is_declared(e);
            });
            e(An, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : n(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(Yn, function(e) {
                if (this.operator == "typeof" && this.expression instanceof _t) return false;
                return this.expression.may_throw(e);
            });
            e(Cn, function(e) {
                if (!this.value) return false;
                return this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function n(e) {
                for (var n = e.length; --n >= 0; ) if (!e[n].is_constant_expression()) return false;
                return true;
            }
            e(Ie, De);
            e(Kn, function() {
                return n(this.elements);
            });
            e(Wn, function() {
                return this.left.is_constant_expression() && this.right.is_constant_expression() && (this.operator != "in" || we(this.right));
            });
            e(gt, Oe);
            e(sn, function(r) {
                var a = this;
                var o = true;
                var s = [];
                a.walk(new zt(function(e, n) {
                    if (!o) return true;
                    if (e instanceof Ve) {
                        if (e === a) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof _t) {
                        if (a.inlined || e.redef) {
                            o = false;
                            return true;
                        }
                        if (a.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (Ee(t.scope, s)) return true;
                        if (r && !t.redefined()) {
                            var i = r.find_variable(e.name);
                            if (t.undeclared ? !i : i === t) {
                                o = "f";
                                return true;
                            }
                        }
                        o = false;
                        return true;
                    }
                    if (e instanceof mt) {
                        if (s.length == 0 && a instanceof cn) o = false;
                        return true;
                    }
                }));
                return o;
            });
            e(tt, function() {
                return n(this.properties);
            });
            e(it, function() {
                return typeof this.key == "string" && this.value.is_constant_expression();
            });
            e(Yn, function() {
                return this.expression.is_constant_expression();
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function M(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(Re, ze);
            e(mn, Ae);
            function n() {
                var e = this.body.length;
                return e > 0 && M(this.body[e - 1]);
            }
            e(Ge, n);
            e(Tn, n);
            e(En, function() {
                return this.alternative && M(this.body) && M(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var h = qe([ "use asm", "use strict" ]);
        e(Be, function(e, n) {
            if (n.option("directives") && (!h[e.value] || n.has_directive(e.value) !== e)) {
                return ve(Ye, e);
            }
            return e;
        });
        e(Ue, function(e, n) {
            if (n.option("drop_debugger")) return ve(Ye, e);
            return e;
        });
        e(Xe, function(e, n) {
            if (n.option("dead_code") && e.body instanceof xn && n.loopcontrol_target(e.body) === e.body) {
                return ve(Ye, e);
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(Je, function(e, n) {
            e.body = u(e.body, n);
            return e;
        });
        function v(e) {
            switch (e.body.length) {
              case 0:
                return ve(Ye, e);

              case 1:
                var n = e.body[0];
                if (!(n instanceof jn || n instanceof Fn)) return n;
            }
            return e;
        }
        e(Ge, function(e, n) {
            e.body = u(e.body, n);
            return v(e);
        });
        e(cn, function(e, n) {
            if (!n.option("arrows")) return e;
            var t = u(e.value ? [ e.first_statement() ] : e.body, n);
            switch (t.length) {
              case 1:
                var i = t[0];
                if (i instanceof bn) {
                    e.body.length = 0;
                    e.value = i.value;
                    break;
                }

              default:
                e.body = t;
                e.value = null;
                break;
            }
            return e;
        });
        e(dn, function(n, e) {
            n.body = u(n.body, e);
            if (e.option("inline")) for (var t = 0; t < n.body.length; t++) {
                var i = n.body[t];
                if (i instanceof Be) continue;
                if (i instanceof bn) {
                    var r = i.value;
                    if (!r || r.TYPE != "Call") break;
                    if (r.is_expr_pure(e)) break;
                    var a = r.expression;
                    if (a instanceof _t) {
                        if (n.name && n.name.definition() === a.definition()) break;
                        a = a.fixed_value();
                    }
                    if (!(a instanceof _n || a instanceof dn)) break;
                    if (a.uses_arguments) break;
                    if (a === r.expression) {
                        if (a.parent_scope !== n) break;
                        if (!Ce(a.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if (a.contains_this()) break;
                    var o = a.argnames.length;
                    if (o > 0 && e.option("inline") < 2) break;
                    if (o > n.argnames.length) break;
                    if (!Ce(n.argnames, function(e) {
                        return e instanceof pt;
                    })) break;
                    if (!Ce(r.args, function(e) {
                        return !(e instanceof Bn);
                    })) break;
                    for (var s = 0; s < o; s++) {
                        var f = r.args[s];
                        if (!(f instanceof _t)) break;
                        if (f.definition() !== n.argnames[s].definition()) break;
                    }
                    if (s < o) break;
                    for (;s < r.args.length; s++) {
                        if (r.args[s].has_side_effects(e)) break;
                    }
                    if (s < r.args.length) break;
                    if (o < n.argnames.length && !e.drop_fargs(n, e.parent())) {
                        if (!e.drop_fargs(a, r)) break;
                        do {
                            a.argnames.push(a.make_var(pt, a, "argument_" + o));
                        } while (++o < n.argnames.length);
                    }
                    return r.expression;
                }
                break;
            }
            return n;
        });
        an.DEFMETHOD("merge_variables", function(o) {
            if (!o.option("merge_vars")) return;
            var c = this, l = {}, p;
            var s = [], f = [], u = 0;
            var d = new Ne();
            var h = Object.create(null);
            var v = Object.create(null);
            var _ = new zt(function(r, e) {
                if (r instanceof Gn) {
                    var n = r.left;
                    if (n instanceof Qn) {
                        r.right.walk(_);
                        var t = new zt(function(e) {
                            if (e instanceof Qn) return;
                            if (e instanceof et) {
                                if (e.key instanceof Ie) {
                                    w();
                                    e.key.walk(_);
                                    x();
                                    w();
                                    e.value.walk(t);
                                    x();
                                } else {
                                    e.value.walk(t);
                                }
                            } else if (e instanceof _t) {
                                k(e, false, true);
                            } else {
                                e.walk(_);
                            }
                            return true;
                        });
                        n.walk(t);
                        return true;
                    }
                    if (n instanceof _t) {
                        if (r.operator != "=") k(n, true, false);
                        r.right.walk(_);
                        k(n, false, true);
                        return true;
                    }
                    return;
                }
                if (r instanceof Wn) {
                    if (!be[r.operator]) return;
                    r.left.walk(_);
                    w();
                    r.right.walk(_);
                    x();
                    return true;
                }
                if (r instanceof xn) {
                    var i = _.loopcontrol_target(r);
                    if (!(i instanceof Ke)) E(i);
                    return true;
                }
                if (r instanceof Nn) {
                    var a = r.expression;
                    var o = a.tail_node();
                    if (!un(o)) return;
                    if (a !== o) a.expressions.slice(0, -1).forEach(function(e) {
                        e.walk(_);
                    });
                    r.args.forEach(function(e) {
                        e.walk(_);
                    });
                    o.walk(_);
                    return true;
                }
                if (r instanceof Jn) {
                    r.condition.walk(_);
                    w();
                    r.consequent.walk(_);
                    x();
                    w();
                    r.alternative.walk(_);
                    x();
                    return true;
                }
                if (r instanceof kn) {
                    var i = _.loopcontrol_target(r);
                    if (i instanceof Ze) E(i);
                    return true;
                }
                if (r instanceof Ze) {
                    w();
                    l.block = r;
                    l.loop = true;
                    var s = l;
                    r.body.walk(_);
                    if (l.inserted === r) l = s;
                    r.condition.walk(_);
                    x();
                    return true;
                }
                if (r instanceof nn) {
                    if (r.init) r.init.walk(_);
                    w();
                    l.block = r;
                    l.loop = true;
                    if (r.condition) r.condition.walk(_);
                    r.body.walk(_);
                    if (r.step) r.step.walk(_);
                    x();
                    return true;
                }
                if (r instanceof tn) {
                    r.object.walk(_);
                    w();
                    l.block = r;
                    l.loop = true;
                    r.init.walk(_);
                    r.body.walk(_);
                    x();
                    return true;
                }
                if (r instanceof En) {
                    r.condition.walk(_);
                    w();
                    r.body.walk(_);
                    x();
                    if (r.alternative) {
                        w();
                        r.alternative.walk(_);
                        x();
                    }
                    return true;
                }
                if (r instanceof Xe) {
                    w();
                    l.block = r;
                    var s = l;
                    r.body.walk(_);
                    if (l.inserted === r) l = s;
                    x();
                    return true;
                }
                if (r instanceof an) {
                    w();
                    l.block = r;
                    if (r === c) p = l;
                    if (r instanceof sn) {
                        if (r.name) h[r.name.definition().id] = false;
                        var t = r.uses_arguments && !_.has_directive("use strict") ? function(e) {
                            if (e instanceof pt) h[e.definition().id] = false;
                        } : function(e) {
                            if (e instanceof pt) k(e, false, true);
                        };
                        var f = new zt(function(e) {
                            if (e instanceof ft) h[e.definition().id] = false;
                            if (!(e instanceof _t)) return;
                            var n = e.definition();
                            var t = r.variables.get(e.name);
                            if (t && (t === n || n.undeclared || r.parent_scope.find_variable(e.name) === n)) {
                                h[n.id] = false;
                                h[t.id] = false;
                            } else {
                                var i = l;
                                x();
                                k(e, true, false);
                                l = i;
                            }
                            return true;
                        });
                        r.argnames.forEach(function(e) {
                            e.mark_symbol(t, f);
                        });
                    }
                    if (r instanceof cn && r.value) {
                        r.value.walk(_);
                    } else {
                        We(r, _);
                    }
                    x();
                    return true;
                }
                if (r instanceof Sn) {
                    r.expression.walk(_);
                    var s = l;
                    r.body.forEach(function(e) {
                        if (e instanceof Dn) return;
                        e.expression.walk(_);
                        if (s === l) w();
                    });
                    l = s;
                    r.body.forEach(function(e) {
                        w();
                        l.block = r;
                        var n = l;
                        We(e, _);
                        if (l.inserted === r) l = n;
                        x();
                    });
                    return true;
                }
                if (r instanceof _t) {
                    k(r, true, false);
                    return true;
                }
                if (r instanceof An) {
                    w();
                    l.block = r;
                    We(r, _);
                    x();
                    if (r.bcatch) {
                        if (r.bcatch.argname) r.bcatch.argname.mark_symbol(function(e) {
                            if (e instanceof vt) {
                                var n = e.definition();
                                h[n.id] = false;
                                if (n = n.redefined()) h[n.id] = false;
                            }
                        }, _);
                        w();
                        if (r.bfinally) l.block = r.bcatch;
                        We(r.bcatch, _);
                        x();
                    }
                    if (r.bfinally) r.bfinally.walk(_);
                    return true;
                }
                if (r instanceof Yn) {
                    if (!jt[r.operator]) return;
                    var u = r.expression;
                    if (!(u instanceof _t)) return;
                    k(u, true, true);
                    return true;
                }
                if (r instanceof Cn) {
                    if (r.value) r.value.walk(_);
                    r.name.mark_symbol(r.value ? function(e) {
                        if (!(e instanceof ft)) return;
                        if (e instanceof lt) {
                            k(e, false, true);
                        } else {
                            h[e.definition().id] = false;
                        }
                        return true;
                    } : function(e) {
                        if (!(e instanceof ft)) return;
                        var n = e.definition().id;
                        if (!(e instanceof lt)) {
                            h[n] = false;
                        } else if (!(n in h)) {
                            d.add(n, e);
                        } else if (h[n]) {
                            h[n].push(e);
                        }
                        return true;
                    }, _);
                    return true;
                }
                if (r instanceof en) {
                    w();
                    l.block = r;
                    l.loop = true;
                    e();
                    x();
                    return true;
                }
            });
            _.directives = Object.create(o.directives);
            c.walk(_);
            var e = Object.create(null);
            while (s.length && f.length) {
                var n = s.pop();
                var t = n.definition;
                if (!(t.id in v)) continue;
                if (!h[t.id]) continue;
                var i = {
                    start: h[t.id].start
                };
                while (t.id in e) t = e[t.id];
                i.end = h[t.id].end;
                var r = [];
                do {
                    var a = f.pop();
                    if (!a) continue;
                    if (a.index > n.index) continue;
                    var m = a.definition.id;
                    var g = h[m];
                    if (!g) continue;
                    if (i.start.block !== g.start.block || !T(i, g) || i.start.loop && !T(g, i) || !Ce(g, function(e) {
                        return e.scope.find_variable(t.name) === t;
                    })) {
                        r.unshift(a);
                        continue;
                    }
                    var b = [], y = [];
                    g.forEach(function(e) {
                        e.thedef = t;
                        e.name = t.name;
                        if (e instanceof _t) {
                            y.push(e);
                        } else {
                            b.push(e);
                        }
                    });
                    t.orig = b.concat(t.orig);
                    t.references = y.concat(t.references);
                    t.fixed = a.definition.fixed && t.fixed;
                    e[m] = t;
                    break;
                } while (f.length);
                if (r.length) f = f.concat(r);
            }
            function w() {
                l = Object.create(l);
            }
            function x() {
                l = Object.getPrototypeOf(l);
            }
            function k(e, n, t) {
                var i = e.definition(), r;
                if (i.id in h) {
                    var a = h[i.id];
                    if (!a) return;
                    if (a.start.block !== l.block) return h[i.id] = false;
                    a.push(e);
                    a.end = l;
                    if (i.id in v) {
                        f[v[i.id]] = null;
                    } else if (!n) {
                        return;
                    }
                } else if ((r = c.variables.get(i.name)) !== i) {
                    if (r && p === l) h[r.id] = false;
                    return h[i.id] = false;
                } else if (o.exposed(i) || e.name == "arguments") {
                    return h[i.id] = false;
                } else {
                    var a = d.get(i.id) || [];
                    a.push(e);
                    h[i.id] = a;
                    if (!n) {
                        a.start = l;
                        return s.push({
                            index: u++,
                            definition: i
                        });
                    }
                    if (l.block !== c) return h[i.id] = false;
                    a.start = p;
                }
                v[i.id] = f.length;
                f.push({
                    index: u++,
                    definition: i
                });
            }
            function E(e) {
                var n = [];
                while (true) {
                    if (Pe(l, "block")) {
                        var t = l.block;
                        if (t instanceof Xe) t = t.body;
                        if (t === e) break;
                    }
                    n.push(l);
                    x();
                }
                l.inserted = l.block;
                w();
                while (n.length) {
                    var i = n.pop();
                    w();
                    if (Pe(i, "block")) l.block = i.block;
                    if (Pe(i, "loop")) l.loop = i.loop;
                }
            }
            function S(e, n) {
                return e === n || e.isPrototypeOf(n);
            }
            function T(e, n) {
                return S(e.start, e.end) || S(e.start, n.start);
            }
        });
        an.DEFMETHOD("drop_unused", function(k) {
            if (!k.option("unused")) return;
            var d = this;
            var h = !(d instanceof on) || k.toplevel.funcs;
            var E = !(d instanceof on) || k.toplevel.vars;
            var S = /keep_assign/.test(k.option("unused")) ? De : function(e, n) {
                var t, i = false;
                if (e instanceof Gn) {
                    if (e.write_only || e.operator == "=") t = e.left;
                } else if (e instanceof Yn) {
                    if (e.write_only) t = e.expression;
                }
                if (/strict/.test(k.option("pure_getters"))) {
                    while (t instanceof In && !t.expression.may_throw_on_access(k)) {
                        if (t instanceof Un) n.unshift(t.property);
                        t = t.expression;
                        i = true;
                    }
                }
                if (!(t instanceof _t)) return;
                if (k.exposed(t.definition())) return;
                if (!de(t, i)) return;
                return t;
            };
            var T = Object.create(null);
            var v = function(e) {
                v = o(d, 0, Te);
                return v(e);
                function o(e, n, i) {
                    var t = k.parent(n);
                    if (!t) return i;
                    if (t instanceof et) {
                        var r = k.parent(n + 1);
                        if (t.key === e) {
                            var a = k.parent(n + 2);
                            if (a instanceof sn) {
                                return o(a, n + 3, a.argnames.indexOf(r) >= 0 ? function(e) {
                                    var n = i(e);
                                    if (n) return n;
                                    n = a.variables.get(e);
                                    if (n) {
                                        var t = n.orig[0];
                                        if (t instanceof pt || t instanceof ht) return n;
                                    }
                                } : function(e) {
                                    return i(e) || a.variables.get(e);
                                });
                            }
                        }
                        return o(r, n + 2, i);
                    }
                    return o(t, n + 1, t.variables ? function(e) {
                        return i(e) || t.variables.get(e);
                    } : i);
                }
            };
            var D = Object.create(null);
            var _ = [];
            var O = Object.create(null);
            var m = Object.create(null);
            var g = Object.create(null);
            if (d instanceof on && k.top_retain) {
                d.variables.each(function(e) {
                    if (k.top_retain(e) && !(e.id in O)) {
                        O[e.id] = true;
                        _.push(e);
                    }
                });
            }
            var b = new Ne();
            var A = new Ne();
            var y = new Ne();
            var z = this;
            var w = new zt(function(a, e) {
                if (a instanceof sn && a.uses_arguments && !w.has_directive("use strict")) {
                    a.each_argname(function(e) {
                        var n = e.definition();
                        if (!(n.id in O)) {
                            O[n.id] = true;
                            _.push(n);
                        }
                    });
                }
                if (a === d) return;
                if (z === d) {
                    if (hn(a)) {
                        var n = a.name.definition();
                        if (!h && !(n.id in O)) {
                            O[n.id] = true;
                            _.push(n);
                        }
                        y.add(n.id, a);
                        return true;
                    }
                    if (a instanceof Mn) {
                        a.definitions.forEach(function(i) {
                            var r = i.value && (i.name instanceof Qn || i.value.has_side_effects(k));
                            i.name.mark_symbol(function(e) {
                                if (!(e instanceof ft)) return;
                                var n = e.definition();
                                A.add(n.id, i);
                                if (a instanceof qn && n.orig[0] instanceof vt) {
                                    var t = n.redefined();
                                    if (t) A.add(t.id, i);
                                }
                                if (!(n.id in O) && (!E || (a instanceof jn ? n.redefined() : n.const_redefs) || !(a instanceof qn || ie(n)))) {
                                    O[n.id] = true;
                                    _.push(n);
                                }
                                if (i.value) {
                                    if (!r) y.add(n.id, i.value);
                                    b.add(n.id, i);
                                }
                                return true;
                            }, w);
                            if (r) i.value.walk(w);
                        });
                        return true;
                    }
                    if (a instanceof pt) {
                        var n = a.definition();
                        A.add(n.id, a);
                        b.add(n.id, a);
                        return true;
                    }
                }
                return t(a, e, true);
            });
            w.directives = Object.create(k.directives);
            d.walk(w);
            w = new zt(t);
            for (var e = 0; e < _.length; e++) {
                var n = y.get(_[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(w);
                });
            }
            Object.keys(T).forEach(function(e) {
                var t = T[e];
                if (!t) {
                    delete T[e];
                    return;
                }
                t = t.reduce(function(n, e) {
                    e.forEach(function(e) {
                        Me(n, e);
                    });
                    return n;
                }, []);
                var n = (b.get(e) || []).filter(function(n) {
                    return Se(n instanceof Yn ? function(e) {
                        return e === n;
                    } : function(e) {
                        if (e === n) return true;
                        if (e instanceof Yn) return false;
                        return ge(e) === ge(n);
                    }, t);
                });
                if (t.length == n.length) {
                    T[e] = n;
                } else {
                    delete T[e];
                }
            });
            var $ = k.option("keep_fnames") ? De : k.option("ie8") ? function(e) {
                return !k.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                if (!(e.id in O)) return true;
                if (e.orig.length < 2) return false;
                if (e.orig[1] instanceof pt) return true;
                return Ce(e.references, function(e) {
                    return !e.in_arg;
                });
            };
            var M = [];
            var j = [];
            var F = [];
            var q = new Ct(function(e) {
                if (e instanceof Zn) {
                    var n = true;
                    for (var t = e.elements.length; --t >= 0; ) {
                        var i = e.elements[t];
                        if (!(i instanceof ft)) {
                            e.elements[t] = i.transform(q);
                            n = false;
                        } else if (i.definition().id in O) {
                            n = false;
                        } else if (n) {
                            e.elements.pop();
                        } else {
                            e.elements[t] = ve(St, i);
                        }
                    }
                    return e;
                }
                if (e instanceof et) {
                    if (!(e.value instanceof ft)) {
                        e.value = e.value.transform(q);
                        return e;
                    }
                    if (typeof e.key != "string") return e;
                    if (e.value.definition().id in O) return e;
                    return $e.skip;
                }
            });
            var C = new Ct(function(v, e, n) {
                var _ = C.parent();
                if (E) {
                    var t = [], i = S(v, t);
                    if (i) {
                        var r = i.definition();
                        var a = r.id in O;
                        var o;
                        if (v instanceof Gn) {
                            if (!a || v.left === i && R(r, v) < 0) {
                                o = B(v);
                                if (v.write_only === true) {
                                    o = o.drop_side_effect_free(k) || ve(yt, v, {
                                        value: 0
                                    });
                                }
                            }
                        } else if (!a || v.expression === i && R(r, v) < 0) {
                            o = ve(yt, v, {
                                value: 0
                            });
                        }
                        if (o) {
                            if (_ instanceof Hn && _.tail_node() !== v) {
                                o = o.drop_side_effect_free(k);
                            }
                            if (o) t.push(o);
                            switch (t.length) {
                              case 0:
                                return $e.skip;

                              case 1:
                                return _e(k, _, v, t[0].transform(C));

                              default:
                                return W(v, t.map(function(e) {
                                    return e.transform(C);
                                }));
                            }
                        }
                    } else if (v instanceof Vn && v.expression instanceof _t && R(v.expression.definition(), v) < 0) {
                        return ve(Ln, v, {
                            operator: "+",
                            expression: v.expression
                        });
                    }
                }
                if (v instanceof Nn) j.push(v);
                if (z !== d) return;
                if (v instanceof sn) {
                    if (h && v !== d && hn(v)) {
                        var r = v.name.definition();
                        if (!(r.id in O)) {
                            N(v.name, "Dropping unused function {name}");
                            r.eliminated++;
                            return n ? $e.skip : ve(Ye, v);
                        }
                    }
                    if (un(v) && v.name && $(v.name.definition())) {
                        M.push(v);
                    }
                    if (!(v instanceof fn)) {
                        var s = k.drop_fargs(v, _);
                        for (var f = v.argnames, u = f.length; --u >= 0; ) {
                            var i = f[u];
                            if (i instanceof Qn) {
                                i.transform(q);
                                s = false;
                                continue;
                            }
                            var r = i.definition();
                            if (r.id in O) {
                                s = false;
                                if (R(r, i) < 0) i.__unused = null;
                            } else {
                                i.__unused = true;
                                if (s) {
                                    N(i, "Dropping unused function argument {name}");
                                    f.pop();
                                }
                            }
                        }
                        F.push(v);
                    }
                }
                if (v instanceof zn && v.argname instanceof Qn) {
                    v.argname.transform(q);
                }
                if (v instanceof Mn && !(_ instanceof tn && _.init === v)) {
                    var m = [], g = [], b = [];
                    var y = [];
                    var w = 0;
                    var x = v instanceof qn;
                    v.definitions.forEach(function(n) {
                        if (n.value) n.value = n.value.transform(C);
                        if (n.name instanceof Qn) {
                            var s = n.value;
                            var f = new Ct(function(e) {
                                if (e instanceof Zn) {
                                    var n = s;
                                    if (s instanceof _t) s = s.fixed_value();
                                    var i = s instanceof Kn && s.elements;
                                    var t = [];
                                    e.elements.forEach(function(e, n) {
                                        if (e instanceof St) return;
                                        s = i && i[n];
                                        e = e.transform(f);
                                        if (e) t[n] = e;
                                    });
                                    s = n;
                                    if (i && t.length == 0) return null;
                                    for (var r = t.length; --r >= 0; ) {
                                        if (!t[r]) t[r] = ve(St, e.elements[r] || e);
                                    }
                                    e.elements = t;
                                    return e;
                                }
                                if (e instanceof nt) {
                                    var n = s;
                                    if (s instanceof _t) s = s.fixed_value();
                                    var i;
                                    if (s instanceof tt) {
                                        i = Object.create(null);
                                        for (var r = 0; r < s.properties.length; r++) {
                                            var a = s.properties[r];
                                            if (typeof a.key != "string") {
                                                i = null;
                                                break;
                                            }
                                            i[a.key] = a.value;
                                        }
                                    }
                                    var o = [];
                                    e.properties.forEach(function(e) {
                                        var n;
                                        if (e.key instanceof Ie) {
                                            e.key = e.key.transform(C);
                                            s = null;
                                            n = e.key.has_side_effects(k);
                                        } else {
                                            s = i && i[e.key];
                                            n = false;
                                        }
                                        if (n && e.value instanceof ft) {
                                            o.push(e);
                                        } else {
                                            var t = e.value.transform(f);
                                            if (t) {
                                                e.value = t;
                                                o.push(e);
                                            }
                                        }
                                    });
                                    s = n;
                                    if (o.length == 0 && s && !s.may_throw_on_access(k)) {
                                        return null;
                                    }
                                    e.properties = o;
                                    return e;
                                }
                                if (e instanceof ft) {
                                    if (!E) return e;
                                    if (e.definition().id in O) return e;
                                    if (l(e)) return e;
                                    if (x && !de(e)) return e;
                                    return null;
                                }
                            });
                            var e = n.name.transform(f);
                            if (e) {
                                h();
                            } else {
                                s = s.drop_side_effect_free(k);
                                if (s) y.push(s);
                            }
                            return;
                        }
                        var t = n.name.definition();
                        var i = x ? de(n.name) : ie(t);
                        if (!i || !E || t.id in O) {
                            if (n.value && R(t, n) < 0) {
                                var r = n.value.write_only;
                                var s = n.value.drop_side_effect_free(k);
                                if (n.value !== s) {
                                    n.value = s && W(n.value, [ s, ve(yt, n.value, {
                                        value: 0
                                    }) ]);
                                } else if (n.value.write_only !== r) {
                                    n.value.write_only = r;
                                }
                            }
                            var a, o = A.get(t.id);
                            if (!n.value && !(v instanceof Fn)) {
                                if (i && o.length > 1) {
                                    Ie.info("Dropping declaration of variable {name} [{file}:{line},{col}]", P(n.name));
                                    Fe(o, n);
                                    t.eliminated++;
                                } else {
                                    g.push(n);
                                }
                            } else if (k.option("functions") && !k.option("ie8") && !(v instanceof jn || v instanceof Fn) && o.length == 1 && t.assignments == 0 && n.value instanceof dn && (t.references.length ? Ce(t.references, function(e) {
                                return n.value === e.fixed_value();
                            }) : n.value === n.name.fixed_value()) && (!n.value.name || (a = n.value.name.definition()).assignments == 0 && (a.name == n.name.name || Ce(a.references, function(e) {
                                return e.scope.find_variable(n.name.name) === n.name.definition();
                            }))) && d() && p(n.value, n.name.name)) {
                                Ie.warn("Declaring {name} as function [{file}:{line},{col}]", P(n.name));
                                var u = ve(_n, n, n.value);
                                u.name = ve(dt, n.name, n.name);
                                var c = n.name.scope.resolve().def_function(u.name);
                                if (a) a.references.forEach(function(e) {
                                    e.name = c.name;
                                    e.thedef = c;
                                    e.reference({});
                                });
                                m.push(u);
                            } else {
                                if (i && o.length > 1 && t.orig.indexOf(n.name) > t.eliminated) {
                                    Fe(o, n);
                                    w++;
                                }
                                h();
                            }
                        } else if (l(n.name)) {
                            var s = n.value && n.value.drop_side_effect_free(k);
                            if (s) y.push(s);
                            var o = A.get(t.id);
                            if (o.length > 1) {
                                Ie.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", P(n.name));
                                Fe(o, n);
                                t.eliminated++;
                            } else {
                                n.value = null;
                                g.push(n);
                            }
                        } else {
                            var s = n.value && !n.value.single_use && n.value.drop_side_effect_free(k);
                            if (s) {
                                Ie.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", P(n.name));
                                y.push(s);
                            } else {
                                N(n.name, "Dropping unused variable {name}");
                            }
                            t.eliminated++;
                        }
                        function l(e) {
                            var n = e.definition();
                            return n.orig[0] instanceof vt && n.scope.resolve() === e.scope.resolve();
                        }
                        function p(e, n) {
                            var t = e.variables.get(n);
                            return !t || e.name && t === e.name.definition();
                        }
                        function d() {
                            if (k.has_directive("use strict")) return _ instanceof an;
                            return _ instanceof Je || _ instanceof nn && _.init === v || _ instanceof En;
                        }
                        function h() {
                            if (y.length > 0) {
                                if (b.length == 0) {
                                    m.push(ve(Le, v, {
                                        body: W(v, y)
                                    }));
                                } else if (n.value) {
                                    y.push(n.value);
                                    n.value = W(n.value, y);
                                } else {
                                    n.value = ve(Ln, n, {
                                        operator: "void",
                                        expression: W(n, y)
                                    });
                                }
                                y = [];
                            }
                            b.push(n);
                        }
                    });
                    switch (g.length) {
                      case 0:
                        if (b.length == 0) break;
                        if (b.length == w) {
                            [].unshift.apply(y, b.map(function(e) {
                                Ie.warn("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", P(e.name));
                                var n = e.name.definition();
                                var t = ve(_t, e.name, e.name);
                                n.references.push(t);
                                var i = ve(Gn, e, {
                                    operator: "=",
                                    left: t,
                                    right: e.value
                                });
                                var r = R(n, e);
                                if (r >= 0) T[n.id][r] = i;
                                n.eliminated++;
                                return i;
                            }));
                            break;
                        }

                      case 1:
                        if (b.length == 0) {
                            var c = g[0].name.definition().id;
                            if (c in D) {
                                v.definitions = g;
                                D[c].init = v;
                                break;
                            }
                        }

                      default:
                        v.definitions = g.concat(b);
                        m.push(v);
                    }
                    if (y.length > 0) {
                        m.push(ve(Le, v, {
                            body: W(v, y)
                        }));
                    }
                    return H(m, v, n);
                }
                if (v instanceof Xe && v.body instanceof nn) {
                    e(v, C);
                    if (v.body instanceof Ge) {
                        var l = v.body;
                        v.body = l.body.pop();
                        l.body.push(v);
                        return n ? $e.splice(l.body) : l;
                    }
                    return v;
                }
                if (v instanceof an) {
                    var p = z;
                    z = v;
                    e(v, C);
                    z = p;
                    return v;
                }
            }, function(e, n) {
                if (e instanceof Ge) switch (e.body.length) {
                  case 0:
                    return n ? $e.skip : ve(Ye, e);

                  case 1:
                    var t = e.body[0];
                    if (!(t instanceof jn || t instanceof Fn)) return t;
                } else if (e instanceof nn) {
                    var i;
                    if (e.init instanceof Ge) {
                        i = e.init;
                        e.init = i.body.pop();
                        i.body.push(e);
                    }
                    if (e.init instanceof _n) {
                        if (!i) {
                            i = ve(Ge, e, {
                                body: [ e ]
                            });
                        }
                        i.body.splice(-1, 0, e.init);
                        e.init = null;
                    } else if (e.init instanceof Le) {
                        e.init = e.init.body;
                    } else if (G(e.init)) {
                        e.init = null;
                    }
                    return !i ? e : n ? $e.splice(i.body) : i;
                } else if (e instanceof tn) {
                    if (!E || !k.option("loops")) return;
                    if (!G(e.body)) return;
                    var r = Y(e);
                    if (!r) return;
                    var a = r.definition();
                    if (a.id in O) return;
                    N(r, "Dropping unused loop variable {name}");
                    if (D[a.id] === e) delete D[a.id];
                    var o = [];
                    var s = e.object.drop_side_effect_free(k);
                    if (s) {
                        Ie.warn("Side effects in object of for-in loop [{file}:{line},{col}]", s.start);
                        o.push(ve(Le, e, {
                            body: s
                        }));
                    }
                    if (e.init instanceof Mn && a.orig[0] instanceof vt) {
                        o.push(e.init);
                    }
                    return H(o, e, n);
                } else if (e instanceof Hn) {
                    if (e.expressions.length == 1) return e.expressions[0];
                }
            });
            C.push(k.parent());
            d.transform(C);
            if (d instanceof sn && d.body.length == 1 && d.body[0] instanceof Be && d.body[0].value == "use strict") {
                d.body.length = 0;
            }
            M.forEach(function(e) {
                e.name = null;
            });
            j.forEach(function(e) {
                ae(e, k, F);
            });
            function N(e, n) {
                Ie[e.definition().references.length > 0 ? "info" : "warn"](n + " [{file}:{line},{col}]", P(e));
            }
            function P(e) {
                return {
                    name: e.name,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                };
            }
            function H(e, n, t) {
                switch (e.length) {
                  case 0:
                    return t ? $e.skip : ve(Ye, n);

                  case 1:
                    return e[0];

                  default:
                    return t ? $e.splice(e) : ve(Ge, n, {
                        body: e
                    });
                }
            }
            function x(e, n) {
                if (e.scope !== d) return false;
                if (!e.fixed || !n.fixed) T[e.id] = false;
                return T[e.id] !== false;
            }
            function I(e, n) {
                if (!T[e.id]) T[e.id] = [];
                if (n.fixed.assigns) Me(T[e.id], n.fixed.assigns);
            }
            function R(e, n) {
                var t = T[e.id];
                return t && t.indexOf(n);
            }
            function U(e, n, t) {
                if (e.id in O) return;
                if (n && t) {
                    O[e.id] = true;
                    _.push(e);
                } else {
                    m[e.id] = n;
                    g[e.id] = t;
                }
            }
            function B(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof Wn && be[n.operator])) return n;
                if (!(n.left instanceof _t)) return n;
                if (!(e.left instanceof _t)) return n;
                var t = e.left.definition();
                if (n.left.definition() !== t) return n;
                if (n.right.has_side_effects(k)) return n;
                if (x(t, n.left)) I(t, n.left);
                return n.right;
            }
            function Y(e) {
                var n = e.init;
                if (n instanceof Mn) {
                    n = n.definitions[0].name;
                    return n instanceof ft && n;
                }
                while (n instanceof In) n = n.expression.tail_node();
                if (n instanceof _t) return n;
            }
            function t(e, n, t) {
                if (e instanceof Gn && e.left instanceof _t) {
                    var i = e.left.definition();
                    if (i.scope === d) b.add(i.id, e);
                }
                if (e instanceof Yn && e.expression instanceof _t) {
                    var i = e.expression.definition();
                    if (i.scope === d) b.add(i.id, e);
                }
                var r, a = [], o = S(e, a);
                if (o && d.variables.get(o.name) === (r = o.definition()) && !(pe(r) && !Ce(d.argnames, function(e) {
                    return !e.match_symbol(function(e) {
                        if (e instanceof pt) {
                            var n = e.definition();
                            return n.references.length > n.replaced;
                        }
                    }, true);
                }))) {
                    a.forEach(function(e) {
                        e.walk(w);
                    });
                    if (e instanceof Gn) {
                        if (e.write_only === "p" && e.right.may_throw_on_access(k)) return;
                        var s = B(e);
                        if (t && e.write_only === true && r.scope === d && !s.has_side_effects(k)) {
                            y.add(r.id, s);
                        } else {
                            s.walk(w);
                        }
                        if (e.left === o) {
                            if (!e.write_only) {
                                U(r, true, g[r.id]);
                            }
                        } else {
                            var f = o.fixed_value();
                            if (!f || !f.is_constant()) {
                                U(r, m[r.id], true);
                            }
                        }
                    }
                    if (x(r, o) && ye(o, e) !== o) I(r, o);
                    return true;
                }
                if (e instanceof tn) {
                    if (e.init instanceof _t && z === d) {
                        var u = e.init.definition().id;
                        if (!(u in D)) D[u] = e;
                    }
                    if (!E || !k.option("loops")) return;
                    if (!G(e.body)) return;
                    if (e.init.has_side_effects(k)) return;
                    var o = Y(e);
                    if (!o) return;
                    var i = o.definition();
                    if (i.scope !== d) {
                        var c = v(o.name);
                        if ((c && c.redefined() || c) === i) return;
                    }
                    e.object.walk(w);
                    return true;
                }
                if (e instanceof _t) {
                    r = e.definition();
                    if (!(r.id in O)) {
                        O[r.id] = true;
                        _.push(r);
                    }
                    if (L(r.scope, e.scope)) {
                        var l = r.redefined();
                        if (l && !(l.id in O)) {
                            O[l.id] = true;
                            _.push(l);
                        }
                    }
                    if (x(r, e)) I(r, e);
                    return true;
                }
                if (e instanceof an) {
                    var p = z;
                    z = e;
                    n();
                    z = p;
                    return true;
                }
            }
        });
        an.DEFMETHOD("hoist_declarations", function(r) {
            if (r.has_directive("use asm")) return;
            var a = r.option("hoist_funs");
            var o = r.option("hoist_vars");
            var s = this;
            if (o) {
                var n = 0;
                s.walk(new zt(function(e) {
                    if (n > 1) return true;
                    if (e instanceof an && e !== s) return true;
                    if (e instanceof qn) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) o = false;
            }
            if (!a && !o) return;
            var f = [];
            var u = [];
            var c = new Ne(), l = 0;
            var p = new Ct(function(e) {
                if (e === s) return;
                if (e instanceof Be) {
                    f.push(e);
                    return ve(Ye, e);
                }
                if (a && e instanceof _n && (p.parent() === s || !r.has_directive("use strict"))) {
                    u.push(e);
                    return ve(Ye, e);
                }
                if (o && e instanceof qn) {
                    e.definitions.forEach(function(e) {
                        c.set(e.name.name, e);
                        ++l;
                    });
                    var n = e.to_assignments();
                    var t = p.parent();
                    if (t instanceof tn && t.init === e) {
                        if (n) return n;
                        var i = e.definitions[0].name;
                        return ve(_t, i, i);
                    }
                    if (t instanceof nn && t.init === e) return n;
                    if (!n) return ve(Ye, e);
                    return ve(Le, e, {
                        body: n
                    });
                }
                if (e instanceof an) return e;
            });
            s.transform(p);
            if (l > 0) {
                var t = [];
                c.each(function(e, n) {
                    if (s instanceof sn && !Ce(s.argnames, function(e) {
                        return e.name != n;
                    })) {
                        c.del(n);
                    } else {
                        e = e.clone();
                        e.value = null;
                        t.push(e);
                        c.set(n, e);
                    }
                });
                if (t.length > 0) {
                    for (var e = 0; e < s.body.length; ) {
                        if (s.body[e] instanceof Le) {
                            var i = s.body[e].body, d, h;
                            if (i instanceof Gn && i.operator == "=" && (d = i.left) instanceof st && c.has(d.name)) {
                                var v = c.get(d.name);
                                if (v.value) break;
                                v.value = i.right;
                                Fe(t, v);
                                t.push(v);
                                s.body.splice(e, 1);
                                continue;
                            }
                            if (i instanceof Hn && (h = i.expressions[0]) instanceof Gn && h.operator == "=" && (d = h.left) instanceof st && c.has(d.name)) {
                                var v = c.get(d.name);
                                if (v.value) break;
                                v.value = h.right;
                                Fe(t, v);
                                t.push(v);
                                s.body[e].body = W(i, i.expressions.slice(1));
                                continue;
                            }
                        }
                        if (s.body[e] instanceof Ye) {
                            s.body.splice(e, 1);
                            continue;
                        }
                        if (s.body[e] instanceof Ge) {
                            var _ = [ e, 1 ].concat(s.body[e].body);
                            s.body.splice.apply(s.body, _);
                            continue;
                        }
                        break;
                    }
                    t = ve(qn, s, {
                        definitions: t
                    });
                    u.push(t);
                }
            }
            s.body = f.concat(u, s.body);
        });
        function y(n, t) {
            n.walk(new zt(function(e) {
                if (e instanceof bn) {
                    t(e);
                    return true;
                }
                if (e instanceof an && e !== n) return true;
            }));
        }
        function w(e) {
            var i = Object.create(null);
            y(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof _t) {
                    var t = n.definition().id;
                    i[t] = (i[t] || 0) + 1;
                }
            });
            return i;
        }
        function E(e, n, t) {
            return e.bool_fn + (n[e.id] || 0) === e.references.length - e.replaced && !t.exposed(e);
        }
        function S(e, i) {
            y(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = n.is_truthy() || n.evaluate(i, true);
                    if (!t) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? W(e.value, [ n, ve(yt, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (t && !(t instanceof Ie)) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? W(e.value, [ n, ve(yt, e.value, {
                            value: 1
                        }) ]) : ve(yt, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        an.DEFMETHOD("process_boolean_returns", Te);
        _n.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = w(this);
            if (!E(this.name.definition(), n, e)) return;
            S(this, e);
        });
        dn.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = w(this);
            if (this.name && !E(this.name.definition(), n, e)) return;
            var t = e.parent();
            if (t instanceof Gn) {
                if (t.operator != "=") return;
                var i = t.left;
                if (!(i instanceof _t)) return;
                if (!E(i.definition(), n, e)) return;
            } else if (t instanceof Nn && t.expression !== this) {
                var r = t.expression;
                if (r instanceof _t) r = r.fixed_value();
                if (!(r instanceof sn)) return;
                if (r.uses_arguments || r.pinned()) return;
                var i = r.argnames[t.args.indexOf(this)];
                if (i && !E(i.definition(), n, e)) return;
            } else if (t.TYPE == "Call") {
                e.pop();
                var a = e.in_boolean_context();
                e.push(this);
                if (!a) return;
            } else return;
            S(this, e);
        });
        Ve.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = Object.create(null);
                this.enclosed.forEach(function(e) {
                    t[e.name] = true;
                });
                this.variables.each(function(e, n) {
                    t[n] = true;
                });
            }
            return t;
        });
        an.DEFMETHOD("make_var", function(e, n, t) {
            var i = [ this ];
            if (n instanceof ft) n.definition().references.forEach(function(e) {
                var n = e.scope;
                if (Ee(n, i)) return;
                do {
                    Me(i, n);
                    n = n.parent_scope;
                } while (n && n !== this);
            });
            t = t.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/gi, "_");
            var r = t;
            for (var a = 0; !Ce(i, function(e) {
                return !e.var_names()[r];
            }); a++) r = t + "$" + a;
            var o = ve(e, n, {
                name: r,
                scope: this
            });
            var s = this.def_variable(o);
            i.forEach(function(e) {
                e.enclosed.push(s);
                e.var_names()[r] = true;
            });
            return o;
        });
        an.DEFMETHOD("hoist_properties", function(e) {
            if (!e.option("hoist_props") || e.has_directive("use asm")) return;
            var f = this;
            var r = f instanceof on && e.top_retain || De;
            var u = Object.create(null);
            f.transform(new Ct(function(i, e) {
                if (i instanceof Gn) {
                    if (i.operator != "=") return;
                    if (!i.write_only) return;
                    if (i.left.scope !== f) return;
                    if (!t(i.left, i.right, 1)) return;
                    e(i, this);
                    var r = new Ne();
                    var a = [];
                    var o = [];
                    i.right.properties.forEach(function(e) {
                        var n = s(i.left, e.key);
                        o.push(ve(Cn, i, {
                            name: n,
                            value: null
                        }));
                        var t = ve(_t, i, {
                            name: n.name,
                            scope: f,
                            thedef: n.definition()
                        });
                        t.reference({});
                        a.push(ve(Gn, i, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    u[i.left.definition().id] = r;
                    f.body.splice(f.body.indexOf(this.stack[1]) + 1, 0, ve(qn, i, {
                        definitions: o
                    }));
                    return W(i, a);
                }
                if (i instanceof an) return i === f ? undefined : i;
                if (i instanceof Cn) {
                    if (!t(i.name, i.value, 0)) return;
                    e(i, this);
                    var r = new Ne();
                    var n = [];
                    i.value.properties.forEach(function(e) {
                        n.push(ve(Cn, i, {
                            name: s(i.name, e.key),
                            value: e.value
                        }));
                    });
                    u[i.name.definition().id] = r;
                    return $e.splice(n);
                }
                function s(e, n) {
                    var t = f.make_var(lt, e, e.name + "_" + n);
                    r.set(n, t.definition());
                    return t;
                }
            }));
            f.transform(new Ct(function(i, e) {
                if (i instanceof Wn) return a("right");
                if (i instanceof In) {
                    if (!(i.expression instanceof _t)) return;
                    var n = u[i.expression.definition().id];
                    if (!n) return;
                    var t = n.get(i.getProperty());
                    var r = ve(_t, i, {
                        name: t.name,
                        scope: i.expression.scope,
                        thedef: t
                    });
                    r.reference({});
                    return r;
                }
                if (i instanceof Yn) {
                    if (Nt[i.operator]) return;
                    return a("expression");
                }
                function a(e) {
                    var n = i[e];
                    if (!(n instanceof _t)) return;
                    if (!(n.definition().id in u)) return;
                    var t = i.clone();
                    t[e] = ve(tt, n, {
                        properties: []
                    });
                    return t;
                }
            }));
            function t(e, n, t) {
                if (!(e instanceof st)) return;
                var i = e.definition();
                if (i.assignments != t) return;
                if (i.direct_access) return;
                if (i.escaped.depth == 1) return;
                if (i.references.length - i.replaced == t) return;
                if (i.single_use) return;
                if (r(i)) return;
                if (e.fixed_value() !== n) return;
                return n instanceof tt && n.properties.length > 0 && Ce(n.properties, function(e) {
                    return e instanceof rt && typeof e.key == "string";
                }) && Ce(i.references, function(e) {
                    return e.fixed_value() === n;
                }) && de(e);
            }
        });
        function te(e, n) {
            if (!e.name || !n.option("ie8")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return Ce(t.references, function(e) {
                return !(e instanceof _t);
            });
        }
        (function(e) {
            function u(e, n, t, i) {
                var r = e.length;
                if (!r) return null;
                var a = [], o = false;
                for (var s = 0; s < r; s++) {
                    var f = e[s];
                    var u;
                    if (i && f instanceof Bn) {
                        u = i(f, n, t);
                    } else {
                        u = f.drop_side_effect_free(n, t);
                    }
                    if (u !== f) o = true;
                    if (u) {
                        a.push(u);
                        t = false;
                    }
                }
                return o ? a.length ? a : null : e;
            }
            function c(e, n, t) {
                var i = e.expression;
                if (!i.is_string(n)) return e;
                return i.drop_side_effect_free(n, t);
            }
            function l(e) {
                return e instanceof Bn ? ve(Kn, e, {
                    elements: [ e ]
                }) : e;
            }
            e(Ie, Ae);
            e(fn, ze);
            e(Kn, function(e, n) {
                var t = u(this.elements, e, n, c);
                if (!t) return null;
                if (t === this.elements && Ce(t, function(e) {
                    return e instanceof Bn;
                })) return this;
                return W(this, t.map(l));
            });
            e(cn, ze);
            e(Gn, function(e) {
                var n = this.left;
                if (n instanceof In) {
                    var t = n.expression;
                    if (t instanceof Gn && t.operator == "=" && !t.may_throw_on_access(e)) {
                        t.write_only = "p";
                    }
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                this.write_only = true;
                if (me(n).is_constant_expression(e.find_parent(an))) {
                    return this.right.drop_side_effect_free(e);
                }
                return this;
            });
            e(pn, ze);
            e(Wn, function(e, n) {
                if (this.operator == "in" && !we(this.right)) {
                    var t = this.left.drop_side_effect_free(e, n);
                    if (t === this.left) return this;
                    var i = this.clone();
                    i.left = t || ve(yt, this.left, {
                        value: 0
                    });
                    return i;
                }
                var r = this.right.drop_side_effect_free(e, n);
                if (!r) return this.left.drop_side_effect_free(e, n);
                if (be[this.operator] && !(r instanceof dn)) {
                    var i = this;
                    if (r !== i.right) {
                        i = this.clone();
                        i.right = r.drop_side_effect_free(e);
                    }
                    return (n ? a : Z)(i, ve(Wn, this, {
                        operator: i.operator == "&&" ? "||" : "&&",
                        left: i.left.negate(e, n),
                        right: i.right
                    }));
                } else {
                    var t = this.left.drop_side_effect_free(e, n);
                    if (!t) return r;
                    return W(this, [ t, r.drop_side_effect_free(e) ]);
                }
            });
            e(Nn, function(t, e) {
                var n = this;
                if (n.is_expr_pure(t)) {
                    if (n.pure) Ie.warn("Dropping __PURE__ call [{file}:{line},{col}]", n.start);
                    var i = u(n.args, t, e, c);
                    return i && W(n, i.map(l));
                }
                var r = n.expression;
                if (n.is_call_pure(t)) {
                    var a = n.args.slice();
                    a.unshift(r.expression);
                    a = u(a, t, e, c);
                    return a && W(n, a.map(l));
                }
                var o;
                if (r instanceof dn && !(r.name && (o = r.name.definition()).references.length > o.replaced)) {
                    r.process_expression(false, function(e) {
                        var n = e.value && e.value.drop_side_effect_free(t, true);
                        return n ? ve(Le, e, {
                            body: n
                        }) : ve(Ye, e);
                    });
                    y(r, function(e) {
                        if (e.value) e.value = e.value.drop_side_effect_free(t);
                    });
                    n = n.clone();
                    n.expression = r.clone();
                }
                if (n instanceof Pn) {
                    var s = r;
                    if (s instanceof _t) s = s.fixed_value();
                    if (s instanceof sn) {
                        s.new = true;
                        var f = Ce(s.body, function(e) {
                            return !e.has_side_effects(t);
                        });
                        delete s.new;
                        if (f) {
                            var a = n.args.slice();
                            a.unshift(r);
                            a = u(a, t, e, c);
                            return a && W(n, a.map(l));
                        }
                        if (!s.contains_this()) return ve(Nn, n, n);
                    }
                }
                return n;
            });
            e(Jn, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var i;
                if (e.option("ie8")) {
                    i = [];
                    if (n instanceof dn) {
                        i.push(n);
                        n = null;
                    }
                    if (t instanceof dn) {
                        i.push(t);
                        t = null;
                    }
                }
                var r;
                if (!n) {
                    r = t ? ve(Wn, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    r = ve(Wn, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    r = this.clone();
                    r.consequent = n;
                    r.alternative = t;
                }
                if (!e.option("ie8")) return r;
                if (r) i.push(r);
                return i.length == 0 ? null : W(this, i);
            });
            e(gt, ze);
            e(Rn, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(dn, function(e) {
                return te(this, e) ? null : this;
            });
            e(tt, function(e, n) {
                var t = [];
                this.properties.forEach(function(e) {
                    if (e instanceof Bn) {
                        t.push(e);
                    } else {
                        if (e.key instanceof Ie) t.push(e.key);
                        t.push(e.value);
                    }
                });
                var i = u(t, e, n, function(e, n, t) {
                    var i = e.expression;
                    return d(i) ? e : i.drop_side_effect_free(n, t);
                });
                if (!i) return null;
                if (i === t && !Ce(i, function(e) {
                    return !(e instanceof Bn);
                })) return this;
                return W(this, i.map(function(e) {
                    return e instanceof Bn ? ve(tt, e, {
                        properties: [ e ]
                    }) : e;
                }));
            });
            e(Hn, function(e, n) {
                var t = u(this.expressions, e, n);
                if (!t) return null;
                var i = t.length - 1;
                var r, a, o;
                if (e.option("conditionals") && i > 0 && (r = t[i - 1]) instanceof Gn && r.operator == "=" && (o = r.left) instanceof _t && (a = I(e, o.definition(), r.right, t[i]))) {
                    r = r.clone();
                    r.right = a;
                    t = t.slice(0, -2);
                    t.push(r);
                }
                return t === this.expressions ? this : W(this, t);
            });
            e(Un, function(e, n) {
                if (this.expression.may_throw_on_access(e)) return this;
                var t = this.expression.drop_side_effect_free(e, n);
                if (!t) return this.property.drop_side_effect_free(e, n);
                var i = this.property.drop_side_effect_free(e);
                if (!i) return t;
                return W(this, [ t, i ]);
            });
            e(_t, function(e) {
                return this.is_declared(e) && de(this) ? null : this;
            });
            e(mt, ze);
            e(Yn, function(e, n) {
                var t = this.expression;
                if (Nt[this.operator]) {
                    this.write_only = !t.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && t instanceof _t && de(t)) return null;
                var i = t.drop_side_effect_free(e, n);
                if (n && i && X(i)) {
                    if (i === t && this.operator == "!") return this;
                    return i.negate(e, n);
                }
                return i;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(Le, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var i = t.drop_side_effect_free(n, true);
                if (!i) {
                    Ie.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return ve(Ye, e);
                }
                if (i !== t) {
                    return ve(Le, e, {
                        body: i
                    });
                }
            }
            return e;
        });
        e(en, function(e, n) {
            return n.option("loops") ? ve(nn, e, e).optimize(n) : e;
        });
        function j(n, e, t) {
            if (!t) t = wn;
            var i = false;
            var r = new zt(function(e) {
                if (i || e instanceof an) return true;
                if (e instanceof t && r.loopcontrol_target(e) === n) {
                    return i = true;
                }
            });
            if (e instanceof Xe) r.push(e);
            r.push(n);
            n.body.walk(r);
            return i;
        }
        e(Ze, function(t, e) {
            if (!e.option("loops")) return t;
            var n = t.condition.is_truthy() || t.condition.evaluate(e, true);
            if (!(n instanceof Ie)) {
                if (n && !j(t, e.parent(), kn)) return ve(nn, t, {
                    body: ve(Ge, t.body, {
                        body: [ t.body, ve(Le, t.condition, {
                            body: t.condition
                        }) ]
                    })
                }).optimize(e);
                if (!j(t, e.parent())) return ve(Ge, t.body, {
                    body: [ t.body, ve(Le, t.condition, {
                        body: t.condition
                    }) ]
                }).optimize(e);
            }
            if (t.body instanceof Ge && !j(t, e.parent(), kn)) {
                var i = t.body.body;
                for (var r = i.length; --r >= 0; ) {
                    var a = i[r];
                    if (a instanceof En && !a.alternative && a.body instanceof xn && e.loopcontrol_target(a.body) === t) {
                        if (o(a.condition)) break;
                        t.condition = ve(Wn, t, {
                            operator: "&&",
                            left: a.condition.negate(e),
                            right: t.condition
                        });
                        i.splice(r, 1);
                    } else if (a instanceof Le) {
                        if (o(a.body)) break;
                        t.condition = W(t, [ a.body, t.condition ]);
                        i.splice(r, 1);
                    } else if (!z(a)) {
                        break;
                    }
                }
                t.body = v(t.body);
            }
            if (t.body instanceof Ye) return ve(nn, t, t).optimize(e);
            if (t.body instanceof Le) return ve(nn, t, {
                condition: W(t.condition, [ t.body.body, t.condition ]),
                body: ve(Ye, t)
            }).optimize(e);
            return t;
            function o(e) {
                var n = false;
                e.walk(new zt(function(e) {
                    if (n) return true;
                    if (e instanceof _t) {
                        if (!Ee(e.definition(), t.enclosed)) n = true;
                        return true;
                    }
                }));
                return n;
            }
        });
        function F(n, t) {
            var e = o(n.body);
            if (t.option("dead_code") && (e instanceof xn || e instanceof kn && s(e) || e instanceof gn)) {
                var i = [];
                if (n.init instanceof Re) {
                    i.push(n.init);
                } else if (n.init) {
                    i.push(ve(Le, n.init, {
                        body: n.init
                    }));
                }
                var r = s(e) || e instanceof gn;
                if (n.condition && r) {
                    i.push(ve(En, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    i.push(ve(Le, n.condition, {
                        body: n.condition
                    }));
                } else if (r) {
                    i.push(e);
                }
                k(t, n.body, i);
                return ve(Ge, n, {
                    body: i
                });
            }
            if (e instanceof En) {
                var a = o(e.body);
                if (a instanceof xn && !s(a)) {
                    if (n.condition) {
                        n.condition = ve(Wn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var i = O(e.alternative);
                    k(t, e.body, i);
                    return f(i);
                }
                a = o(e.alternative);
                if (a instanceof xn && !s(a)) {
                    if (n.condition) {
                        n.condition = ve(Wn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var i = O(e.body);
                    k(t, e.alternative, i);
                    return f(i);
                }
            }
            return n;
            function o(e) {
                return e instanceof Ge ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof Ge) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = ve(Ge, n.body, {
                        body: e
                    }).transform(t);
                }
                return F(n, t);
            }
        }
        e(nn, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = e.condition.evaluate(n);
                if (t instanceof Ie) {
                    t = e.condition.is_truthy() || e.condition.evaluate(n, true);
                } else if (t) {
                    e.condition = null;
                } else if (!n.option("dead_code")) {
                    var i = e.condition;
                    e.condition = D(t, e.condition);
                    e.condition = Z(e.condition.transform(n), i);
                }
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        if (e.init instanceof Re) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(ve(Le, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(ve(Le, e.condition, {
                            body: e.condition
                        }));
                        k(n, e.body, r);
                        return ve(Ge, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (e.condition && !(t instanceof Ie)) {
                    e.body = ve(Ge, e.body, {
                        body: [ ve(Le, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return F(e, n);
        });
        e(tn, function(e, n) {
            if (n.option("varify") && (e.init instanceof jn || e.init instanceof Fn)) {
                var t = e.init.definitions[0].name;
                if ((t instanceof Qn || t instanceof ct) && !t.match_symbol(function(e) {
                    if (e instanceof ft) return N(n, e.definition());
                })) {
                    e.init = P(e.init);
                }
            }
            return e;
        });
        function q(e, n, t) {
            if (!(e instanceof Wn)) return;
            if (!(e.left instanceof bt)) {
                switch (e.operator) {
                  case "&&":
                    q(e.left, n);
                    q(e.right, n);
                    break;

                  case "||":
                    q(f(e.left), t);
                    q(f(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof Ln)) return;
            if (e.right.operator != "typeof") return;
            var i = e.right.expression;
            if (!K(i)) return;
            var r;
            var a = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                r = a ? t : n;
                break;

              case "!=":
                r = a ? n : t;
                break;

              default:
                return;
            }
            if (!r) return;
            var o = i.definition();
            var s = new zt(function(e) {
                if (e instanceof an) {
                    var n = s.parent();
                    if (n instanceof Nn && n.expression === e) return;
                    return true;
                }
                if (e instanceof _t && e.definition() === o) e.defined = true;
            });
            r.walk(s);
            function f(e) {
                if (!(e instanceof Wn)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        e(En, function(e, f) {
            if (G(e.alternative)) e.alternative = null;
            if (!f.option("conditionals")) return e;
            var n = e.condition.evaluate(f);
            if (!f.option("dead_code") && !(n instanceof Ie)) {
                var t = e.condition;
                e.condition = D(n, t);
                e.condition = Z(e.condition.transform(f), t);
            }
            if (f.option("dead_code")) {
                if (n instanceof Ie) {
                    n = e.condition.is_truthy() || e.condition.evaluate(f, true);
                }
                if (!n) {
                    Ie.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var i = [ ve(Le, e.condition, {
                        body: e.condition
                    }) ];
                    k(f, e.body, i);
                    if (e.alternative) i.push(e.alternative);
                    return ve(Ge, e, {
                        body: i
                    }).optimize(f);
                } else if (!(n instanceof Ie)) {
                    Ie.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var i = [ ve(Le, e.condition, {
                        body: e.condition
                    }), e.body ];
                    if (e.alternative) k(f, e.alternative, i);
                    return ve(Ge, e, {
                        body: i
                    }).optimize(f);
                }
            }
            var r = e.condition.negate(f);
            var a = e.condition.print_to_string().length;
            var o = r.print_to_string().length;
            var s = o < a;
            if (e.alternative && s) {
                s = false;
                e.condition = r;
                var u = e.body;
                e.body = e.alternative || ve(Ye, e);
                e.alternative = u;
            }
            var i = [], c = [], l = [];
            var p = _(e.body, i, c, l);
            var d = _(e.alternative, i, c, l);
            if (p && d) {
                if (c.length > 0) i.push(ve(qn, e, {
                    definitions: c
                }));
                if (p.length == 0) {
                    i.push(ve(Le, e.condition, {
                        body: d.length > 0 ? ve(Wn, e, {
                            operator: "||",
                            left: e.condition,
                            right: W(e.alternative, d)
                        }).transform(f) : e.condition.clone()
                    }).optimize(f));
                } else if (d.length == 0) {
                    if (a === o && !s && e.condition instanceof Wn && e.condition.operator == "||") {
                        s = true;
                    }
                    i.push(ve(Le, e, {
                        body: ve(Wn, e, {
                            operator: s ? "||" : "&&",
                            left: s ? r : e.condition,
                            right: W(e.body, p)
                        }).transform(f)
                    }).optimize(f));
                } else {
                    i.push(ve(Le, e, {
                        body: ve(Jn, e, {
                            condition: e.condition,
                            consequent: W(e.body, p),
                            alternative: W(e.alternative, d)
                        })
                    }).optimize(f));
                }
                l.forEach(function(e) {
                    e.definition().references.push(e);
                });
                return ve(Ge, e, {
                    body: i
                }).optimize(f);
            }
            if (G(e.body)) {
                e = ve(En, e, {
                    condition: r,
                    body: e.alternative,
                    alternative: null
                });
            }
            if (e.body instanceof gn && e.alternative instanceof gn && e.body.TYPE == e.alternative.TYPE) {
                var h = ve(e.body.CTOR, e, {
                    value: ve(Jn, e, {
                        condition: e.condition,
                        consequent: e.body.value || ve(Et, e.body).transform(f),
                        alternative: e.alternative.value || ve(Et, e.alternative).transform(f)
                    })
                });
                if (h instanceof bn) {
                    h.in_bool = e.body.in_bool || e.alternative.in_bool;
                }
                return h;
            }
            if (e.body instanceof En && !e.body.alternative && !e.alternative) {
                e = ve(En, e, {
                    condition: ve(Wn, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (M(e.body)) {
                if (e.alternative) {
                    var v = e.alternative;
                    e.alternative = null;
                    return ve(Ge, e, {
                        body: [ e, v ]
                    }).optimize(f);
                }
            }
            if (M(e.alternative)) {
                var i = e.body;
                e.body = e.alternative;
                e.condition = s ? r : e.condition.negate(f);
                e.alternative = null;
                return ve(Ge, e, {
                    body: [ e, i ]
                }).optimize(f);
            }
            if (f.option("typeofs")) q(e.condition, e.body, e.alternative);
            return e;
            function _(e, n, t, i) {
                if (e == null) return [];
                if (e instanceof Ge) {
                    var r = [];
                    for (var a = 0; a < e.body.length; a++) {
                        var o = e.body[a];
                        if (o instanceof _n) {
                            n.push(o);
                        } else if (o instanceof Ye) {
                            continue;
                        } else if (o instanceof Le) {
                            if (!f.option("sequences") && r.length > 0) return;
                            r.push(o.body);
                        } else if (o instanceof qn) {
                            if (!f.option("sequences") && r.length > 0) return;
                            o.remove_initializers(f, t);
                            o.definitions.forEach(s);
                        } else {
                            return;
                        }
                    }
                    return r;
                }
                if (e instanceof _n) {
                    n.push(e);
                    return [];
                }
                if (e instanceof Ye) return [];
                if (e instanceof Le) return [ e.body ];
                if (e instanceof qn) {
                    var r = [];
                    e.remove_initializers(f, t);
                    e.definitions.forEach(s);
                    return r;
                }
                function s(e) {
                    if (!e.value) return;
                    r.push(ve(Gn, e, {
                        operator: "=",
                        left: e.name.convert_symbol(_t, function(e) {
                            i.push(e);
                        }),
                        right: e.value
                    }));
                }
            }
        });
        e(Sn, function(i, t) {
            if (!t.option("switches")) return i;
            var e;
            var n = i.expression.evaluate(t);
            if (!(n instanceof Ie)) {
                var r = i.expression;
                i.expression = D(n, r);
                i.expression = Z(i.expression.transform(t), r);
            }
            if (!t.option("dead_code")) return i;
            if (n instanceof Ie) {
                n = i.expression.evaluate(t, true);
            }
            var a = [];
            var o = [];
            var s;
            var f;
            for (var u = 0, c = i.body.length; u < c && !f; u++) {
                e = i.body[u];
                if (e instanceof Dn) {
                    var l = o[o.length - 1];
                    if (s || b(e.body[0], t) && (!l || M(l))) {
                        w(e, l);
                        continue;
                    } else {
                        s = e;
                    }
                } else if (!(n instanceof Ie)) {
                    var p = e.expression.evaluate(t);
                    if (!(p instanceof Ie) && p !== n) {
                        w(e, o[o.length - 1]);
                        continue;
                    }
                    if (p instanceof Ie) p = e.expression.evaluate(t, true);
                    if (p === n) {
                        f = e;
                        if (s) {
                            var d = o.indexOf(s);
                            o.splice(d, 1);
                            w(s, o[d - 1]);
                            s = null;
                        }
                    }
                }
                if (M(e)) {
                    var l = o[o.length - 1];
                    if (M(l) && l.body.length == e.body.length && ve(Ge, l, l).equivalent_to(ve(Ge, e, e))) {
                        l.body = [];
                    }
                }
                o.push(e);
            }
            while (u < c) w(i.body[u++], o[o.length - 1]);
            while (e = o[o.length - 1]) {
                var h = e.body[e.body.length - 1];
                if (b(h, t)) e.body.pop();
                if (e === s) {
                    if (!x(e)) break;
                } else if (e.expression.has_side_effects(t)) {
                    break;
                } else if (s) {
                    if (!x(s)) break;
                    if (o[o.length - 2] !== s) break;
                    s.body = s.body.concat(e.body);
                    e.body = [];
                } else if (!x(e)) break;
                w(e);
                if (o.pop() === s) s = null;
            }
            if (o.length == 0) {
                return ve(Ge, i, {
                    body: a.concat(ve(Le, i.expression, {
                        body: i.expression
                    }))
                }).optimize(t);
            }
            o[0].body = a.concat(o[0].body);
            i.body = o;
            if (t.option("conditionals")) switch (o.length) {
              case 1:
                if (!y(o[0])) break;
                var p = o[0].expression;
                var v = o[0].body.slice();
                if (o[0] !== s && o[0] !== f) return ve(En, i, {
                    condition: ve(Wn, i, {
                        operator: "===",
                        left: i.expression,
                        right: p
                    }),
                    body: ve(Ge, i, {
                        body: v
                    }),
                    alternative: null
                }).optimize(t);
                if (p) v.unshift(ve(Le, p, {
                    body: p
                }));
                v.unshift(ve(Le, i.expression, {
                    body: i.expression
                }));
                return ve(Ge, i, {
                    body: v
                }).optimize(t);

              case 2:
                if (!Ee(s, o) || !y(o[1])) break;
                var v = o[0].body.slice();
                var _ = v.length && b(v[v.length - 1], t);
                if (_) v.pop();
                if (!Ce(v, y)) break;
                var m = o[1].body.length && ve(Ge, o[1], o[1]);
                var g = ve(En, i, {
                    condition: ve(Wn, i, o[0] === s ? {
                        operator: "!==",
                        left: i.expression,
                        right: o[1].expression
                    } : {
                        operator: "===",
                        left: i.expression,
                        right: o[0].expression
                    }),
                    body: ve(Ge, o[0], {
                        body: v
                    }),
                    alternative: _ && m || null
                });
                if (!_ && m) g = ve(Ge, i, {
                    body: [ g, m ]
                });
                return g.optimize(t);
            }
            return i;
            function b(e, n) {
                return e instanceof xn && n.loopcontrol_target(e) === i;
            }
            function y(e) {
                var n = false;
                var t = new zt(function(e) {
                    if (n || e instanceof sn || e instanceof Le) return true;
                    if (b(e, t)) n = true;
                });
                t.push(i);
                e.walk(t);
                return !n;
            }
            function w(e, n) {
                if (n && !M(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    k(t, e, a);
                }
            }
        });
        e(An, function(e, n) {
            e.body = u(e.body, n);
            if (n.option("dead_code")) {
                if (x(e) && !(e.bcatch && e.bcatch.argname && e.bcatch.argname.match_symbol(function(e) {
                    return e instanceof vt && !de(e);
                }, true))) {
                    var t = [];
                    if (e.bcatch) {
                        k(n, e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof qn)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    t.unshift(ve(Ge, e, e).optimize(n));
                    if (e.bfinally) {
                        t.push(ve(Ge, e.bfinally, e.bfinally).optimize(n));
                    }
                    return ve(Ge, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && x(e.bfinally)) {
                    var t = ve(Ge, e.bfinally, e.bfinally).optimize(n);
                    t = e.body.concat(t);
                    if (!e.bcatch) return ve(Ge, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        function C(r) {
            return function(n, t) {
                var i = false;
                this.definitions.forEach(function(e) {
                    if (e.value) i = true;
                    e.name.match_symbol(function(e) {
                        if (e instanceof ft) t.push(ve(Cn, e, {
                            name: e,
                            value: r(n, e)
                        }));
                    }, true);
                });
                return i;
            };
        }
        jn.DEFMETHOD("remove_initializers", C(function(e, n) {
            return ve(Et, n).optimize(e);
        }));
        Fn.DEFMETHOD("remove_initializers", C(ze));
        qn.DEFMETHOD("remove_initializers", C(ze));
        Mn.DEFMETHOD("to_assignments", function() {
            var e = this.definitions.reduce(function(e, n) {
                var t = n.name.definition();
                if (n.value) {
                    var i = ve(_t, n.name, n.name);
                    e.push(ve(Gn, n, {
                        operator: "=",
                        left: i,
                        right: n.value
                    }));
                    t.references.push(i);
                }
                t.eliminated++;
                return e;
            }, []);
            if (e.length == 0) return null;
            return W(this, e);
        });
        function ie(e) {
            return e.name != "arguments" && e.orig.length < (e.orig[0] instanceof ht ? 3 : 2);
        }
        function N(e, n) {
            if (e.exposed(n)) return true;
            var t = n.scope.resolve();
            for (var i = n.scope; i !== t; ) {
                i = i.parent_scope;
                if (i.var_names()[n.name]) return true;
            }
        }
        function P(e) {
            return ve(qn, e, {
                definitions: e.definitions.map(function(e) {
                    return ve(Cn, e, {
                        name: e.name.convert_symbol(lt, function(e, n) {
                            var t = e.definition();
                            t.orig[t.orig.indexOf(n)] = e;
                            var i = t.scope.resolve();
                            if (t.scope === i) return;
                            t.scope = i;
                            i.variables.set(t.name, t);
                        }),
                        value: e.value
                    });
                })
            });
        }
        function H(e, t) {
            return t.option("varify") && Ce(e.definitions, function(e) {
                return !e.name.match_symbol(function(e) {
                    if (e instanceof ft) {
                        var n = e.definition();
                        return !e.fixed_value() || !ie(n) || N(t, n);
                    }
                }, true);
            }) ? P(e) : e;
        }
        e(jn, H);
        e(Fn, H);
        function re(e, n) {
            var t = e.expression;
            if (!(t instanceof Hn)) return e;
            var i = t.expressions.slice();
            var r = e.clone();
            r.expression = i.pop();
            i.push(r);
            return W(e, i);
        }
        function ae(e, t, n) {
            var i = e.expression;
            var r = i instanceof _t ? i.fixed_value() : i;
            if (!(r instanceof sn)) return;
            if (r.uses_arguments) return;
            if (r.pinned()) return;
            if (n && n.indexOf(r) < 0) return;
            var a = e.args;
            if (!Ce(a, function(e) {
                return !(e instanceof Bn);
            })) return;
            var o = 0, s = 0;
            var f = r === i && !r.name && t.drop_fargs(r, e) ? function(e, n) {
                if (!e) return true;
                if (e instanceof Zn) {
                    return e.elements.length == 0 && n instanceof Kn;
                }
                if (e instanceof nt) {
                    return e.properties.length == 0 && n && !n.may_throw_on_access(t);
                }
                return e.__unused;
            } : De;
            var u = [];
            for (var c = 0; c < a.length; c++) {
                var l = r.argnames[c];
                if (!l || "__unused" in l) {
                    var p = a[c].drop_side_effect_free(t);
                    if (f(l)) {
                        if (l) r.argnames.splice(c, 1);
                        a.splice(c, 1);
                        if (p) u.push(p);
                        c--;
                        continue;
                    } else if (p) {
                        u.push(p);
                        a[o++] = W(e, u);
                        u = [];
                    } else if (l) {
                        if (u.length) {
                            a[o++] = W(e, u);
                            u = [];
                        } else {
                            a[o++] = ve(yt, a[c], {
                                value: 0
                            });
                            continue;
                        }
                    }
                } else if (l && f(l, a[c])) {
                    var p = a[c].drop_side_effect_free(t);
                    r.argnames.splice(c, 1);
                    a.splice(c, 1);
                    if (p) u.push(p);
                    c--;
                    continue;
                } else {
                    u.push(a[c]);
                    a[o++] = W(e, u);
                    u = [];
                }
                s = o;
            }
            for (;c < r.argnames.length; c++) {
                if (f(r.argnames[c])) r.argnames.splice(c--, 1);
            }
            a.length = s;
            if (!u.length) return;
            var d = W(e, u);
            a.push(a.length < r.argnames.length ? ve(Ln, e, {
                operator: "void",
                expression: d
            }) : d);
        }
        e(Nn, function(u, c) {
            var o = u.expression;
            if (c.option("sequences")) {
                if (o instanceof In) {
                    var e = re(o, c);
                    if (e !== o) {
                        var n = u.clone();
                        n.expression = e.expressions.pop();
                        e.expressions.push(n);
                        return e.optimize(c);
                    }
                } else if (!J(c, o.tail_node())) {
                    var e = re(u, c);
                    if (e !== u) return e.optimize(c);
                }
            }
            if (c.option("unused")) ae(u, c);
            if (c.option("unsafe")) {
                if (K(o)) switch (o.name) {
                  case "Array":
                    if (u.args.length == 1) {
                        var t = u.args[0];
                        if (t instanceof yt) try {
                            var i = t.value;
                            if (i > 6) break;
                            var r = Array(i);
                            for (var a = 0; a < i; a++) r[a] = ve(St, u);
                            return ve(Kn, u, {
                                elements: r
                            });
                        } catch (e) {
                            Ie.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: i,
                                file: u.start.file,
                                line: u.start.line,
                                col: u.start.col
                            });
                            break;
                        }
                        if (!t.is_boolean(c) && !t.is_string(c)) break;
                    }
                    return ve(Kn, u, {
                        elements: u.args
                    });

                  case "Object":
                    if (u.args.length == 0) {
                        return ve(tt, u, {
                            properties: []
                        });
                    }
                    break;

                  case "String":
                    if (u.args.length == 0) return ve(bt, u, {
                        value: ""
                    });
                    if (u.args.length <= 1) return ve(Wn, u, {
                        left: u.args[0],
                        operator: "+",
                        right: ve(bt, u, {
                            value: ""
                        })
                    }).optimize(c);
                    break;

                  case "Number":
                    if (u.args.length == 0) return ve(yt, u, {
                        value: 0
                    });
                    if (u.args.length == 1) return ve(Ln, u, {
                        expression: u.args[0],
                        operator: "+"
                    }).optimize(c);

                  case "Boolean":
                    if (u.args.length == 0) return ve(Ot, u);
                    if (u.args.length == 1) return ve(Ln, u, {
                        expression: ve(Ln, u, {
                            expression: u.args[0],
                            operator: "!"
                        }),
                        operator: "!"
                    }).optimize(c);
                    break;

                  case "RegExp":
                    var s = [];
                    if (Ce(u.args, function(e) {
                        var n = e.evaluate(c);
                        s.unshift(n);
                        return e !== n;
                    })) {
                        try {
                            return ee(c, u, ve(wt, u, {
                                value: RegExp.apply(RegExp, s)
                            }));
                        } catch (e) {
                            Ie.warn("Error converting {expr} [{file}:{line},{col}]", {
                                expr: u,
                                file: u.start.file,
                                line: u.start.line,
                                col: u.start.col
                            });
                        }
                    }
                    break;
                } else if (o instanceof Rn) switch (o.property) {
                  case "toString":
                    if (u.args.length == 0 && !o.expression.may_throw_on_access(c)) {
                        return ve(Wn, u, {
                            left: ve(bt, u, {
                                value: ""
                            }),
                            operator: "+",
                            right: o.expression
                        }).optimize(c);
                    }
                    break;

                  case "join":
                    if (o.expression instanceof Kn) e: {
                        var f;
                        if (u.args.length > 0) {
                            f = u.args[0].evaluate(c);
                            if (f === u.args[0]) break e;
                        }
                        var r = [];
                        var l = [];
                        o.expression.elements.forEach(function(e) {
                            var n = e.evaluate(c);
                            if (n !== e) {
                                l.push(n);
                            } else {
                                if (l.length > 0) {
                                    r.push(ve(bt, u, {
                                        value: l.join(f)
                                    }));
                                    l.length = 0;
                                }
                                r.push(e);
                            }
                        });
                        if (l.length > 0) {
                            r.push(ve(bt, u, {
                                value: l.join(f)
                            }));
                        }
                        if (r.length == 0) return ve(bt, u, {
                            value: ""
                        });
                        if (r.length == 1) {
                            if (r[0].is_string(c)) {
                                return r[0];
                            }
                            return ve(Wn, r[0], {
                                operator: "+",
                                left: ve(bt, u, {
                                    value: ""
                                }),
                                right: r[0]
                            });
                        }
                        if (f == "") {
                            var t;
                            if (r[0].is_string(c) || r[1].is_string(c)) {
                                t = r.shift();
                            } else {
                                t = ve(bt, u, {
                                    value: ""
                                });
                            }
                            return r.reduce(function(e, n) {
                                return ve(Wn, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, t).optimize(c);
                        }
                        var p = u.clone();
                        p.expression = p.expression.clone();
                        p.expression.expression = p.expression.expression.clone();
                        p.expression.expression.elements = r;
                        return ee(c, u, p);
                    }
                    break;

                  case "charAt":
                    if (u.args.length < 2) {
                        var p = ve(Un, u, {
                            expression: o.expression,
                            property: u.args.length ? ve(Wn, u.args[0], {
                                operator: "|",
                                left: ve(yt, u, {
                                    value: 0
                                }),
                                right: u.args[0]
                            }) : ve(yt, u, {
                                value: 0
                            })
                        });
                        p.is_string = Oe;
                        return p.optimize(c);
                    }
                    break;

                  case "apply":
                    if (u.args.length == 2 && u.args[1] instanceof Kn) {
                        var d = u.args[1].elements.slice();
                        d.unshift(u.args[0]);
                        return ve(Nn, u, {
                            expression: ve(Rn, o, {
                                expression: o.expression,
                                property: "call"
                            }),
                            args: d
                        }).optimize(c);
                    }
                    break;

                  case "call":
                    var h = o.expression;
                    if (h instanceof _t) {
                        h = h.fixed_value();
                    }
                    if (h instanceof sn && !h.contains_this()) {
                        return (u.args.length ? W(this, [ u.args[0], ve(Nn, u, {
                            expression: o.expression,
                            args: u.args.slice(1)
                        }) ]) : ve(Nn, u, {
                            expression: o.expression,
                            args: []
                        })).optimize(c);
                    }
                    break;
                }
            }
            if (c.option("unsafe_Function") && K(o) && o.name == "Function") {
                if (u.args.length == 0) return ve(dn, u, {
                    argnames: [],
                    body: []
                }).init_vars(o.scope);
                if (Ce(u.args, function(e) {
                    return e instanceof bt;
                })) {
                    try {
                        var v = "n(function(" + u.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join(",") + "){" + u.args[u.args.length - 1].value + "})";
                        var _ = qt(v);
                        var m = {
                            ie8: c.option("ie8")
                        };
                        _.figure_out_scope(m);
                        var g = new Ht(c.options);
                        _ = _.transform(g);
                        _.figure_out_scope(m);
                        _.compute_char_frequency(m);
                        _.mangle_names(m);
                        var b;
                        _.walk(new zt(function(e) {
                            if (b) return true;
                            if (e instanceof sn) {
                                b = e;
                                return true;
                            }
                        }));
                        var v = Pt();
                        Ge.prototype._codegen.call(b, v);
                        u.args = [ ve(bt, u, {
                            value: b.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join(",")
                        }), ve(bt, u.args[u.args.length - 1], {
                            value: v.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return u;
                    } catch (e) {
                        if (e instanceof Mt) {
                            Ie.warn("Error parsing code passed to new Function [{file}:{line},{col}]", u.args[u.args.length - 1].start);
                            Ie.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var y = o instanceof _t ? o.fixed_value() : o;
            var w = y instanceof cn || y instanceof _n || y instanceof dn;
            var x = w && y.first_statement();
            var k = w && c.option("inline") && !u.is_expr_pure(c) && Ce(y.argnames, function(e) {
                return !(e instanceof Qn);
            }) && Ce(u.args, function(e) {
                return !(e instanceof Bn);
            });
            if (k && x instanceof bn) {
                var E = x.value;
                if (o === y && (!E || E.is_constant_expression() && j(E))) {
                    var d = u.args.concat(E || ve(Et, u));
                    return W(u, d).optimize(c);
                }
            }
            if (w) {
                var S, E, T = false;
                if (k && !y.uses_arguments && !y.pinned() && !(y.name && y instanceof dn) && (o === y || !xe(c, S = o.definition()) && y.is_constant_expression(V(c))) && (E = q(x)) && !y.contains_this()) {
                    var D = o === y || S.single_use && S.references.length - S.replaced == 1;
                    if (N()) {
                        var d = u.args.slice();
                        var O = [];
                        d.push(E.clone(true).transform(new Ct(function(e) {
                            if (e instanceof _t) {
                                var n = e.definition();
                                if (y.variables.get(e.name) !== n) {
                                    O.push(e);
                                    return e;
                                }
                                var t = C(n);
                                var i = d[t];
                                if (!i) return ve(Et, u);
                                d[t] = null;
                                var r = this.parent();
                                return r ? _e(c, r, e, i) : i;
                            }
                        })));
                        var p = W(u, d.filter(function(e) {
                            return e;
                        })).optimize(c);
                        p = _e(c, c.parent(), c.self(), p);
                        if (D || Z(p, u) === p) {
                            O.forEach(function(e) {
                                var n = e.definition();
                                n.references.push(e);
                                if (D) n.replaced++;
                            });
                            return p;
                        }
                    }
                    var A, z, $;
                    if (D && R()) {
                        y._squeezed = true;
                        if (o !== y) y.parent_scope = o.scope;
                        var p = W(u, L()).optimize(c);
                        return _e(c, c.parent(), c.self(), p);
                    }
                }
                if (c.option("side_effects") && Ce(y.body, G) && (y !== o || te(y, c)) && !(y instanceof cn && y.value) && Ce(y.argnames, function(e) {
                    return !(e instanceof Qn);
                })) {
                    var d = u.args.map(function(e) {
                        return e instanceof Bn ? ve(Kn, e, {
                            elements: [ e ]
                        }) : e;
                    });
                    d.push(ve(Et, u));
                    return W(u, d).optimize(c);
                }
            }
            if (c.option("drop_console")) {
                if (o instanceof In) {
                    var M = o.expression;
                    while (M.expression) {
                        M = M.expression;
                    }
                    if (K(M) && M.name == "console") {
                        return ve(Et, u).optimize(c);
                    }
                }
            }
            if (c.option("negate_iife") && c.parent() instanceof Le && X(u)) {
                return u.negate(c, true);
            }
            return ne(c, u);
            function j(e) {
                if (!ln($ || c.find_parent(an))) return true;
                var t = true;
                var i = new zt(function(e) {
                    if (!t) return true;
                    if (e instanceof an) {
                        if (e === y) return;
                        if (e instanceof cn) {
                            for (var n = 0; t && n < e.argnames.length; n++) e.argnames[n].walk(i);
                        } else if (hn(e) && e.name.name == "await") {
                            t = false;
                        }
                        return true;
                    }
                    if (e instanceof st && e.name == "await" && e !== y.name) t = false;
                });
                e.walk(i);
                return t;
            }
            function F(e) {
                if (!e) return ve(Et, u);
                if (e instanceof bn) return e.value || ve(Et, u);
                if (e instanceof Le) return ve(Ln, e, {
                    operator: "void",
                    expression: e.body
                });
            }
            function q(e) {
                var n = y.body.length;
                if (n < 2) {
                    e = F(e);
                    if (e) return e;
                }
                if (c.option("inline") < 3) return false;
                e = null;
                for (var t = 0; t < n; t++) {
                    var i = y.body[t];
                    if (i instanceof qn) {
                        var r = T || !Ce(i.definitions, function(e) {
                            return !e.value;
                        });
                        if (r) {
                            T = true;
                            if (e) return false;
                        }
                    } else if (i instanceof vn || i instanceof _n || i instanceof Ye) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = i;
                    }
                }
                return F(e);
            }
            function C(e) {
                for (var n = y.argnames.length; --n >= 0; ) {
                    if (y.argnames[n].definition() === e) return n;
                }
            }
            function N() {
                if (T) return;
                if (c.option("inline") < 2 && y.argnames.length) return;
                if (!y.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof pt;
                })) return;
                var r = false;
                var a;
                var o = [];
                var s = false;
                var f = true;
                E.walk(new zt(function(e, n) {
                    if (r) return true;
                    if (e instanceof Wn && be[e.operator] || e instanceof Jn) {
                        o = null;
                        return;
                    }
                    if (e instanceof an) return r = true;
                    if (f && e instanceof st && e.name == "await") {
                        if (ln(c.find_parent(an))) return r = true;
                        f = false;
                    }
                    if (e instanceof _t) {
                        var t = e.definition();
                        if (y.variables.get(e.name) !== t) {
                            o = null;
                            return;
                        }
                        if (hn(t.init)) return r = true;
                        if (ye(e, this.parent())) return r = true;
                        var i = C(t);
                        if (!(a < i)) a = i;
                        if (!o) return;
                        if (s) {
                            o = null;
                        } else {
                            o.push(y.argnames[i]);
                        }
                        return;
                    }
                    if (e.has_side_effects(c)) {
                        n();
                        s = true;
                        return true;
                    }
                }));
                if (r) return;
                var e = u.args.length;
                if (o && y.argnames.length >= e) {
                    e = y.argnames.length;
                    while (e-- > a && y.argnames[e] === o.pop()) ;
                    e++;
                }
                var n = s && !o && c.find_parent(an);
                return e <= a || Ce(u.args.slice(a, e), n ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(c);
                });
            }
            function P(e, n) {
                return e[n] || Q[n] || $.var_names()[n];
            }
            function H(e, n, t) {
                for (var i = 0; i < y.argnames.length; i++) {
                    var r = y.argnames[i];
                    if (r.__unused) continue;
                    if (!t || P(e, r.name)) return false;
                    n[r.name] = true;
                    if (z) z.push(r.definition());
                }
                return true;
            }
            function I(n, e, t) {
                for (var i = 0; i < y.body.length; i++) {
                    var r = y.body[i];
                    if (hn(r)) {
                        if (!t || P(e, r.name.name)) return false;
                        if (!Ce(r.enclosed, function(e) {
                            return e.scope === r || !n[e.name];
                        })) return false;
                        continue;
                    }
                    if (!(r instanceof qn)) continue;
                    if (!t) return false;
                    for (var a = r.definitions.length; --a >= 0; ) {
                        var o = r.definitions[a].name;
                        if (P(n, o.name)) return false;
                        if (z) z.push(o.definition());
                    }
                }
                return true;
            }
            function R() {
                var n = Object.create(null);
                var e = 0, t;
                $ = c.self();
                do {
                    if ($.variables) $.variables.each(function(e) {
                        n[e.name] = true;
                    });
                    t = $;
                    $ = c.parent(e++);
                    if ($ instanceof Qe) {
                        z = [];
                    } else if ($ instanceof nn) {
                        if ($.init === t) continue;
                        z = [];
                    } else if ($ instanceof tn) {
                        if ($.init === t) continue;
                        if ($.object === t) continue;
                        z = [];
                    } else if ($ instanceof _t) {
                        if ($.fixed_value() instanceof an) return false;
                    }
                } while (!($ instanceof an));
                A = $.body.indexOf(t) + 1;
                if (!A) return false;
                if (!j(y)) return false;
                var i = o !== y || y.parent_scope.resolve() === $;
                if ($ instanceof on) {
                    if (c.toplevel.vars) {
                        n["arguments"] = true;
                    } else {
                        i = false;
                    }
                }
                var r = c.option("inline");
                var a = Object.create(n);
                if (!H(n, a, r >= 2 && i)) return false;
                if (!I(n, a, r >= 3 && i)) return false;
                return !z || z.length == 0 || !fe(y, z);
            }
            function U(e, n, t, i) {
                var r = t.definition();
                $.variables.set(t.name, r);
                $.enclosed.push(r);
                if (!$.var_names()[t.name]) {
                    $.var_names()[t.name] = true;
                    e.push(ve(Cn, t, {
                        name: t,
                        value: null
                    }));
                }
                if (!i) return;
                var a = ve(_t, t, t);
                r.references.push(a);
                n.push(ve(Gn, u, {
                    operator: "=",
                    left: a,
                    right: i
                }));
            }
            function B(e, n) {
                var t = y.argnames.length;
                for (var i = u.args.length; --i >= t; ) {
                    n.push(u.args[i]);
                }
                for (i = t; --i >= 0; ) {
                    var r = y.argnames[i];
                    var a = u.args[i];
                    if (r.__unused || $.var_names()[r.name]) {
                        if (a) n.push(a);
                    } else {
                        var o = ve(lt, r, r);
                        r.definition().orig.push(o);
                        if (!a && z) a = ve(Et, u);
                        if ("__unused" in r) {
                            U(e, n, o);
                            if (a) n.push(a);
                        } else {
                            U(e, n, o, a);
                        }
                    }
                }
                e.reverse();
                n.reverse();
            }
            function Y(e, n) {
                var t = n.length;
                for (var i = 0; i < y.body.length; i++) {
                    var r = y.body[i];
                    if (!(r instanceof qn)) continue;
                    for (var a = 0; a < r.definitions.length; a++) {
                        var o = r.definitions[a];
                        var s = o.name;
                        var f = s.definition().redefined();
                        if (f) {
                            s = s.clone();
                            s.thedef = f;
                        }
                        U(e, n, s, o.value);
                        if (z && Ce(y.argnames, function(e) {
                            return e.name != s.name;
                        })) {
                            var u = y.variables.get(s.name);
                            var c = ve(_t, s, s);
                            u.references.push(c);
                            n.splice(t++, 0, ve(Gn, o, {
                                operator: "=",
                                left: c,
                                right: ve(Et, s)
                            }));
                        }
                    }
                }
            }
            function L() {
                var e = [];
                var n = [];
                B(e, n);
                Y(e, n);
                n.push(E);
                var t = y.body.filter(function(e) {
                    if (hn(e)) {
                        var n = e.name.definition();
                        $.functions.set(n.name, n);
                        $.variables.set(n.name, n);
                        $.enclosed.push(n);
                        $.var_names()[n.name] = true;
                        return true;
                    }
                });
                t.unshift(A, 0);
                if (e.length) t.push(ve(qn, y, {
                    definitions: e
                }));
                [].splice.apply($.body, t);
                y.enclosed.forEach(function(e) {
                    if ($.var_names()[e.name]) return;
                    $.enclosed.push(e);
                    $.var_names()[e.name] = true;
                });
                return n;
            }
        });
        e(Pn, function(e, n) {
            if (n.option("sequences")) {
                var t = re(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unsafe")) {
                var i = e.expression;
                if (K(i)) {
                    switch (i.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return ve(Nn, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        function I(t, i, e, n) {
            if (!(n instanceof Wn)) return;
            if (!be[n.operator]) return;
            if (!(n.right instanceof Gn)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof _t)) return;
            if (n.right.left.definition() !== i) return;
            if (e.has_side_effects(t)) return;
            if (!r(n.left)) return;
            if (!r(n.right.right)) return;
            i.replaced++;
            return n.operator == "&&" ? ve(Jn, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : ve(Jn, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function r(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new zt(function(e) {
                    if (n) return true;
                    if (e instanceof _t && e.definition() === i) return n = true;
                }));
                return !n;
            }
        }
        e(Hn, function(e, a) {
            var r = n();
            var o = r.length - 1;
            i();
            t();
            if (o == 0) {
                e = _e(a, a.parent(), a.self(), r[0]);
                if (!(e instanceof Hn)) e = e.optimize(a);
                return e;
            }
            e.expressions = r;
            return e;
            function n() {
                if (!a.option("side_effects")) return e.expressions;
                var t = [];
                var i = He(a);
                var r = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < r) e = e.drop_side_effect_free(a, i);
                    if (e) {
                        _(t, e);
                        i = false;
                    }
                });
                return t;
            }
            function t() {
                if (!a.option("side_effects")) return;
                while (o > 0 && $(r[o], a)) o--;
                if (o < r.length - 1) {
                    r[o] = ve(Ln, e, {
                        operator: "void",
                        expression: r[o]
                    });
                    r.length = o + 1;
                }
            }
            function i() {
                if (!a.option("conditionals")) return;
                for (var e = 1; e < o; e++) {
                    var n = r[e - 1];
                    if (!(n instanceof Gn)) continue;
                    if (n.operator != "=") continue;
                    if (!(n.left instanceof _t)) continue;
                    var t = n.left.definition();
                    var i = I(a, t, n.right, r[e]);
                    if (!i) continue;
                    n.right = i;
                    r.splice(e, 1);
                    o--;
                }
            }
        });
        e(Vn, function(e, n) {
            if (n.option("sequences")) {
                var t = re(e, n);
                if (t !== e) return t.optimize(n);
            }
            return ne(n, e);
        });
        var R = qe("+ -");
        var U = qe("* / %");
        e(Ln, function(e, n) {
            var t = e.operator;
            var i = e.expression;
            if (n.option("evaluate") && t == "delete" && !(i instanceof _t || i instanceof In || o(i))) {
                if (i instanceof Hn) {
                    i = i.expressions.slice();
                    i.push(ve(At, e));
                    return W(e, i).optimize(n);
                }
                return W(e, [ i, ve(At, e) ]).optimize(n);
            }
            if (n.option("sequences") && !(t == "typeof" && K(i.tail_node()))) {
                var r = re(e, n);
                if (r !== e) return r.optimize(n);
            }
            if (n.option("side_effects") && t == "void") {
                i = i.drop_side_effect_free(n);
                if (!i) return ve(Et, e).optimize(n);
                e.expression = i;
                return e;
            }
            if (n.option("booleans")) {
                if (t == "!" && i.is_truthy()) {
                    return W(e, [ i, ve(Ot, e) ]).optimize(n);
                } else if (n.in_boolean_context()) switch (t) {
                  case "!":
                    if (i instanceof Ln && i.operator == "!") {
                        return i.expression;
                    }
                    if (i instanceof Wn) {
                        e = ee(n, e, i.negate(n, He(n)));
                    }
                    break;

                  case "typeof":
                    Ie.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                    var a = [ ve(At, e) ];
                    if (!(i instanceof _t && de(i))) a.unshift(i);
                    return W(e, a).optimize(n);
                }
            }
            if (t == "-" && i instanceof Tt) i = i.transform(n);
            if (n.option("evaluate") && i instanceof Wn && R[t] && U[i.operator] && (i.left.is_constant() || !i.right.has_side_effects(n))) {
                return ve(Wn, e, {
                    operator: i.operator,
                    left: ve(Ln, i.left, {
                        operator: t,
                        expression: i.left
                    }),
                    right: i.right
                });
            }
            return t == "-" && (i instanceof yt || i instanceof Tt) ? e : ne(n, e);
        });
        Wn.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof In) {
                if (!(this.left.expression instanceof Hn)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return W(this, n);
            }
            if (this.left instanceof Hn) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return W(this, n);
            }
            if (this.right instanceof Hn) {
                if (this.left.has_side_effects(e)) return this;
                var i = this.operator == "=" && this.left instanceof _t;
                var n = this.right.expressions;
                var r = n.length - 1;
                for (var a = 0; a < r; a++) {
                    if (!i && n[a].has_side_effects(e)) break;
                }
                if (a == r) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return W(this, n);
                }
                if (a > 0) {
                    var t = this.clone();
                    t.right = W(this.right, n.slice(a));
                    n = n.slice(0, a);
                    n.push(t);
                    return W(this, n);
                }
            }
            return this;
        });
        var B = qe("indexOf lastIndexOf");
        var Y = qe("== === != !== * & | ^");
        function we(e) {
            if (e instanceof Gn) return e.operator == "=" && we(e.right);
            if (e instanceof Hn) return we(e.tail_node());
            if (e instanceof _t) return we(e.fixed_value());
            return e instanceof Kn || e instanceof sn || e instanceof Pn || e instanceof tt;
        }
        function oe(e, n) {
            if (n instanceof Rn) return oe(e, n.expression);
            if (n instanceof Un) {
                return oe(e, n.expression) && oe(e, n.property);
            }
            if (n instanceof st) return true;
            return !n.has_side_effects(e);
        }
        e(Wn, function(i, o) {
            function t() {
                return i.left.is_constant() || i.right.is_constant() || !i.left.has_side_effects(o) && !i.right.has_side_effects(o);
            }
            function e(e) {
                if (t()) {
                    if (e) i.operator = e;
                    var n = i.left;
                    i.left = i.right;
                    i.right = n;
                }
            }
            function n() {
                var e = i.right;
                i.left = ve(Wn, i, {
                    operator: i.operator,
                    left: i.left,
                    right: e.left,
                    start: i.left.start,
                    end: e.left.end
                });
                i.right = e.right;
                i.left = i.left.transform(o);
            }
            if (Y[i.operator] && i.right.is_constant() && !i.left.is_constant() && !(i.left instanceof Wn && Ft[i.left.operator] >= Ft[i.operator])) {
                e();
            }
            if (o.option("sequences")) {
                var r = i.lift_sequences(o);
                if (r !== i) return r.optimize(o);
            }
            if (o.option("assignments") && be[i.operator]) {
                var a = i.right;
                if (i.left instanceof _t && a instanceof Gn && a.operator == "=" && i.left.equivalent_to(a.left)) {
                    i.right = a.right;
                    a.right = i;
                    return a;
                }
            }
            if (o.option("comparisons")) switch (i.operator) {
              case "===":
              case "!==":
                if ($(i.left, o) && i.right.is_defined(o)) {
                    Ie.warn("Expression always defined [{file}:{line},{col}]", i.start);
                    return W(i, [ i.right, ve(i.operator == "===" ? Ot : At, i) ]).optimize(o);
                }
                var s = true;
                if (i.left.is_string(o) && i.right.is_string(o) || i.left.is_number(o) && i.right.is_number(o) || i.left.is_boolean(o) && i.right.is_boolean(o) || oe(o, i.left) && i.left.equivalent_to(i.right)) {
                    i.operator = i.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!s && $(i.left, o)) {
                    i.left = ve(xt, i.left);
                } else if (o.option("typeofs") && i.left instanceof bt && i.left.value == "undefined" && i.right instanceof Ln && i.right.operator == "typeof") {
                    var f = i.right.expression;
                    if (f instanceof _t ? f.is_declared(o) : !(f instanceof In && o.option("ie8"))) {
                        i.right = f;
                        i.left = ve(Et, i.left).optimize(o);
                        if (i.operator.length == 2) i.operator += "=";
                    }
                } else if (i.left instanceof _t && i.right instanceof _t && i.left.definition() === i.right.definition() && we(i.left)) {
                    return ve(i.operator[0] == "=" ? At : Ot, i).optimize(o);
                }
                break;

              case "&&":
              case "||":
                var u = i.left;
                if (u.operator == i.operator) {
                    u = u.right;
                }
                if (u instanceof Wn && u.operator == (i.operator == "&&" ? "!==" : "===") && i.right instanceof Wn && u.operator == i.right.operator && ($(u.left, o) && i.right.left instanceof xt || u.left instanceof xt && $(i.right.left, o)) && !u.right.has_side_effects(o) && u.right.equivalent_to(i.right.right)) {
                    var c = ve(Wn, i, {
                        operator: u.operator.slice(0, -1),
                        left: ve(xt, i),
                        right: u.right
                    });
                    if (u !== i.left) {
                        c = ve(Wn, i, {
                            operator: i.operator,
                            left: i.left.left,
                            right: c
                        });
                    }
                    return c;
                }
                break;
            }
            var l = o.option("booleans") && o.in_boolean_context();
            if (l) switch (i.operator) {
              case "+":
                var p = i.left.evaluate(o);
                var d = i.right.evaluate(o);
                if (p && typeof p == "string") {
                    Ie.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return W(i, [ i.right, ve(At, i) ]).optimize(o);
                }
                if (d && typeof d == "string") {
                    Ie.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return W(i, [ i.left, ve(At, i) ]).optimize(o);
                }
                break;

              case "==":
                if (i.left instanceof bt && i.left.value == "" && i.right.is_string(o)) {
                    return ve(Ln, i, {
                        operator: "!",
                        expression: i.right
                    }).optimize(o);
                }
                break;

              case "!=":
                if (i.left instanceof bt && i.left.value == "" && i.right.is_string(o)) {
                    return i.right.optimize(o);
                }
                break;
            }
            var h = o.parent();
            if (o.option("comparisons") && i.is_boolean(o)) {
                if (!(h instanceof Wn) || h instanceof Gn) {
                    var v = ee(o, i, ve(Ln, i, {
                        operator: "!",
                        expression: i.negate(o, He(o))
                    }));
                    if (v !== i) return v;
                }
                switch (i.operator) {
                  case ">":
                    e("<");
                    break;

                  case ">=":
                    e("<=");
                    break;
                }
            }
            if (o.option("conditionals") && be[i.operator] && i.right instanceof Wn && i.operator == i.right.operator) {
                n();
            }
            if (o.option("strings") && i.operator == "+") {
                if (i.right instanceof bt && i.right.value == "" && i.left.is_string(o)) {
                    return i.left.optimize(o);
                }
                if (i.left instanceof bt && i.left.value == "" && i.right.is_string(o)) {
                    return i.right.optimize(o);
                }
                if (i.left instanceof Wn && i.left.operator == "+" && i.left.left instanceof bt && i.left.left.value == "" && i.right.is_string(o)) {
                    i.left = i.left.right;
                    return i.optimize(o);
                }
                if (i.right instanceof Wn && i.operator == i.right.operator && (i.left.is_string(o) && i.right.is_string(o) || i.right.left.is_string(o) && (i.left.is_constant() || !i.right.right.has_side_effects(o)))) {
                    n();
                }
            }
            if (o.option("evaluate")) {
                var _ = true;
                switch (i.operator) {
                  case "&&":
                    var p = T(i.left);
                    if (!p) {
                        Ie.warn("Condition left of && always false [{file}:{line},{col}]", i.start);
                        return _e(o, h, o.self(), i.left).optimize(o);
                    } else if (!(p instanceof Ie)) {
                        Ie.warn("Condition left of && always true [{file}:{line},{col}]", i.start);
                        return W(i, [ i.left, i.right ]).optimize(o);
                    }
                    var d = i.right.evaluate(o);
                    if (!d) {
                        if (l) {
                            Ie.warn("Boolean && always false [{file}:{line},{col}]", i.start);
                            return W(i, [ i.left, ve(Ot, i) ]).optimize(o);
                        } else i.falsy = true;
                    } else if (!(d instanceof Ie)) {
                        if (l || h.operator == "&&" && h.left === o.self()) {
                            Ie.warn("Dropping side-effect-free && [{file}:{line},{col}]", i.start);
                            return i.left.optimize(o);
                        }
                    }
                    if (i.left.operator == "||") {
                        var m = i.left.right.evaluate(o, true);
                        if (!m) return ve(Jn, i, {
                            condition: i.left.left,
                            consequent: i.right,
                            alternative: i.left.right
                        }).optimize(o);
                    }
                    break;

                  case "||":
                    var p = T(i.left);
                    if (!p) {
                        Ie.warn("Condition left of || always false [{file}:{line},{col}]", i.start);
                        return W(i, [ i.left, i.right ]).optimize(o);
                    } else if (!(p instanceof Ie)) {
                        Ie.warn("Condition left of || always true [{file}:{line},{col}]", i.start);
                        return _e(o, h, o.self(), i.left).optimize(o);
                    }
                    var d = i.right.evaluate(o);
                    if (!d) {
                        if (l || h.operator == "||" && h.left === o.self()) {
                            Ie.warn("Dropping side-effect-free || [{file}:{line},{col}]", i.start);
                            return i.left.optimize(o);
                        }
                    } else if (!(d instanceof Ie)) {
                        if (l) {
                            Ie.warn("Boolean || always true [{file}:{line},{col}]", i.start);
                            return W(i, [ i.left, ve(At, i) ]).optimize(o);
                        } else i.truthy = true;
                    }
                    if (i.left.operator == "&&") {
                        var m = i.left.right.is_truthy() || i.left.right.evaluate(o, true);
                        if (m && !(m instanceof Ie)) return ve(Jn, i, {
                            condition: i.left.left,
                            consequent: i.left.right,
                            alternative: i.right
                        }).optimize(o);
                    }
                    break;

                  case "+":
                    if (i.left instanceof gt && i.right instanceof Wn && i.right.operator == "+" && i.right.left instanceof gt && i.right.is_string(o)) {
                        i = ve(Wn, i, {
                            operator: "+",
                            left: ve(bt, i.left, {
                                value: "" + i.left.value + i.right.left.value,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                    }
                    if (i.right instanceof gt && i.left instanceof Wn && i.left.operator == "+" && i.left.right instanceof gt && i.left.is_string(o)) {
                        i = ve(Wn, i, {
                            operator: "+",
                            left: i.left.left,
                            right: ve(bt, i.right, {
                                value: "" + i.left.right.value + i.right.value,
                                start: i.left.right.start,
                                end: i.right.end
                            })
                        });
                    }
                    if (i.right instanceof Ln && i.right.operator == "-" && i.left.is_number(o)) {
                        i = ve(Wn, i, {
                            operator: "-",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }
                    if (i.left instanceof Ln && i.left.operator == "-" && t() && i.right.is_number(o)) {
                        i = ve(Wn, i, {
                            operator: "-",
                            left: i.right,
                            right: i.left.expression
                        });
                        break;
                    }
                    if (o.option("unsafe_math") && i.left instanceof Wn && Ft[i.left.operator] == Ft[i.operator] && i.right.is_constant() && (i.right.is_boolean(o) || i.right.is_number(o)) && i.left.is_number(o) && !i.left.right.is_constant() && (i.left.left.is_boolean(o) || i.left.left.is_number(o))) {
                        i = ve(Wn, i, {
                            operator: i.left.operator,
                            left: ve(Wn, i, {
                                operator: i.operator,
                                left: i.right,
                                right: i.left.left
                            }),
                            right: i.left.right
                        });
                        break;
                    }

                  case "-":
                    if (i.right instanceof Ln && i.right.operator == "-" && i.left.is_number(o) && i.right.expression.is_number(o)) {
                        i = ve(Wn, i, {
                            operator: "+",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    _ = o.option("unsafe_math");
                    if (i.operator != "+") [ "left", "right" ].forEach(function(e) {
                        var n = i[e];
                        if (n instanceof Ln && n.operator == "+") {
                            var t = n.expression;
                            if (t.is_boolean(o) || t.is_number(o) || t.is_string(o)) {
                                i[e] = t;
                            }
                        }
                    });

                  case "&":
                  case "|":
                  case "^":
                    if (i.operator != "-" && i.operator != "/" && (i.left.is_boolean(o) || i.left.is_number(o)) && (i.right.is_boolean(o) || i.right.is_number(o)) && t() && !(i.left instanceof Wn && i.left.operator != i.operator && Ft[i.left.operator] >= Ft[i.operator])) {
                        var g = ve(Wn, i, {
                            operator: i.operator,
                            left: i.right,
                            right: i.left
                        });
                        if (i.right instanceof gt && !(i.left instanceof gt)) {
                            i = ee(o, g, i);
                        } else {
                            i = ee(o, i, g);
                        }
                    }
                    if (!_ || !i.is_number(o)) break;
                    if (i.right instanceof Wn && i.right.operator != "%" && Ft[i.right.operator] == Ft[i.operator] && i.right.is_number(o) && (i.operator != "+" || i.right.left.is_boolean(o) || i.right.left.is_number(o)) && (i.operator != "-" || !i.left.is_negative_zero()) && (i.right.left.is_constant_expression() || !i.right.right.has_side_effects(o))) {
                        i = ve(Wn, i, {
                            operator: E(i.operator, i.right.operator),
                            left: ve(Wn, i.left, {
                                operator: i.operator,
                                left: i.left,
                                right: i.right.left,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                        if (i.operator == "+" && !i.right.is_boolean(o) && !i.right.is_number(o)) {
                            i.right = ve(Ln, i.right, {
                                operator: "+",
                                expression: i.right
                            });
                        }
                    }
                    if (i.right instanceof gt && i.left instanceof Wn && i.left.operator != "%" && Ft[i.left.operator] == Ft[i.operator] && i.left.is_number(o)) {
                        if (i.left.left instanceof gt) {
                            var u = S(i.left, i.operator, i.left.left, i.right, i.left.left.start, i.right.end);
                            i = S(i, i.left.operator, ne(o, u), i.left.right);
                        } else if (i.left.right instanceof gt) {
                            var b = E(i.left.operator, i.operator);
                            var y = ne(o, S(i.left, b, i.left.right, i.right));
                            if (y.is_constant() && !(i.left.operator == "-" && i.right.value != 0 && +y.value == 0 && i.left.left.is_negative_zero())) {
                                i = S(i, i.left.operator, i.left.left, y);
                            }
                        }
                    }
                    break;
                }
                if (!(h instanceof Ln && h.operator == "delete")) {
                    if (i.left instanceof yt && !i.right.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.left.value == 0) {
                            if (i.right.is_boolean(o)) return ve(Ln, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(o);
                            if (i.right.is_number(o) && !i.right.is_negative_zero()) return i.right;
                        }
                        break;

                      case "*":
                        if (i.left.value == 1) {
                            return i.right.is_number(o) ? i.right : ve(Ln, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(o);
                        }
                        break;
                    }
                    if (i.right instanceof yt && !i.left.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.right.value == 0) {
                            if (i.left.is_boolean(o)) return ve(Ln, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                            if (i.left.is_number(o) && !i.left.is_negative_zero()) return i.left;
                        }
                        break;

                      case "-":
                        if (i.right.value == 0) {
                            return i.left.is_number(o) ? i.left : ve(Ln, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                        }
                        break;

                      case "/":
                        if (i.right.value == 1) {
                            return i.left.is_number(o) ? i.left : ve(Ln, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                        }
                        break;
                    }
                }
            }
            if (o.option("typeofs")) switch (i.operator) {
              case "&&":
                q(i.left, i.right, null);
                break;

              case "||":
                q(i.left, null, i.right);
                break;
            }
            if (o.option("unsafe")) {
                var w = D(i.right);
                if (l && w && (i.operator == "==" || i.operator == "!=") && i.left instanceof yt && i.left.value == 0) {
                    return (i.operator == "==" ? ve(Ln, i, {
                        operator: "!",
                        expression: i.right
                    }) : i.right).optimize(o);
                }
                var x = D(i.left);
                if (o.option("comparisons") && O()) {
                    var k = ve(Ln, i, {
                        operator: "!",
                        expression: ve(Ln, i, {
                            operator: "~",
                            expression: x ? i.left : i.right
                        })
                    });
                    switch (i.operator) {
                      case "<":
                        if (x) break;

                      case "<=":
                      case "!=":
                        k = ve(Ln, i, {
                            operator: "!",
                            expression: k
                        });
                        break;
                    }
                    return k.optimize(o);
                }
            }
            return ne(o, i);
            function E(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function S(e, n, t, i, r, a) {
                if (n == "+") {
                    if (!t.is_boolean(o) && !t.is_number(o)) {
                        t = ve(Ln, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                    if (!i.is_boolean(o) && !i.is_number(o)) {
                        i = ve(Ln, i, {
                            operator: "+",
                            expression: i
                        });
                    }
                }
                return ve(Wn, e, {
                    operator: n,
                    left: t,
                    right: i,
                    start: r,
                    end: a
                });
            }
            function T(e) {
                if (e.truthy) return true;
                if (e.falsy) return false;
                if (e.is_truthy()) return true;
                return e.evaluate(o, true);
            }
            function D(e) {
                return e.TYPE == "Call" && e.expression instanceof Rn && B[e.expression.property];
            }
            function O() {
                switch (i.operator) {
                  case "<=":
                    return w && i.left instanceof yt && i.left.value == 0;

                  case "<":
                    if (x && i.right instanceof yt && i.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!w) return false;
                    return i.left instanceof yt && i.left.value == -1 || i.left instanceof Ln && i.left.operator == "-" && i.left.expression instanceof yt && i.left.expression.value == 1;
                }
            }
        });
        function xe(e, n) {
            var t = 0, i = e.self();
            do {
                if (i instanceof sn && i.name && i.name.definition() === n) return i;
            } while (i = e.parent(t++));
        }
        e(_t, function(e, n) {
            if (!n.option("ie8") && K(e) && !(e.scope.resolve().uses_with && n.find_parent(rn))) {
                switch (e.name) {
                  case "undefined":
                    return ve(Et, e).optimize(n);

                  case "NaN":
                    return ve(kt, e).optimize(n);

                  case "Infinity":
                    return ve(Tt, e).optimize(n);
                }
            }
            var t = n.parent();
            if (n.option("reduce_vars") && ye(n.self(), t) !== n.self()) {
                var i = e.definition();
                var r = e.fixed_value();
                var a = i.single_use && !(t instanceof Nn && t.is_expr_pure(n));
                if (a) {
                    if (r instanceof sn) {
                        if ((i.scope !== e.scope.resolve() || i.in_loop) && (!n.option("reduce_funcs") || i.escaped.depth == 1 || r.inlined)) {
                            a = false;
                        } else if (xe(n, i)) {
                            a = false;
                        } else if (r.name && r.name.definition() !== i) {
                            a = false;
                        } else if (r.parent_scope !== e.scope.resolve() || i.orig[0] instanceof pt) {
                            a = r.is_constant_expression(e.scope);
                            if (a == "f") {
                                var o = e.scope;
                                do {
                                    if (hn(o) || un(o)) {
                                        o.inlined = true;
                                    }
                                } while (o = o.parent_scope);
                            }
                        }
                        if (a) r.parent_scope = e.scope;
                    } else if (!r || !r.is_constant_expression()) {
                        a = false;
                    }
                }
                if (a) {
                    i.single_use = false;
                    r._squeezed = true;
                    r.single_use = true;
                    if (r instanceof vn) {
                        r = ve(pn, r, r);
                        r.name = ve(ht, r.name, r.name);
                    } else if (r instanceof _n) {
                        r = ve(dn, r, r);
                        r.name = ve(ht, r.name, r.name);
                    }
                    if (r instanceof sn) {
                        var o = e.scope.resolve();
                        r.enclosed.forEach(function(e) {
                            if (r.variables.has(e.name)) return;
                            if (o.var_names()[e.name]) return;
                            o.enclosed.push(e);
                            o.var_names()[e.name] = true;
                        });
                    }
                    var s;
                    if (i.recursive_refs > 0) {
                        s = r.clone(true);
                        var f = s.name.definition();
                        var u = s.variables.get(s.name.name);
                        var c = u && u.orig[0];
                        if (!(c instanceof ht)) {
                            c = ve(ht, s.name, s.name);
                            c.scope = s;
                            s.name = c;
                            u = s.def_function(c);
                            u.recursive_refs = i.recursive_refs;
                        }
                        s.walk(new zt(function(e) {
                            if (!(e instanceof _t)) return;
                            var n = e.definition();
                            if (n === f) {
                                e.thedef = u;
                                u.references.push(e);
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (!(t instanceof sn)) return;
                                if (!t.name) return;
                                if (t.name.definition() !== n) return;
                                if (n.scope !== t.name.scope) return;
                                if (r.variables.get(t.name.name) !== n) return;
                                t.name = t.name.clone();
                                var i = s.variables.get(t.name.name) || s.def_function(t.name);
                                e.thedef = i;
                                i.references.push(e);
                            }
                        }));
                    } else {
                        s = r.optimize(n);
                        if (s === r) s = s.transform(new Ct(function(e, n) {
                            if (e instanceof an) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    i.replaced++;
                    return s;
                }
                var l = e.fixed !== i.fixed;
                if (r && (l || i.should_replace !== false)) {
                    var p;
                    if (r instanceof mt) {
                        if (!(i.orig[0] instanceof pt) && g(i)) {
                            p = r;
                        }
                    } else {
                        var d = r.evaluate(n, true);
                        if (d !== r && typeof d != "function" && (typeof d != "object" || d instanceof RegExp && n.option("unsafe_regexp") && !i.cross_loop && g(i))) {
                            p = D(d, r);
                        }
                    }
                    if (p) {
                        if (!l && i.should_replace === undefined) {
                            var h = p.optimize(n).print_to_string().length;
                            if (!b(r)) {
                                h = Math.min(h, r.print_to_string().length);
                            }
                            var v = i.name.length;
                            if (n.option("unused") && !n.exposed(i)) {
                                var _ = i.references.length - i.replaced;
                                v += (v + 2 + h) / (_ - i.assignments);
                            }
                            var m = h - Math.floor(v);
                            i.should_replace = m < n.eval_threshold;
                        }
                        if (l || i.should_replace) {
                            var s;
                            if (b(r)) {
                                s = p.optimize(n);
                                if (s === p) s = s.clone(true);
                            } else {
                                s = Z(p.optimize(n), r);
                                if (s === p || s === r) s = s.clone(true);
                            }
                            i.replaced++;
                            return s;
                        }
                    }
                }
            }
            return e;
            function g(e) {
                var n = e.scope.resolve();
                return Ce(e.references, function(e) {
                    return n === e.scope.resolve();
                });
            }
            function b(e) {
                var n;
                e.walk(new zt(function(e) {
                    if (e instanceof _t) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function se(e, n) {
            return e instanceof _t || e.TYPE === n.TYPE;
        }
        e(Et, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = V(n).find_variable("undefined");
                if (t) {
                    var i = ve(_t, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    i.is_undefined = true;
                    return i;
                }
            }
            var r = ye(n.self(), n.parent());
            if (r && se(r, e)) return e;
            return ve(Ln, e, {
                operator: "void",
                expression: ve(yt, e, {
                    value: 0
                })
            });
        });
        e(Tt, function(e, n) {
            var t = ye(n.self(), n.parent());
            if (t && se(t, e)) return e;
            if (n.option("keep_infinity") && !(t && !se(t, e)) && !V(n).find_variable("Infinity")) return e;
            return ve(Wn, e, {
                operator: "/",
                left: ve(yt, e, {
                    value: 1
                }),
                right: ve(yt, e, {
                    value: 0
                })
            });
        });
        e(kt, function(e, n) {
            var t = ye(n.self(), n.parent());
            if (t && !se(t, e) || V(n).find_variable("NaN")) {
                return ve(Wn, e, {
                    operator: "/",
                    left: ve(yt, e, {
                        value: 0
                    }),
                    right: ve(yt, e, {
                        value: 0
                    })
                });
            }
            return e;
        });
        function fe(t, n) {
            var i = false;
            var r = new zt(function(e) {
                if (i) return true;
                if (e instanceof _t && Ee(e.definition(), n)) {
                    return i = true;
                }
            });
            var a = new zt(function(e) {
                if (i) return true;
                if (e instanceof an && e !== t) {
                    var n = a.parent();
                    if (n instanceof Nn && n.expression === e) return;
                    e.walk(r);
                    return true;
                }
            });
            t.walk(a);
            return i;
        }
        var ue = qe("+ - * / % >> << >>> | ^ &");
        var ce = qe("* | ^ &");
        e(Gn, function(a, o) {
            if (o.option("dead_code")) {
                if (a.left instanceof In) {
                    if (a.operator == "=") {
                        if (a.__drop) {
                            var e = [ a.left.expression ];
                            if (a.left instanceof Un) e.push(a.left.property);
                            e.push(a.right);
                            return W(a, e).optimize(o);
                        }
                        if (a.left.equivalent_to(a.right) && !a.left.has_side_effects(o)) {
                            return a.right;
                        }
                        var n = a.left.expression;
                        if (n instanceof sn || !o.has_directive("use strict") && n instanceof gt && !n.may_throw_on_access(o)) {
                            return a.left instanceof Rn ? a.right : W(a, [ a.left.property, a.right ]).optimize(o);
                        }
                    }
                } else if (a.left instanceof _t && Ce(a.left.definition().orig, function(e) {
                    return !(e instanceof ut);
                })) {
                    var t;
                    if (a.operator == "=" && a.left.equivalent_to(a.right) && !((t = o.parent()) instanceof Ln && t.operator == "delete")) {
                        return a.right;
                    }
                    if (a.left.is_immutable()) return h();
                    var i = a.left.definition();
                    var s = i.scope.resolve();
                    var r = s === o.find_parent(sn);
                    var f = 0, u;
                    t = a;
                    do {
                        u = t;
                        t = o.parent(f++);
                        if (t instanceof Gn) {
                            var c = false;
                            if (t.left.match_symbol(function(e) {
                                if (e instanceof In) return true;
                                if (!c && e instanceof _t && e.definition() === i) {
                                    if (d(f, t)) return true;
                                    i.fixed = false;
                                    c = true;
                                }
                            })) break;
                            if (c) return h();
                        } else if (t instanceof gn) {
                            if (!r) break;
                            if (d(f, t)) break;
                            if (fe(s, [ i ])) break;
                            i.fixed = false;
                            return h();
                        } else if (t instanceof Cn) {
                            if (!(t.name instanceof ft)) continue;
                            if (t.name.definition() !== i) continue;
                            if (d(f, t)) break;
                            i.fixed = false;
                            return h();
                        }
                    } while (t instanceof Wn && t.right === u || t instanceof Hn && t.tail_node() === u || t instanceof Ln);
                }
            }
            if (o.option("sequences")) {
                var l = a.lift_sequences(o);
                if (l !== a) return l.optimize(o);
            }
            if (o.option("assignments")) {
                if (a.operator == "=" && a.left instanceof _t && a.right instanceof Wn) {
                    if (a.right.left instanceof _t && a.right.left.name == a.left.name && ue[a.right.operator]) {
                        return ve(Gn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.right
                        }).optimize(o);
                    } else if (a.right.right instanceof _t && a.right.right.name == a.left.name && ce[a.right.operator] && !a.right.left.has_side_effects(o)) {
                        return ve(Gn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.left
                        }).optimize(o);
                    }
                }
                if ((a.operator == "-=" || a.operator == "+=" && (a.left.is_boolean(o) || a.left.is_number(o))) && a.right instanceof yt && a.right.value == 1) {
                    var p = a.operator.slice(0, -1);
                    return ve(Ln, a, {
                        operator: p + p,
                        expression: a.left
                    });
                }
            }
            return ne(o, a);
            function d(e, n) {
                var t = a.right;
                a.right = ve(xt, t);
                var i = n.may_throw(o);
                a.right = t;
                var r;
                while (r = o.parent(e++)) {
                    if (r === s) return false;
                    if (r instanceof An) {
                        if (r.bfinally) return true;
                        if (i && r.bcatch) return true;
                    }
                }
            }
            function h() {
                return (a.operator != "=" ? ve(Wn, a, {
                    operator: a.operator.slice(0, -1),
                    left: a.left,
                    right: a.right
                }) : _e(o, o.parent(), a, a.right)).optimize(o);
            }
        });
        e(Jn, function(a, n) {
            if (n.option("sequences") && a.condition instanceof Hn) {
                var e = a.condition.expressions.slice();
                a.condition = e.pop();
                e.push(a);
                return W(a, e);
            }
            if (!n.option("conditionals")) return a;
            var o = a.condition.is_truthy() || a.condition.evaluate(n, true);
            if (!o) {
                Ie.warn("Condition always false [{file}:{line},{col}]", a.start);
                return W(a, [ a.condition, a.alternative ]).optimize(n);
            } else if (!(o instanceof Ie)) {
                Ie.warn("Condition always true [{file}:{line},{col}]", a.start);
                return W(a, [ a.condition, a.consequent ]).optimize(n);
            }
            var t = o.negate(n, He(n));
            if (ee(n, o, t) === t) {
                a = ve(Jn, a, {
                    condition: t,
                    consequent: a.alternative,
                    alternative: a.consequent
                });
                t = o;
                o = a.condition;
            }
            var i = a.consequent;
            var r = a.alternative;
            if (oe(n, o)) {
                if (o.equivalent_to(i)) return ve(Wn, a, {
                    operator: "||",
                    left: o,
                    right: r
                }).optimize(n);
                if (o.equivalent_to(r)) return ve(Wn, a, {
                    operator: "&&",
                    left: o,
                    right: i
                }).optimize(n);
            }
            var s = i.tail_node();
            if (s instanceof Gn) {
                var f = s.operator == "=";
                var u = f ? r.tail_node() : r;
                if ((f || i === s) && u instanceof Gn && s.operator == u.operator && s.left.equivalent_to(u.left) && (f && s.left instanceof _t || !o.has_side_effects(n) && y(i) && y(r))) {
                    return ve(Gn, a, {
                        operator: s.operator,
                        left: s.left,
                        right: ve(Jn, a, {
                            condition: o,
                            consequent: w(i),
                            alternative: w(r)
                        })
                    });
                }
            }
            if (i.equivalent_to(r)) return W(a, [ o, i ]).optimize(n);
            var c = b(i, r, true);
            if (c) return c;
            var l;
            if (i instanceof Nn && r.TYPE == i.TYPE && (l = m(i, r)) >= 0 && i.expression.equivalent_to(r.expression) && !o.has_side_effects(n) && !i.expression.has_side_effects(n)) {
                var p = i.clone();
                p.args[l] = ve(Jn, a, {
                    condition: o,
                    consequent: i.args[l],
                    alternative: r.args[l]
                });
                return p;
            }
            if (i instanceof Jn && i.alternative.equivalent_to(r)) {
                return ve(Jn, a, {
                    condition: ve(Wn, a, {
                        left: o,
                        operator: "&&",
                        right: i.condition
                    }),
                    consequent: i.consequent,
                    alternative: r
                });
            }
            if (i instanceof Jn && i.consequent.equivalent_to(r)) {
                return ve(Jn, a, {
                    condition: ve(Wn, a, {
                        left: t,
                        operator: "||",
                        right: i.condition
                    }),
                    consequent: r,
                    alternative: i.alternative
                });
            }
            if (r instanceof Jn && i.equivalent_to(r.consequent)) {
                return ve(Jn, a, {
                    condition: ve(Wn, a, {
                        left: o,
                        operator: "||",
                        right: r.condition
                    }),
                    consequent: i,
                    alternative: r.alternative
                });
            }
            if (r instanceof Jn && i.equivalent_to(r.alternative)) {
                return ve(Jn, a, {
                    condition: ve(Wn, a, {
                        left: t,
                        operator: "&&",
                        right: r.condition
                    }),
                    consequent: r.consequent,
                    alternative: i
                });
            }
            if ((i instanceof Hn || r instanceof Hn) && i.tail_node().equivalent_to(r.tail_node())) {
                return W(a, [ ve(Jn, a, {
                    condition: o,
                    consequent: x(i),
                    alternative: x(r)
                }), i.tail_node() ]).optimize(n);
            }
            if (i instanceof Wn && i.operator == "&&" && i.right.equivalent_to(r)) {
                return ve(Wn, a, {
                    operator: "&&",
                    left: ve(Wn, a, {
                        operator: "||",
                        left: t,
                        right: i.left
                    }),
                    right: r
                }).optimize(n);
            }
            if (i instanceof Wn && i.operator == "||" && i.right.equivalent_to(r)) {
                return ve(Wn, a, {
                    operator: "||",
                    left: ve(Wn, a, {
                        operator: "&&",
                        left: o,
                        right: i.left
                    }),
                    right: r
                }).optimize(n);
            }
            if (r instanceof Wn && r.operator == "&&" && r.right.equivalent_to(i)) {
                return ve(Wn, a, {
                    operator: "&&",
                    left: ve(Wn, a, {
                        operator: "||",
                        left: o,
                        right: r.left
                    }),
                    right: i
                }).optimize(n);
            }
            if (r instanceof Wn && r.operator == "||" && r.right.equivalent_to(i)) {
                return ve(Wn, a, {
                    operator: "||",
                    left: ve(Wn, a, {
                        operator: "&&",
                        left: t,
                        right: r.left
                    }),
                    right: i
                }).optimize(n);
            }
            var d = n.option("booleans") && n.in_boolean_context();
            if (v(i)) {
                if (_(r)) {
                    return h(o);
                }
                return ve(Wn, a, {
                    operator: "||",
                    left: h(o),
                    right: r
                });
            }
            if (_(i)) {
                if (v(r)) {
                    return h(o.negate(n));
                }
                return ve(Wn, a, {
                    operator: "&&",
                    left: h(o.negate(n)),
                    right: r
                });
            }
            if (v(r)) {
                return ve(Wn, a, {
                    operator: "||",
                    left: h(o.negate(n)),
                    right: i
                });
            }
            if (_(r)) {
                return ve(Wn, a, {
                    operator: "&&",
                    left: h(o),
                    right: i
                });
            }
            if (n.option("typeofs")) q(o, i, r);
            return a;
            function h(e) {
                if (e.is_boolean(n)) return e;
                return ve(Ln, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function v(e) {
                return e instanceof At || d && e instanceof gt && e.value || e instanceof Ln && e.operator == "!" && e.expression instanceof gt && !e.expression.value;
            }
            function _(e) {
                return e instanceof Ot || d && (e instanceof gt && !e.value || e instanceof Ln && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof Ln && e.operator == "!" && e.expression instanceof gt && e.expression.value;
            }
            function m(e, n) {
                var t = e.args;
                var i = n.args;
                var r = t.length;
                if (r != i.length) return -2;
                for (var a = 0; a < r; a++) {
                    if (!t[a].equivalent_to(i[a])) {
                        for (var o = a + 1; o < r; o++) {
                            if (!t[o].equivalent_to(i[o])) return -2;
                        }
                        return a;
                    }
                }
                return -1;
            }
            function g(e, n) {
                if (e.TYPE != n.TYPE) return;
                if (e instanceof Nn) {
                    if (m(e, n) != -1) return;
                    return e.TYPE != "Call" || !(e.expression instanceof In || n.expression instanceof In) || g(e.expression, n.expression);
                }
                if (e instanceof Rn) return e.property == n.property;
                if (e instanceof Un) return e.property.equivalent_to(n.property);
            }
            function b(e, n, t) {
                if (!g(e, n)) return !t && ve(Jn, a, {
                    condition: o,
                    consequent: e,
                    alternative: n
                });
                var i = b(e.expression, n.expression);
                if (!i) return;
                var r = e.clone();
                r.expression = i;
                return r;
            }
            function y(e) {
                return e === e.tail_node() || Ce(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function w(e) {
                if (!(e instanceof Hn)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return W(e, n);
            }
            function x(e) {
                if (!(e instanceof Hn)) return ve(yt, e, {
                    value: 0
                });
                return W(e, e.expressions.slice(0, -1));
            }
        });
        e(Dt, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return ve(yt, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof Wn && (t.operator == "==" || t.operator == "!=")) {
                Ie.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return ve(yt, e, {
                    value: +e.value
                });
            }
            return ve(Ln, e, {
                operator: "!",
                expression: ve(yt, e, {
                    value: 1 - e.value
                })
            });
        });
        e(Bn, function(e, n) {
            var t = e.expression;
            if (n.option("spread") && t instanceof Kn && !(n.parent() instanceof tt)) {
                return $e.splice(t.elements.map(function(e) {
                    return e instanceof St ? ve(Et, e).optimize(n) : e;
                }));
            }
            return e;
        });
        function ke(e, n) {
            if (e instanceof _t) {
                e = e.fixed_value();
            }
            if (!e) return false;
            if (!(e instanceof sn)) return true;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            return !e.contains_this();
        }
        e(Un, function(e, t) {
            var n = e.expression;
            var i = e.property;
            if (t.option("properties")) {
                var r = i.evaluate(t);
                if (r !== i) {
                    if (typeof r == "string") {
                        if (r == "undefined") {
                            r = undefined;
                        } else {
                            var a = parseFloat(r);
                            if (a.toString() == r) {
                                r = a;
                            }
                        }
                    }
                    i = e.property = Z(i, D(r, i).transform(t));
                    var o = "" + r;
                    if ($t(o) && o.length <= i.print_to_string().length + 1) {
                        return ve(Rn, e, {
                            expression: n,
                            property: o
                        }).optimize(t);
                    }
                }
            }
            var s = t.parent();
            var f = ye(t.self(), s);
            var u, c, l;
            if (t.option("arguments") && n instanceof _t && pe(u = n.definition()) && !n.in_arg && i instanceof yt && (c = u.scope) === E() && c.uses_arguments < (f ? 2 : 3)) {
                var p = i.value;
                if (s instanceof Ln && s.operator == "delete") {
                    if (!u.deleted) u.deleted = [];
                    u.deleted[p] = true;
                }
                var d = c.argnames[p];
                if (u.deleted && u.deleted[p]) {
                    d = null;
                } else if (d instanceof Qn) {
                    d = null;
                } else if (d && (t.has_directive("use strict") || c.name || !(l instanceof Nn && p < l.args.length) || !Ce(c.argnames, function(e) {
                    return !(e instanceof Qn);
                }))) {
                    var h = d.definition();
                    if (!t.option("reduce_vars") || u.reassigned || h.assignments || h.orig.length > 1) {
                        d = null;
                    }
                } else if (!d && p < c.argnames.length + 5 && t.drop_fargs(c, l)) {
                    while (p >= c.argnames.length) {
                        d = c.make_var(pt, c, "argument_" + c.argnames.length);
                        c.argnames.push(d);
                    }
                }
                if (d && Se(function(e) {
                    return e.name === d.name;
                }, c.argnames) === d) {
                    u.reassigned = false;
                    var v = ve(_t, e, d);
                    v.reference({});
                    delete d.__unused;
                    return v;
                }
            }
            if (f) return e;
            if (t.option("sequences") && s.TYPE != "Call" && !(s instanceof tn && s.init === e)) {
                var _ = re(e, t);
                if (_ !== e) return _.optimize(t);
            }
            if (r !== i) {
                var m = e.flatten_object(o, t);
                if (m) {
                    n = e.expression = m.expression;
                    i = e.property = m.property;
                }
            }
            var g;
            if (t.option("properties") && t.option("side_effects") && i instanceof yt && n instanceof Kn && Ce(g = n.elements, function(e) {
                return !(e instanceof Bn);
            })) {
                var p = i.value;
                var b = g[p];
                if (ke(b, t)) {
                    var y = b instanceof St;
                    var w = !y;
                    var x = [];
                    for (var k = g.length; --k > p; ) {
                        var a = g[k].drop_side_effect_free(t);
                        if (a) {
                            x.unshift(a);
                            if (w && a.has_side_effects(t)) w = false;
                        }
                    }
                    if (!w) x.unshift(b);
                    while (--k >= 0) {
                        var a = g[k].drop_side_effect_free(t);
                        if (a) {
                            x.unshift(a);
                        } else if (y) {
                            x.unshift(ve(St, g[k]));
                        } else {
                            p--;
                        }
                    }
                    if (w) {
                        x.push(b);
                        return W(e, x).optimize(t);
                    } else return ve(Un, e, {
                        expression: ve(Kn, n, {
                            elements: x
                        }),
                        property: ve(yt, i, {
                            value: p
                        })
                    });
                }
            }
            return ne(t, e);
            function E() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof sn) {
                        if (n instanceof fn) return;
                        if (n instanceof cn) continue;
                        l = t.parent(e);
                        return n;
                    }
                }
            }
        });
        cn.DEFMETHOD("contains_this", De);
        an.DEFMETHOD("contains_this", function() {
            var n;
            var t = this;
            t.walk(new zt(function(e) {
                if (n) return true;
                if (e instanceof mt) return n = true;
                if (e !== t && e instanceof an && !(e instanceof cn)) return true;
            }));
            return n;
        });
        In.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            var t = this.expression;
            if (t instanceof tt) {
                var i = t.properties;
                for (var r = i.length; --r >= 0; ) {
                    var a = i[r];
                    if (a.key != e) continue;
                    if (!Ce(i, function(e) {
                        return e instanceof rt && typeof e.key == "string";
                    })) break;
                    if (!ke(a.value, n)) break;
                    return ve(Un, this, {
                        expression: ve(Kn, t, {
                            elements: i.map(function(e) {
                                return e.value;
                            })
                        }),
                        property: ve(yt, this, {
                            value: r
                        })
                    });
                }
            }
        });
        e(Rn, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                Ie.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            var t = n.parent();
            if (ye(n.self(), t)) return e;
            if (n.option("sequences") && t.TYPE != "Call" && !(t instanceof tn && t.init === e)) {
                var i = re(e, n);
                if (i !== e) return i.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof Rn && e.expression.property == "prototype") {
                var r = e.expression.expression;
                if (K(r)) switch (r.name) {
                  case "Array":
                    e.expression = ve(Kn, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = ve(dn, e.expression, {
                        argnames: [],
                        body: []
                    }).init_vars(r.scope);
                    break;

                  case "Number":
                    e.expression = ve(yt, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = ve(tt, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = ve(wt, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = ve(bt, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var a = e.flatten_object(e.property, n);
            if (a) return a.optimize(n);
            return ne(n, e);
        });
        e(et, function(e, n) {
            if (n.option("objects")) {
                var t = e.key;
                if (t instanceof Ie) {
                    t = t.evaluate(n);
                    if (t !== e.key) e.key = "" + t;
                }
            }
            return e;
        });
        e(tt, function(t, i) {
            if (!i.option("objects")) return t;
            var r = false;
            var a = false;
            var o = false;
            var s = i.has_directive("use strict");
            var f = new Ne();
            var u = [];
            t.properties.forEach(function(e) {
                if (!(e instanceof Bn)) return l(e);
                a = true;
                var n = e.expression;
                if (i.option("spread") && n instanceof tt && Ce(n.properties, function(e) {
                    return !(e instanceof ot || e instanceof Bn);
                })) {
                    r = true;
                    n.properties.forEach(function(e) {
                        l(e instanceof at ? ve(rt, e, {
                            key: e.key,
                            value: ve(Et, e).optimize(i)
                        }) : e);
                    });
                } else {
                    o = true;
                    c();
                    u.push(e);
                }
            });
            c();
            if (!r) return t;
            if (a && o && u.length == 1) {
                var e = u[0];
                if (e instanceof it && e.key instanceof yt) {
                    e.key = "" + e.key.value;
                }
            }
            return r ? ve(tt, t, {
                properties: u
            }) : t;
            function c() {
                f.each(function(e) {
                    if (e.length == 1) return u.push(e[0]);
                    r = true;
                    var n = s && !o && e.pop();
                    u.push(e.length == 1 ? e[0] : ve(rt, t, {
                        key: e[0].key,
                        value: W(t, e.map(function(e) {
                            return e.value;
                        }))
                    }));
                    if (n) u.push(n);
                });
                f = new Ne();
            }
            function l(e) {
                var n = e.key;
                if (n instanceof Ie) {
                    a = true;
                    n = n.evaluate(i);
                    if (n === e.key) {
                        o = true;
                    } else {
                        n = e.key = "" + n;
                    }
                }
                if (e instanceof rt && typeof n == "string") {
                    if (e.value.has_side_effects(i)) c();
                    f.add(n, e);
                } else {
                    c();
                    u.push(e);
                }
                if (a && !o && typeof n == "string" && /^[1-9]*[0-9]$/.test(n)) {
                    o = true;
                    if (f.has(n)) e = f.get(n)[0];
                    e.key = ve(yt, e, {
                        value: +n
                    });
                }
            }
        });
        e(bn, function(e, n) {
            if (e.value && $(e.value, n)) {
                e.value = null;
            }
            return e;
        });
    })(function(e, i) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = i(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var w = e("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var x = w.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function k(e, n) {
        var t = 0;
        var i = 0;
        for (var r = 0, a = 0; r < n.length; r++) {
            var o = x[n[r]];
            t += (o & 31) << i;
            if (o & 32) {
                i += 5;
            } else {
                e[a++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = i = 0;
            }
        }
        return a;
    }
    function E(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += w[t];
        } while (e);
        return n;
    }
    function S() {
        var n = Object.create(null);
        var t = [];
        t.index = function(e) {
            if (!Pe(n, e)) {
                n[e] = t.length;
                t.push(e);
            }
            return n[e];
        };
        return t;
    }
    function O(l) {
        var f = S();
        var a = l.includeSources && Object.create(null);
        var u = S();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, k(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!a || !n.sourcesContent) return;
            for (var i = 0; i < n.sources.length; i++) {
                var r = n.sourcesContent[i];
                if (r) a[n.sources[i]] = r;
            }
        });
        var p;
        var d = 1;
        var h = 0;
        var v = 0;
        var _ = 1;
        var m = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, t, i, r, a) {
                var o = l.orig[e];
                if (o) {
                    var s = o.mappings[i - 1];
                    if (!s) return;
                    var f;
                    for (var u = 0; u < s.length; u++) {
                        var c = s[u][0];
                        if (r >= c) f = s[u];
                        if (r <= c) break;
                    }
                    if (!f || f.length < 4) {
                        e = null;
                    } else {
                        e = o.sources[f[1]];
                        i = f[2];
                        r = f[3];
                        if (f.length > 4) a = o.names[f[4]];
                    }
                }
                b(e, n, t, i, r, a);
            } : b,
            setSourceContent: a ? function(e, n) {
                a[e] = n;
            } : Te,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: a ? f.map(function(e) {
                        return a[e] || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, i, r, a) {
            if (p == null && e == null) return;
            p = e;
            if (d < n) {
                h = 0;
                do {
                    c += ";";
                } while (++d < n);
            } else if (c) {
                c += ",";
            }
            c += E(t - h);
            h = t;
            if (e == null) return;
            var o = f.index(e);
            c += E(o - v);
            v = o;
            c += E(i - _);
            _ = i;
            c += E(r - m);
            m = r;
            if (l.names && a != null) {
                var s = u.index(a);
                c += E(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        function n(e) {
            var n = true;
            for (var t = 0; t < e.length; t++) {
                if (n && e[t] instanceof Re && e[t].body instanceof bt) {
                    e[t] = new Be({
                        start: e[t].start,
                        end: e[t].end,
                        value: e[t].body.value
                    });
                } else if (n && !(e[t] instanceof Re && e[t].body instanceof bt)) {
                    n = false;
                }
            }
            return e;
        }
        var i = {
            Program: function(e) {
                return new on({
                    start: s(e),
                    end: f(e),
                    body: n(e.body.map(u))
                });
            },
            FunctionDeclaration: function(e) {
                return new _n({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                return new dn({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            ExpressionStatement: function(e) {
                return new Le({
                    start: s(e),
                    end: f(e),
                    body: u(e.expression)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new An({
                    start: s(e),
                    end: f(e),
                    body: u(e.block).body,
                    bcatch: u(n[0]),
                    bfinally: e.finalizer ? new $n(u(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.key;
                var t = {
                    start: s(n),
                    end: f(e.value),
                    key: "" + n[n.type == "Identifier" ? "name" : "value"],
                    value: u(e.value)
                };
                if (e.kind == "init") return new rt(t);
                t.value = new fn(t.value);
                if (e.kind == "get") return new ot(t);
                if (e.kind == "set") return new at(t);
            },
            ArrayExpression: function(e) {
                return new Kn({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new St() : u(e);
                    })
                });
            },
            ObjectExpression: function(e) {
                return new tt({
                    start: s(e),
                    end: f(e),
                    properties: e.properties.map(function(e) {
                        e.type = "Property";
                        return u(e);
                    })
                });
            },
            SequenceExpression: function(e) {
                return new Hn({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(u)
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? Un : Rn)({
                    start: s(e),
                    end: f(e),
                    property: e.computed ? u(e.property) : e.property.name,
                    expression: u(e.object)
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? On : Dn)({
                    start: s(e),
                    end: f(e),
                    expression: u(e.test),
                    body: e.consequent.map(u)
                });
            },
            VariableDeclaration: function(e) {
                return new qn({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(u)
                });
            },
            Literal: function(e) {
                var n = e.value, t = {
                    start: s(e),
                    end: f(e)
                };
                if (n === null) return new xt(t);
                var i = e.regex;
                if (i && i.pattern) {
                    t.value = new RegExp(i.pattern, i.flags);
                    t.value.raw_source = i.pattern;
                    return new wt(t);
                } else if (i) {
                    t.value = e.regex && e.raw ? e.raw : n;
                    return new wt(t);
                }
                switch (typeof n) {
                  case "string":
                    t.value = n;
                    return new bt(t);

                  case "number":
                    t.value = n;
                    return new yt(t);

                  case "boolean":
                    return new (n ? At : Ot)(t);
                }
            },
            Identifier: function(e) {
                var n = a[a.length - 2];
                return new (n.type == "LabeledStatement" ? ce : n.type == "VariableDeclarator" && n.id === e ? lt : n.type == "FunctionExpression" ? n.id === e ? ht : pt : n.type == "FunctionDeclaration" ? n.id === e ? dt : pt : n.type == "CatchClause" ? vt : n.type == "BreakStatement" || n.type == "ContinueStatement" ? le : _t)({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            ThisExpression: function(e) {
                return new mt({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            }
        };
        i.UpdateExpression = i.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? Ln : Vn)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: u(n.argument)
            });
        };
        e("EmptyStatement", Ye);
        e("BlockStatement", Ge, "body@body");
        e("IfStatement", En, "test>condition, consequent>body, alternate>alternative");
        e("LabeledStatement", Xe, "label>label, body>body");
        e("BreakStatement", xn, "label>label");
        e("ContinueStatement", kn, "label>label");
        e("WithStatement", rn, "object>expression, body>body");
        e("SwitchStatement", Sn, "discriminant>expression, cases@body");
        e("ReturnStatement", bn, "argument>value");
        e("ThrowStatement", yn, "argument>value");
        e("WhileStatement", en, "test>condition, body>body");
        e("DoWhileStatement", Ze, "test>condition, body>body");
        e("ForStatement", nn, "init>init, test>condition, update>step, body>body");
        e("ForInStatement", tn, "left>init, right>object, body>body");
        e("DebuggerStatement", Ue);
        e("VariableDeclarator", Cn, "id>name, init>value");
        e("CatchClause", zn, "param>argname, body%body");
        e("BinaryExpression", Wn, "operator=operator, left>left, right>right");
        e("LogicalExpression", Wn, "operator=operator, left>left, right>right");
        e("AssignmentExpression", Gn, "operator=operator, left>left, right>right");
        e("ConditionalExpression", Jn, "test>condition, consequent>consequent, alternate>alternative");
        e("NewExpression", Pn, "callee>expression, arguments@args");
        e("CallExpression", Nn, "callee>expression, arguments@args");
        c(on, function e(n) {
            return d("Program", n);
        });
        c(_n, function e(n) {
            return {
                type: "FunctionDeclaration",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(dn, function e(n) {
            return {
                type: "FunctionExpression",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(Be, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: {
                    type: "Literal",
                    value: n.value
                }
            };
        });
        c(Le, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: l(n.body)
            };
        });
        c(Tn, function e(n) {
            return {
                type: "SwitchCase",
                test: l(n.expression),
                consequent: n.body.map(l)
            };
        });
        c(An, function e(n) {
            return {
                type: "TryStatement",
                block: p(n),
                handler: l(n.bcatch),
                guardedHandlers: [],
                finalizer: l(n.bfinally)
            };
        });
        c(zn, function e(n) {
            return {
                type: "CatchClause",
                param: l(n.argname),
                guard: null,
                body: p(n)
            };
        });
        c(Mn, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: "var",
                declarations: n.definitions.map(l)
            };
        });
        c(Hn, function e(n) {
            return {
                type: "SequenceExpression",
                expressions: n.expressions.map(l)
            };
        });
        c(In, function e(n) {
            var t = n instanceof Un;
            return {
                type: "MemberExpression",
                object: l(n.expression),
                computed: t,
                property: t ? l(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
        });
        c(Yn, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof Ln,
                argument: l(n.expression)
            };
        });
        c(Wn, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: l(n.left),
                operator: n.operator,
                right: l(n.right)
            };
        });
        c(Kn, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(l)
            };
        });
        c(tt, function e(n) {
            return {
                type: "ObjectExpression",
                properties: n.properties.map(l)
            };
        });
        c(it, function e(n) {
            var t = {
                type: "Literal",
                value: n.key
            };
            var i;
            if (n instanceof rt) {
                i = "init";
            } else if (n instanceof ot) {
                i = "get";
            } else if (n instanceof at) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                key: t,
                value: l(n.value)
            };
        });
        c(st, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        c(mt, function e() {
            return {
                type: "ThisExpression"
            };
        });
        c(wt, function e(n) {
            var t = n.value.toString().match(/[gimuy]*$/)[0];
            var i = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: i,
                raw: i,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        c(gt, function e(n) {
            var t = n.value;
            if (typeof t === "number" && (t < 0 || t === 0 && 1 / t < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -t,
                        raw: n.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: t,
                raw: n.start.raw
            };
        });
        c(v, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        Dt.DEFMETHOD("to_mozilla_ast", gt.prototype.to_mozilla_ast);
        xt.DEFMETHOD("to_mozilla_ast", gt.prototype.to_mozilla_ast);
        St.DEFMETHOD("to_mozilla_ast", function e() {
            return null;
        });
        Je.DEFMETHOD("to_mozilla_ast", Ge.prototype.to_mozilla_ast);
        sn.DEFMETHOD("to_mozilla_ast", dn.prototype.to_mozilla_ast);
        function r(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var i = e.range;
            return new Q({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[0] : e.start,
                raw: r(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var i = e.range;
            return new Q({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[1] : e.end,
                raw: r(e)
            });
        }
        function e(e, n, t) {
            var a = "function From_Moz_" + e + "(M){\n";
            a += "return new U2." + n.name + "({\n" + "start: my_start_token(M),\n" + "end: my_end_token(M)";
            var o = "function To_Moz_" + e + "(M){\n";
            o += "return {\n" + "type: " + JSON.stringify(e);
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], i = n[2], r = n[3];
                a += ",\n" + r + ": ";
                o += ",\n" + t + ": ";
                switch (i) {
                  case "@":
                    a += "M." + t + ".map(from_moz)";
                    o += "M." + r + ".map(to_moz)";
                    break;

                  case ">":
                    a += "from_moz(M." + t + ")";
                    o += "to_moz(M." + r + ")";
                    break;

                  case "=":
                    a += "M." + t;
                    o += "M." + r;
                    break;

                  case "%":
                    a += "from_moz(M." + t + ").body";
                    o += "to_moz_block(M)";
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            a += "\n})\n}";
            o += "\n}\n}";
            a = new Function("U2", "my_start_token", "my_end_token", "from_moz", "return(" + a + ")")(h, s, f, u);
            o = new Function("to_moz", "to_moz_block", "to_moz_scope", "return(" + o + ")")(l, p, d);
            i[e] = a;
            c(n, o);
        }
        var a = null;
        function u(e) {
            a.push(e);
            var n = e != null ? i[e.type](e) : null;
            a.pop();
            return n;
        }
        Ie.from_mozilla_ast = function(e) {
            var n = a;
            a = [];
            var t = u(e);
            a = n;
            t.walk(new zt(function(e) {
                if (e instanceof le) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof an) break;
                        if (t instanceof Xe && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var i = e.start;
                        de("Undefined label " + e.name, i.file, i.line, i.col, i.pos);
                    }
                }
            }));
            return t;
        };
        function t(e, n, t) {
            var i = e.start;
            var r = e.end;
            if (i.pos != null && r.endpos != null) {
                n.range = [ i.pos, r.endpos ];
            }
            if (i.line) {
                n.loc = {
                    start: {
                        line: i.line,
                        column: i.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (i.file) {
                    n.loc.source = i.file;
                }
            }
            return n;
        }
        function c(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return t(this, n(this));
            });
        }
        function l(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function p(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(l)
            };
        }
        function d(e, n) {
            var t = n.body.map(l);
            if (n.body[0] instanceof Le && n.body[0].body instanceof bt) {
                t.unshift(l(new Ye(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var A = function() {
        var n = [];
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(new e()).map(t);
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        return qe(n);
        function t(e) {
            n.push(e);
        }
    }();
    function z(e, n) {
        e.walk(new zt(function(e) {
            if (e instanceof it) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof Un) {
                $(e.property, t);
            }
        }));
        function t(e) {
            Me(n, e);
        }
    }
    function $(e, n) {
        if (e instanceof Jn) {
            $(e.consequent, n);
            $(e.alternative, n);
        } else if (e instanceof Hn) {
            $(e.tail_node(), n);
        } else if (e instanceof bt) {
            n(e.value);
        }
    }
    function Y(e, t) {
        t = ue(t, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            regex: null,
            reserved: null
        }, true);
        var n = Object.create(t.builtins ? null : A);
        if (Array.isArray(t.reserved)) t.reserved.forEach(function(e) {
            n[e] = true;
        });
        var i = -1;
        var r;
        if (t.cache) {
            r = t.cache.props;
            r.each(function(e) {
                n[e] = true;
            });
        } else {
            r = new Ne();
        }
        var a = t.regex;
        var o = t.debug !== false;
        var s;
        if (o) s = t.debug === true ? "" : t.debug;
        var f = Object.create(null);
        var u = Object.create(n);
        e.walk(new zt(function(e) {
            if (e instanceof Wn) {
                if (e.operator == "in") $(e.left, p);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Rn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof _t)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    $(e.args[1], p);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    $(e.args[0], p);
                    break;
                }
            } else if (e instanceof Rn) {
                p(e.property);
            } else if (e instanceof it) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof Un) {
                $(e.property, p);
            }
        }));
        e.walk(new zt(function(e) {
            if (e instanceof Wn) {
                if (e.operator == "in") h(e.left);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Rn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof _t)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    h(e.args[1]);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    h(e.args[0]);
                    break;
                }
            } else if (e instanceof Rn) {
                e.property = d(e.property);
            } else if (e instanceof it) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof Un) {
                if (!t.keep_quoted) h(e.property);
            }
        }));
        function c(e) {
            if (u[e]) return false;
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (n[e]) return false;
            if (a && !a.test(e)) return false;
            return r.has(e) || f[e];
        }
        function p(e) {
            if (c(e)) f[e] = true;
            if (!l(e)) u[e] = true;
        }
        function d(e) {
            if (!l(e)) {
                return e;
            }
            var n = r.get(e);
            if (!n) {
                if (o) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = y(++i);
                } while (!c(n));
                r.set(e, n);
            }
            return n;
        }
        function h(e) {
            if (e instanceof Hn) {
                h(e.expressions.tail_node());
            } else if (e instanceof bt) {
                e.value = d(e.value);
            } else if (e instanceof Jn) {
                h(e.consequent);
                h(e.alternative);
            }
        }
    }
    "use strict";
    var L, V;
    if (typeof Buffer == "undefined") {
        L = atob;
        V = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        L = function(e) {
            return new Buffer(e, "base64").toString();
        };
        V = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        L = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        V = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function W(e, n) {
        var t = n.end.comments_after;
        for (var i = t.length; --i >= 0; ) {
            var r = t[i];
            if (r.type != "comment1") break;
            var a = /^# ([^\s=]+)=(\S+)\s*$/.exec(r.value);
            if (!a) break;
            if (a[1] == "sourceMappingURL") {
                a = /^data:application\/json(;.*?)?;base64,(\S+)$/.exec(a[2]);
                if (!a) break;
                return L(a[2]);
            }
        }
        Ie.warn("inline source map not found: {name}", {
            name: e
        });
    }
    function J(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function G(n, t, e) {
        if (t[n]) {
            e.forEach(function(e) {
                if (t[e]) {
                    if (typeof t[e] != "object") t[e] = {};
                    if (!(n in t[e])) t[e][n] = t[n];
                }
            });
        }
    }
    function X(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new Ne();
        } else if (!(e.props instanceof Ne)) {
            e.props = Ne.fromObject(e.props);
        }
    }
    function ie(e) {
        return {
            props: e.props.toObject()
        };
    }
    function re(i, r) {
        try {
            r = ue(r, {
                compress: {},
                enclose: false,
                ie8: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                validate: false,
                warnings: false,
                webkit: false,
                wrap: false
            }, true);
            if (r.validate) Ie.enable_validation();
            var e = r.timings && {
                start: Date.now()
            };
            if (r.rename === undefined) {
                r.rename = r.compress && r.mangle;
            }
            G("ie8", r, [ "compress", "mangle", "output" ]);
            G("keep_fnames", r, [ "compress", "mangle" ]);
            G("toplevel", r, [ "compress", "mangle" ]);
            G("webkit", r, [ "mangle", "output" ]);
            var n;
            if (r.mangle) {
                r.mangle = ue(r.mangle, {
                    cache: r.nameCache && (r.nameCache.vars || {}),
                    eval: false,
                    ie8: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false,
                    webkit: false
                }, true);
                if (r.mangle.properties) {
                    if (typeof r.mangle.properties != "object") {
                        r.mangle.properties = {};
                    }
                    if (r.mangle.properties.keep_quoted) {
                        n = r.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        r.mangle.properties.reserved = n;
                    }
                    if (r.nameCache && !("cache" in r.mangle.properties)) {
                        r.mangle.properties.cache = r.nameCache.props || {};
                    }
                }
                X(r.mangle.cache);
                X(r.mangle.properties.cache);
            }
            if (r.sourceMap) {
                r.sourceMap = ue(r.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (r.warnings) Ie.log_function(function(e) {
                t.push(e);
            }, r.warnings == "verbose");
            if (e) e.parse = Date.now();
            var a;
            if (i instanceof on) {
                a = i;
            } else {
                if (typeof i == "string") {
                    i = [ i ];
                }
                r.parse = r.parse || {};
                r.parse.toplevel = null;
                var o = r.sourceMap && r.sourceMap.content;
                if (typeof o == "string" && o != "inline") {
                    o = J(o);
                }
                if (o) r.sourceMap.orig = Object.create(null);
                for (var s in i) if (Pe(i, s)) {
                    r.parse.filename = s;
                    r.parse.toplevel = a = qt(i[s], r.parse);
                    if (o == "inline") {
                        var f = W(s, a);
                        if (f) {
                            r.sourceMap.orig[s] = J(f);
                        }
                    } else if (o) {
                        r.sourceMap.orig[s] = o;
                    }
                }
            }
            if (n) {
                z(a, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = r[e];
                if (!n) return;
                var t = a.print_to_string().slice(0, -1);
                a = a[e](n);
                i[a.start.file] = a.print_to_string().replace(t, "");
            });
            if (r.validate) a.validate_ast();
            if (e) e.rename = Date.now();
            if (r.rename) {
                a.figure_out_scope(r.mangle);
                a.expand_names(r.mangle);
            }
            if (e) e.compress = Date.now();
            if (r.compress) {
                a = new Ht(r.compress).compress(a);
                if (r.validate) a.validate_ast();
            }
            if (e) e.scope = Date.now();
            if (r.mangle) a.figure_out_scope(r.mangle);
            if (e) e.mangle = Date.now();
            if (r.mangle) {
                a.compute_char_frequency(r.mangle);
                a.mangle_names(r.mangle);
            }
            if (e) e.properties = Date.now();
            if (r.mangle && r.mangle.properties) Y(a, r.mangle.properties);
            if (e) e.output = Date.now();
            var u = {};
            if (r.output.ast) {
                u.ast = a;
            }
            if (!Pe(r.output, "code") || r.output.code) {
                if (r.sourceMap) {
                    r.output.source_map = O(r.sourceMap);
                    if (r.sourceMap.includeSources) {
                        if (i instanceof on) {
                            throw new Error("original source content unavailable");
                        } else for (var s in i) if (Pe(i, s)) {
                            r.output.source_map.setSourceContent(s, i[s]);
                        }
                    }
                }
                delete r.output.ast;
                delete r.output.code;
                var c = Pt(r.output);
                a.print(c);
                u.code = c.get();
                if (r.sourceMap) {
                    u.map = r.output.source_map.toString();
                    var l = r.sourceMap.url;
                    if (l) {
                        u.code = u.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (l == "inline") {
                            u.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + V(u.map);
                        } else {
                            u.code += "\n//# sourceMappingURL=" + l;
                        }
                    }
                }
            }
            if (r.nameCache && r.mangle) {
                if (r.mangle.cache) r.nameCache.vars = ie(r.mangle.cache);
                if (r.mangle.properties && r.mangle.properties.cache) {
                    r.nameCache.props = ie(r.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                u.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                u.warnings = t;
            }
            return u;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            Ie.log_function();
            Ie.disable_validation();
        }
    }
    h["Dictionary"] = Ne;
    h["List"] = $e;
    h["minify"] = re;
    h["parse"] = qt;
    h["push_uniq"] = Me;
    h["TreeTransformer"] = Ct;
    h["TreeWalker"] = zt;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
